CREATE OR REPLACE
TRIGGER USR_BLOQ_QUANT_ITEMSOLI BEFORE INSERT OR UPDATE OF QTSOLIPROD ON ITEMSOLI
FOR EACH ROW
DECLARE
   V_CDARVPROD VARCHAR2(20);
   V_NMPRODUTO VARCHAR2(50);
   V_GRUPOPER VARCHAR2(2);
   V_IDTIPLAN VARCHAR2(1);
   V_DSREMOTEADDR VARCHAR2(15);
   V_DSREMOTEHOST VARCHAR2(15);
   V_DSSERVERRDM  VARCHAR2(20);
   V_DSSERVMETHOD VARCHAR2(30);
   V_DSREMOTEOPER VARCHAR2(12);
   V_CDPRODUTO    VARCHAR2(10);
   V_NRNECECMPSOL VARCHAR2(10);
   
BEGIN
   WEBTUNNING(V_DSREMOTEADDR,
              V_DSREMOTEHOST,
              V_DSSERVERRDM,
              V_DSSERVMETHOD,
              V_DSREMOTEOPER);
   SELECT MAX(NVL(IDTIPLAN, 'A')), MAX(NVL(NRNECECMPSOL, '0'))
     INTO V_IDTIPLAN, V_NRNECECMPSOL
     FROM SOLICITA
    WHERE CDFILLANCA = NVL(:OLD.CDFILLAN, :NEW.CDFILLAN)
      AND CDFILSOLI  = NVL(:OLD.CDFILSOLI, :NEW.CDFILSOLI)
      AND NRSOLICMP  = NVL(:OLD.NRSOLICMP, :NEW.NRSOLICMP);
   IF V_IDTIPLAN = 'A' THEN
      IF UPDATING THEN
         SELECT MAX(NVL(OPER.CDGRUPOPER,00))
           INTO V_GRUPOPER
           FROM OPERADOR O, OPERGRUPOP OPER
          WHERE OPER.CDOPERADOR  = O.CDOPERADOR
            AND OPER.CDGRUPOPER  = '06'
            AND O.CDOPERADOR = V_DSREMOTEOPER;
         IF V_GRUPOPER = '06' THEN
            SELECT NVL(MAX(CDARVPROD), '0'), NVL(MAX(NMPRODUTO), 'X')
              INTO V_CDARVPROD, V_NMPRODUTO
              FROM PRODUTO
             WHERE CDPRODUTO = NVL(:OLD.CDPRODUTO, :NEW.CDPRODUTO);
            IF NVL(:OLD.QTSOLIPROD, 0) < NVL(:NEW.QTSOLIPROD, 0) THEN
               RAISE_APPLICATION_ERROR(-20501, 'Operao bloqueada! No  possivel alterar a quantidade atual '|| TO_CHAR(:OLD.QTSOLIPROD) ||' para a quantidade posterior ' || TO_CHAR(:NEW.QTSOLIPROD) ||' do item de solicitao '|| V_CDARVPROD || ' ' || V_NMPRODUTO, True);
            END IF;
         END IF;
      ELSE
         SELECT MAX(NVL(OPER.CDGRUPOPER,00))
           INTO V_GRUPOPER
           FROM OPERADOR O, OPERGRUPOP OPER
          WHERE OPER.CDOPERADOR  = O.CDOPERADOR
            AND OPER.CDGRUPOPER  = '06'
            AND O.CDOPERADOR = V_DSREMOTEOPER;
         IF V_GRUPOPER = '06' THEN
            SELECT NVL(MAX(CDARVPROD), '0'), NVL(MAX(NMPRODUTO), 'X')
              INTO V_CDARVPROD, V_NMPRODUTO
              FROM PRODUTO
             WHERE CDPRODUTO = NVL(:OLD.CDPRODUTO, :NEW.CDPRODUTO);
            SELECT NVL(MAX(CDPRODNECCMP), '0')
              INTO V_CDPRODUTO
              FROM TRABNECECOMP
             WHERE CDPRODNECCMP = NVL(:OLD.CDPRODUTO, :NEW.CDPRODUTO)
               AND NRNECECOMP =  V_NRNECECMPSOL
               AND DTENTRNECCMP = NVL(:OLD.DTPROGENTR, :NEW.DTPROGENTR);
             IF V_CDPRODUTO = '0' THEN
                RAISE_APPLICATION_ERROR(-20501, 'Operao bloqueada! No  possivel incluir o produto ' || V_CDARVPROD || ' ' || V_NMPRODUTO, True);
             END IF;
         END IF;
      END IF;
   END IF;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('USR_BLOQ_QUANT_ITEMSOLI','5.50.XXX'); END;
/
