package com.javaseleniumtemplate.pages;

import com.javaseleniumtemplate.bases.PageBase;
import org.openqa.selenium.By;
import org.testng.Assert;

import javax.swing.*;

public class CadastroTipoDePratoPage extends PageBase {

    //Cadastro Tipo de Prato
    By clicaMenu = By.xpath("//*[@type = 'button']");
    By buscaTela = By.xpath("/html/body/span/section/section/div[2]/section[1]/div/aside/div[1]/section/input");
    By clicarTela = By.xpath("/html/body/span/section/section/div[2]/section[1]/div/aside/div[2]/nav/ul/li[3]/span/span[2]");
    By msgEsperada = By.xpath("//div[contains(text(),'Tipo de Prato')]");
    By botaoAdicionar = By.xpath("//li[@data-zh-id='41996933698328914326']");
    By codTipoPrato = By.xpath("//input[@id = 'CDTIPOPRAT']");
    By nmTipoPrato = By.xpath("//input[@id = 'NMTIPOPRAT']");
    By nmReduzTipoPrato = By.xpath("//input[@id = 'NMREDUZIDO']");
    By salvaTipoPrato = By.xpath("//li[@data-zh-id='41996933620751020994332']");
    By msgConfirCadastro = By.xpath("//*[@id='grid-41996933611901253144317']/div[2]/div/div[9]/div[2]");
    By botaoAbrirOpcoesControleTelaInicial = By.xpath("//*[@id='popup']/span/section/section/section/section/div/div[2]/div");
    By botaoPesquisarFiltro = By.xpath("//*[@id='popup']/span/section/section/section/section/div/div[2]/div/div[1]/ul/li[2]");
    By campoProcurar = By.xpath("//*[@id='popup']/span/section/section/section/section/div/div[2]/div/div[1]/ul/li[2]/div/div/div/div[3]/input");


    //Alteração Tipo de Prato
    By btnEditar = By.xpath("//div[@class = 'zh-footer-center']//li[@data-zh-id='41996933612129910994328']");
    By lupaGrupo = By.xpath("//span[@zh-icon = 'no-border search']");
    By idSobreLimpa = By.xpath("//*[@for = 'zh-checkbox-IDSOBRLIMPTP']//div[@class = 'zh-box mousetrap zh-ripple-effect']");
    By sobraLimpa = By.xpath("//div[@data-zh-id='41996933640536505964324']/input");
    By idMedicaoKg = By.xpath("//*[@for = 'zh-checkbox-IDMEDICAOKG']//div[@class = 'zh-box mousetrap zh-ripple-effect']");
    By medicaoKg = By.xpath("//div[@data-zh-id='41996933641014422294325']/input");
    By limpaFiltro = By.xpath("//span[@zh-icon = 'no-border close-x']");
    By clickGrupo = By.xpath("//*[@id='grid-41996933611901253144317']/div[2]/div/div[7]");
    By selecionaGrupo = By.xpath("//*[@id='grid-9000']/div[2]/div/div[1]");
    By salvaEdicao = By.xpath("//li[@data-zh-id='41996933620751020994332']");
    By voltaTela = By.xpath("//li[@data-zh-id='4199693368856806954336']");

    //Eclusão Tipo de Prato
    By btnExcluir = By.xpath("//li[@data-zh-id='41996933614279302634330']");
    By mscConfirmacao = By.xpath("//button[@class = 'zh-alert-button horizontal']//span[contains(text(),'Sim')]");
    By msgAlertOk = By.xpath("//button[@class = 'zh-alert-button']");
    By msgEncontragaCodGrupo = By.xpath("//*[@id='grid-41996933611901253144317']/div[2]/div/div[7]/div[1]");
    By tipoPratoExclusao = By.xpath("//*[@id='grid-41996933611901253144317']/div[2]/div/div[9]");
    By getAlertSucessoPlanejamento = By.xpath("//*[@class='zh-notification-messages']");

    //Campo obrigatorio
    By campoUnidade = By.xpath("//div[@data-zh-id='41996933637617461294318']/div[2]/span");
    By campoServico = By.xpath("//div[@data-zh-id='41996933635637308664319']/div[2]/span");
    By btnCancelar = By.xpath("//li[@data-zh-id='41996933637532612574334']");

    public void clicarMenuPrincipal() {

        tempo();
        click(clicaMenu);
        tempo();
        click(buscaTela);
        clearAndSendKeys(buscaTela,"Tipo de Prato");
        tempo();
        click(clicarTela);
        tempo();
    }

    public String mensagemEsperada(){
        return getText(msgEsperada);
    }

    public void adicionaTipoDePrato(String codigo, String nome, String nomeReduzido, String nmGrupo){
        tempo();
        click(botaoAdicionar);
        tempo();
        click(codTipoPrato);
        tempo();
        if(codigo == "01" ){
            clearAndSendKeys(codTipoPrato,"01");
        }else {
            clearAndSendKeys(codTipoPrato, codigo);
        }
        click(nmTipoPrato);
        clearAndSendKeys(nmTipoPrato,nome);
        click(nmReduzTipoPrato);
        clearAndSendKeys(nmReduzTipoPrato,nomeReduzido);
        tempo();
        click(lupaGrupo);
        tempo();
        preencherCampoProcurarTelaInicial(botaoAbrirOpcoesControleTelaInicial,botaoPesquisarFiltro,campoProcurar,nmGrupo);
        tempo();
        click(selecionaGrupo);
        tempo();
        if (!returnIfElementIsSelected(sobraLimpa)){
            click(idSobreLimpa);
        }
        if (returnIfElementIsSelected(medicaoKg)){
            click(idMedicaoKg);
        }
        tempo();
        click(salvaTipoPrato);
        tempo();
        if(codigo == "01" ){
            tempo();
            click(msgAlertOk);
            tempo();
        }
    }

    public String confirmaCadastro(){
        tempo();
        return getText(msgConfirCadastro);
    }

    public void alteraTipoDePrato(String nmNovo,String cdNovoGrupo, String nmGrupo){
        click(clickGrupo);
        tempo();
        click(btnEditar);
        tempo();
        click(nmTipoPrato);
        tempo();
        clearAndSendKeys(nmTipoPrato,nmNovo);
        tempo();
        click(nmReduzTipoPrato);
        clearAndSendKeys(nmReduzTipoPrato,cdNovoGrupo);
        tempo();
        click(limpaFiltro);
        tempo();
        click(lupaGrupo);
        tempo();
        preencherCampoProcurarTelaInicial(botaoAbrirOpcoesControleTelaInicial,botaoPesquisarFiltro,campoProcurar,nmGrupo);
        click(selecionaGrupo);
        tempo();
        if (returnIfElementIsSelected(sobraLimpa) || !returnIfElementIsSelected(sobraLimpa)){
            click(idSobreLimpa);
        }
        if (returnIfElementIsSelected(medicaoKg) || !returnIfElementIsSelected(medicaoKg)) {
            click(idMedicaoKg);
        }
        tempo();
        click(salvaEdicao);
        tempo();
        click(voltaTela);
        tempo();
    }

    public void excluirTipodePratoRelacionado(){
        click(clickGrupo);
        tempo();
        click(btnExcluir);
        tempo();
        click(mscConfirmacao);
        tempo();
        click(msgAlertOk);
        tempo();
        click(voltaTela);
        tempo();

    }

    public String validarExclusaoRelac(){
        return getText(msgEncontragaCodGrupo);
    }

    public void excluirTipoPrato(){
        tempo();
        click(tipoPratoExclusao);
        tempo();
        click(btnExcluir);
        tempo();
        click(mscConfirmacao);
        tempo();

    }

    public String confirmaExclusao(){
        return getText(getAlertSucessoPlanejamento);
    }

    public void validarCampoObrigatorio(){
        tempo();
        click(botaoAdicionar);
        tempo();
        click(salvaTipoPrato);
        tempo();
        Assert.assertEquals(campoObrigatorioUnidade(),"Campo obrigatório", "Campo Unidade: ");
        Assert.assertEquals(campoObrigatorioServico(),"Campo obrigatório", "Campo Serviço: ");
        click(btnCancelar);
        tempo();
    }

    public String campoObrigatorioUnidade(){
        return getText(campoUnidade);
    }

    public String campoObrigatorioServico(){
        return getText(campoServico);
    }

}
