package com.javaseleniumtemplate.pages;

import com.javaseleniumtemplate.bases.PageBase;
import org.openqa.selenium.By;
import org.openqa.selenium.Keys;
import org.openqa.selenium.interactions.Actions;
import org.testng.Assert;

public class CicloPage extends PageBase {

    By botaoMenu = By.xpath("//div[@class='bars']");
    By campoPesquisar = By.xpath("//section[@class='zh-container-search-menu']//input[@type='text']");
    By selecionarOpcaoCiclo = By.xpath("//section[@class='something-else']//span[text() = 'Ciclo']");

    By botaoAdicionar = By.xpath("//div[@class=\"zh-footer-center\"]//div[@class=\"zh-test-box\"]");
    By botaoEditar = By.xpath("//div[@class=\"zh-footer-center\"]//div[@class=\"zh-test-box\"]");
    By botaoSalvar = By.xpath("//div[@class=\"zh-footer-right\"]");
    By botaoCancelar = By.xpath("//div[@class=\"zh-footer-left\"]");
    By botaoVoltar = By.xpath("//div[@class=\"zh-footer-left\"]");
    By botaoSim = By.xpath("//section[@class=\"zh-container-alert\"]//button[1]");
    By botaoIncluir = By.xpath("//section[@class=\"popup-container\"]//div[@class=\"zh-footer-right\"]");
    By botaoOk = By.xpath("//section[@class=\"zh-container-alert\"]//button[@type=\"submit\"]");
    By botaoExcluir = By.xpath("//div[@class=\"zh-footer-center\"]//div[@class=\"zh-test-box\"]");
    By botaoAbrirOpcoesControleTelaInicial = By.xpath("//div[@data-ng-if=\"widget.isFloatingControlVisible()\"]//div[@data-zh-floating-control]");
    By botaoPesquisarFiltro = By.xpath("//div[@class=\"control-menu\"]//li[@data-zh-id=\"zh-floating-control-custom-action-1\"]");
    By campoProcurar = By.xpath("//li[@class=\"float-action expandable fix-position-bottom opened\"]//input[@placeholder=\"Procurar\"]");

    By campoCodigo = By.id("CDCARDCICLO");
    By campoNome = By.id("NMCARDCICLO");
    By campoNumeroSemanas = By.id("NRSEMCICLO");
    By campoInicioCiclo = By.xpath("//div[@data-zh-id=\"5540835572114801395571\"]//div[@class=\"new-select input-text form-input-margin-bottom mousetrap form-control zh-text-align-{{field.align || 'left'}} ng-pristine ng-untouched ng-valid\"]");
    By inicioCicloQuarta = By.xpath("//div[@data-zh-id=\"5540835572114801395571\"]//ul[@class=\"list zh-new-select-list\"]//li[text() = 'Quarta']");
    By inputCheckBoxAtivo = By.id("zh-checkbox-IDATIVCICLO");
    By checkBoxAtivo = By.xpath("//label[@for=\"zh-checkbox-IDATIVCICLO\"]/div[1]");
    By nomeCicloNaAbaCiclo = By.xpath("//div[@id=\"span-field-NMCARDCICLO\"]//p[@class=\"zh-field-value zh-text-align-left\"]");
    By checkBoxAtivoNaAbaCiclo = By.xpath("//div[@id=\"span-field-IDATIVCICLO\"]//input[@type=\"checkbox\"]");

    By botaoExcluirPrimeiroCiclo = By.xpath("//div[@id=\"grid-5540835572228896548499\"]//div[@class=\"body-content\"]/div[1]//div[@data-zh-field-name=\"__LEFT_ACTIONS\"]//div[@class=\"zh-grid-actions\"]");
    By nomePrimeiroCiclo = By.xpath("//div[@id=\"grid-5540835572228896548499\"]//div[@class=\"body-content\"]/div[1]/div[3]/span");

    By botaoExcluirCicloLinha1 = By.xpath("//div[@id=\"grid-5540835572228896548499\"]//div[@class=\"body-content\"]/div[1]//div[@data-zh-field-name=\"__LEFT_ACTIONS\"]//div[@class=\"zh-grid-actions\"]");
    By codigoCicloLinha1 = By.xpath("//div[@id=\"grid-5540835572228896548499\"]//div[@class=\"body-content\"]/div[1]/div[2]/span");
    By nomeCicloLinha1 = By.xpath("//div[@id=\"grid-5540835572228896548499\"]//div[@class=\"body-content\"]/div[1]/div[3]/span");
    By numeroSemanasCicloLinha1 = By.xpath("//div[@id=\"grid-5540835572228896548499\"]//div[@class=\"body-content\"]/div[1]/div[4]/span");
    By numeroCardapiosCicloLinha1 = By.xpath("//div[@id=\"grid-5540835572228896548499\"]//div[@class=\"body-content\"]/div[1]/div[5]/span");
    By inicioCicloLinha1 = By.xpath("//div[@id=\"grid-5540835572228896548499\"]//div[@class=\"body-content\"]/div[1]/div[6]/span");
    By ativoCicloLinha1 = By.xpath("//div[@id=\"grid-5540835572228896548499\"]//div[@class=\"body-content\"]/div[1]//div[@data-zh-field-name=\"IDATIVCICLO\"]//div[@class=\"grid-checkbox-column\"]/span");

    By padraoCicloVendas = By.xpath("//div[@id=\"grid-5540835572610232968501\"]//div[@data-zh-field-name=\"NMPADCICLO\"]//span[text() = 'VENDAS']");
    By checkBoxPadraoCiclo = By.xpath("//div[@id=\"grid-554083557159926467500\"]//div[@class=\"body-content\"]/div[1]/div[1]//span[@data-ng-if=\"!row.__group\"]");
    By codigoPadraoCiclo = By.xpath("//div[@id=\"grid-554083557159926467500\"]//div[@class=\"body-content\"]/div[1]/div[2]/span");
    By nomePadraoCiclo = By.xpath("//div[@id=\"grid-554083557159926467500\"]//div[@class=\"body-content\"]/div[1]/div[3]/span");
    By tipoPratoArroz = By.xpath("//div[@id=\"grid-5540835574033265492510\"]//div[@class=\"body-content\"]/div[1]/div[1]");
    By tipoPratoSalada = By.xpath("//div[@id=\"grid-5540835574033265492510\"]//div[@class=\"body-content\"]/div[3]/div[1]");

    By botaoExluirPrimTipoPratPadrCiclo = By.xpath("//div[@id=\"grid-5540835573682507379509\"]//div[@class=\"body-content\"]/div[1]/div[1]");
    By tipoPratoPrimPadrCiclo = By.xpath("//div[@id=\"grid-5540835573682507379509\"]//div[@class=\"body-content\"]/div[1]/div[2]/span");
    By complementoPrimTipoPratPadrCiclo = By.xpath("//div[@id=\"grid-5540835573682507379509\"]//div[@class=\"body-content\"]/div[1]/div[3]/span");
    By opcaoPrimTipoPratPadrCiclo = By.xpath("//div[@id=\"grid-5540835573682507379509\"]//div[@class=\"body-content\"]/div[1]//div[@data-zh-field-name=\"IDOPCARDCICLO\"]//div[@class=\"grid-checkbox-column\"]/span");
    By opcaoSegTipoPratoPadrCiclo = By.xpath("//div[@id=\"grid-5540835573682507379509\"]//div[@class=\"body-content\"]/div[2]//div[@data-zh-field-name=\"IDOPCARDCICLO\"]//div[@class=\"grid-checkbox-column\"]/span");

    By tipoPratoSegPadrCiclo = By.xpath("//div[@id=\"grid-5540835573682507379509\"]//div[@class=\"body-content\"]/div[2]/div[2]/span");
    By abaCiclo = By.xpath("//div[@class=\"zh-tab-scroller\"]//a[text() = 'Ciclo']");

    By mensagemSucesso = By.xpath("//*[@class=\"zh-notification-messages\"]//span[@class=\"notification-message-text\"]");
    By mensagemAlerta = By.xpath("//section[@class=\"zh-container-alert\"]//div[@class=\"zh-alert-scroll\"]/p");
    By mensagemObrigatorioCodigo = By.xpath("//div[@data-zh-id=\"5540835572123934878563\"]//div[@class=\"zh-validation\"]/span");
    By mensagemObrigatorioNome = By.xpath("//div[@data-zh-id=\"5540835574060717102567\"]//div[@class=\"zh-validation\"]/span");
    By mensagemNaoHaRegistroPadraoCiclo = By.xpath("//div[@id=\"grid-554083557159926467500\"]//div[@class=\"body-content\"]//p[@class=\"text-center zh-text-search-not-found ng-binding\"]");
    By mensagemNenhumRegistroEncontradoTelaInicial = By.xpath("//div[@id=\"grid-5540835572228896548499\"]//div[@class=\"body-content\"]//p[@class=\"text-center zh-text-search-not-found ng-binding\"]");

    public void acessarTela() {
        tempoParaAguardarTelaInicial();
        waitForElement(botaoMenu);
        click(botaoMenu);
        sendKeys(campoPesquisar, "Ciclo");
        click(selecionarOpcaoCiclo);
    }

    public void adicionarCiclo1() {
        click(botaoAdicionar);
        sendKeys(campoCodigo, "5");
        sendKeys(campoNome, "ENTREGA");
        clearAndSendKeys(campoNumeroSemanas, "3");
        click(campoInicioCiclo);
        clicarCampoSelecionarValor(campoInicioCiclo, inicioCicloQuarta);
        click(botaoSalvar);

        String mensagem = getText(mensagemSucesso);
        String mensagemEsperada = "Salvo com sucesso.";
        Assert.assertEquals(mensagem, mensagemEsperada, "Verificação de mensagem de salvo com sucesso após adicionar um novo ciclo");
        click(botaoVoltar);
    }

    public void verificarCicloAdicionado1() {
        preencherCampoProcurarTelaInicial("00005");
        //valores encontrados
        String encCodigo = getText(codigoCicloLinha1);
        String encNome = getText(nomeCicloLinha1);
        String encNumeroSemanas = getText(numeroSemanasCicloLinha1);
        String encNumeroCardapios = getText(numeroCardapiosCicloLinha1);
        String encInicioCiclo = getText(inicioCicloLinha1);
        boolean encAtivo = driver.findElement(ativoCicloLinha1).getAttribute("className").contains("checked");

        //valores esperados
        String expCodigo = "00005";
        String expNome = "ENTREGA";
        String expNumeroSemanas = "3";
        String expNumeroCardapios = "21";
        String expInicioCiclo = "Quarta";
        boolean expAtivo = true;

        Assert.assertEquals(encCodigo, expCodigo, "Verificação do código do ciclo adicionado");
        Assert.assertEquals(encNome, expNome, "Verificação do nome do ciclo adicionado");
        Assert.assertEquals(encNumeroSemanas, expNumeroSemanas, "Verificação do número de semanas do ciclo adicionado");
        Assert.assertEquals(encNumeroCardapios, expNumeroCardapios, "Verificação do número de cardápios do ciclo adicionado");
        Assert.assertEquals(encInicioCiclo, expInicioCiclo, "Verificação do início do ciclo adicionado");
        Assert.assertEquals(encAtivo, expAtivo, "Verificação se o ciclo adicionado está ativo ou não");
    }

    public void excluirCicloAdicionado1() {
        preencherCampoProcurarTelaInicial("00005");
        click(botaoExcluirCicloLinha1);

        String mensagem = getText(mensagemAlerta);
        String mensagemEsperada = "Deletar o(s) registro(s)?";
        Assert.assertEquals(mensagem, mensagemEsperada, "Verificação da mensagem exibida na tela após click no botão excluir");
        click(botaoSim);

        mensagem = getText(mensagemSucesso);
        mensagemEsperada = "Excluído com sucesso.";
        Assert.assertEquals(mensagem, mensagemEsperada, "Verificação da mensagem de sucesso, após excluir o padrão de ciclo");

        mensagem = getText(mensagemNenhumRegistroEncontradoTelaInicial);
        mensagemEsperada = "Nenhum registro foi encontrado";
        Assert.assertEquals(mensagem, mensagemEsperada, "Verificar a mensagem de nenhum registro encontrado, após a exclusão do ciclo adicionado");
    }

    public void editarNomeAtivoCiclo1() {
        preencherCampoProcurarTelaInicial("00003");
        alterarNomeCiclo("ENTREGA RÁPIDA");
        click(ativoCicloLinha1);
        click(botaoSalvar);

        String mensagem = getText(mensagemSucesso);
        String mensagemEsperada = "Salvo com sucesso.";
        Assert.assertEquals(mensagem, mensagemEsperada, "Verificação da mensagem de sucesso apresentada após alterar o nome de um padrão de ciclo.");

        tempo();
        String encNome = getText(nomeCicloLinha1);
        boolean encAtivo = driver.findElement(ativoCicloLinha1).getAttribute("className").contains("checked");
        String expNome = "ENTREGA RÁPIDA";
        boolean expAtivo = false;
        Assert.assertEquals(encNome, expNome, "Verificação do nome, no ciclo após a edição");
        Assert.assertEquals(encAtivo, expAtivo, "Verificação satus do ativo, no ciclo após a edição");

        alterarNomeCiclo("PREPARO");
        click(ativoCicloLinha1);
        click(botaoSalvar);

        tempo();
        encNome = getText(nomeCicloLinha1);
        encAtivo = driver.findElement(ativoCicloLinha1).getAttribute("className").contains("checked");
        expNome = "PREPARO";
        expAtivo = true;
        Assert.assertEquals(encNome, expNome, "Verificação do nome, no ciclo após a edição para retornar ao nome que estava no início do teste");
        Assert.assertEquals(encAtivo, expAtivo, "Verificação satus do ativo, no ciclo após a edição para deixar o ciclo ativo, como estava no início do teste");
    }

    public void edtarAcessandoCiclo() {
        preencherCampoProcurarTelaInicial("00003");
        click(codigoCicloLinha1);
        click(abaCiclo);
        tempo();
        click(botaoEditar);
        clearAndSendKeys(campoNome, "DEPOSITO LOCAL");
        click(checkBoxAtivo);
        click(botaoSalvar);

        String mensagem = getText(mensagemSucesso);
        String mensagemEsperada = "Salvo com sucesso.";
        Assert.assertEquals(mensagem, mensagemEsperada, "Verificação da mensagem de salvo com sucesso exibida no canto da tela após editar o ciclo");

        click(abaCiclo);
        String encNome = getText(nomeCicloNaAbaCiclo);
        boolean encAtivo = returnIfElementIsSelected(checkBoxAtivoNaAbaCiclo);
        String expNome = "DEPOSITO LOCAL";
        boolean expAtivo = false;
        Assert.assertEquals(encNome, expNome, "Verificação do nome do ciclo após a edição");
        Assert.assertEquals(encAtivo, expAtivo, "Verificação se o ciclo está ativo após a edição");

        click(botaoEditar);
        clearAndSendKeys(campoNome, "DEPOSITO");
        click(checkBoxAtivo);
        click(botaoSalvar);
        tempo();
        click(abaCiclo);

        encNome = getText(nomeCicloNaAbaCiclo);
        encAtivo = returnIfElementIsSelected(checkBoxAtivoNaAbaCiclo);
        expNome = "DEPOSITO";
        expAtivo = true;
        Assert.assertEquals(encNome, expNome, "Verificar se o nome do ciclo está com o mesmo nome do início do teste");
        Assert.assertEquals(encAtivo, expAtivo, "Verificar se o ativo, está selecionado, da mesma forma que estava no início do teste");
    }

    public void adicionarPadraoCiclo1() {
        preencherCampoProcurarTelaInicial("00003");
        click(codigoCicloLinha1);
        tempo();
        click(botaoAdicionar);
        tempo();
        click(padraoCicloVendas);
        click(tipoPratoArroz);
        click(tipoPratoSalada);
        click(botaoIncluir);

        String mensagem = getText(mensagemSucesso);
        String mensagemEsperada = "Registro adicionado com sucesso!";
        Assert.assertEquals(mensagem, mensagemEsperada, "Verificação da mensagem de sucesso apresentada após adicionar um padrão de ciclo.");
        tempo();
    }

    public void verificarPadraoCicloAdd1() {
        //valores encontrados
        String encNomePrimTipoPrato = getText(tipoPratoPrimPadrCiclo);
        String encNomeSegTipoPrato = getText(tipoPratoSegPadrCiclo);
        boolean encOpcaoPrimeiroTipoPrato = driver.findElement(opcaoPrimTipoPratPadrCiclo).getAttribute("className").contains("checked");
        boolean encOpcaoSegundoTipoPrato = driver.findElement(opcaoSegTipoPratoPadrCiclo).getAttribute("className").contains("checked");

        //valores esperados
        String expNomePrimTipoPrato = "ARROZ";
        String expNomeSegTipoPrato = "SALADA";
        boolean expOpcaoPrimTipoPrato = false;
        boolean expOpcaoSegTipoPrato = false;

        Assert.assertEquals(encNomePrimTipoPrato, expNomePrimTipoPrato, "Verificação do nome do primeiro tipo prato, adicionado no padrão ciclo");
        Assert.assertEquals(encOpcaoPrimeiroTipoPrato, expOpcaoPrimTipoPrato, "Verificação da opção do primeiro tipo prato, adicionado no padrão ciclo");
        Assert.assertEquals(encNomeSegTipoPrato, expNomeSegTipoPrato, "Verificação do nome do segundo tipo prato, adicionado no padrão ciclo");
        Assert.assertEquals(encOpcaoSegundoTipoPrato, expOpcaoSegTipoPrato, "Verificação da opção do segundo tipo prato, adicionado no padrão ciclo");

        click(botaoVoltar);

        //valores encontrados
        String encCodigoPadraoCiclo = getText(codigoPadraoCiclo);
        String encNomePadraoCiclo = getText(nomePadraoCiclo);

        //valores esperados
        String expCodigoPadraoCiclo = "00001";
        String expNomePadraoCiclo = "VENDAS";

        Assert.assertEquals(encCodigoPadraoCiclo, expCodigoPadraoCiclo, "Verificação do código do padrão ciclo adicionado");
        Assert.assertEquals(encNomePadraoCiclo, expNomePadraoCiclo, "Verificação do nome do padrão ciclo adicionado");
    }

    public void excluirTipoPratoPadraoCiclo1() {
        click(codigoPadraoCiclo);

        for (int quant = 1; quant <= 2; quant ++) {
            click(botaoExluirPrimTipoPratPadrCiclo);
            String mensagem = getText(mensagemAlerta);
            String mensagemEsperada = "Deletar o registro?";
            Assert.assertEquals(mensagem, mensagemEsperada, "Verificação da mensagem exibida na tela para excluir um tipo de prato do padrão de ciclo");
            click(botaoSim);
            tempo();
        }

        String mensagem = getText(mensagemNaoHaRegistroPadraoCiclo);
        String mensagemEsperada = "Não há registros";
        Assert.assertEquals(mensagem, mensagemEsperada, "Verificação da mensagem de não há registros, exibida na aba padrão de ciclo, após excluir os 2 tipos de prato que haviam sido adicionados");
    }

    public void tentarExcluirCicloComRegFilho1() {
        preencherCampoProcurarTelaInicial("00001");
        click(botaoExcluirPrimeiroCiclo);

        String mensagem = getText(mensagemAlerta);
        String mensagemEsperada = "Deletar o(s) registro(s)?";
        Assert.assertEquals(mensagem, mensagemEsperada, "Verificação da mensagem exibida na tela após click no botão para excluir o tipo de prato do padrão ciclo");
        click(botaoSim);

        mensagem = getText(mensagemAlerta);
        mensagemEsperada = "Exclusão não permitida! O registro possui registros filhos.";
        Assert.assertEquals(mensagem, mensagemEsperada, "Verificação da mensagem exibida na tela após tentar excluir um ciclo que possui registro filho");
        click(botaoOk);

        String nomeCiclo = getText(nomePrimeiroCiclo);
        String nomeEsperado = "RETIRADA";
        Assert.assertEquals(nomeCiclo, nomeEsperado, "Verificação se o ciclo que possui registro filho não foi excluído");
    }

    public void tentarExcluirPadraoCicloComRegFilho1() {
        preencherCampoProcurarTelaInicial("00002");
        click(codigoCicloLinha1);
        click(checkBoxPadraoCiclo);
        click(botaoExcluir);

        String mensagem = getText(mensagemAlerta);
        String mensagemEsperada = "Deletar o(s) registro(s)?";
        Assert.assertEquals(mensagem, mensagemEsperada, "Verificação da mensagem exibida na tela após click no botão para excluir o tipo de prato do padrão ciclo");
        click(botaoSim);

        mensagem = getText(mensagemAlerta);
        mensagemEsperada = "Exclusão não permitida! O registro possui registros filhos.";
        Assert.assertEquals(mensagem, mensagemEsperada, "Verificação da mensagem exibida na tela após tentar excluir um ciclo que possui registro filho");
        click(botaoOk);
        click(checkBoxPadraoCiclo);

        String encNomePadraoCiclo = getText(nomePadraoCiclo);
        String expNomePadraoCiclo = "COMPRAS";
        Assert.assertEquals(encNomePadraoCiclo, expNomePadraoCiclo, "Verificação se o padrão ciclo não foi excluir após a tentativa de excluir com registros filhos");
    }

    public void editarConfiguracaoPadraoCiclo() {
        preencherCampoProcurarTelaInicial("00004");
        click(codigoCicloLinha1);
        click(codigoPadraoCiclo);
        alterarComplementoTipoPratoPadraoCiclo("Colorido");
        click(opcaoPrimTipoPratPadrCiclo);
        click(botaoSalvar);
        tempo();

        String encComplementoPrimTipoPrato = getText(complementoPrimTipoPratPadrCiclo);
        boolean encOpcaoPrimTipoPrato = driver.findElement(opcaoPrimTipoPratPadrCiclo).getAttribute("className").contains("checked");

        String expComplementoPrimTipoPrato = "Colorido";
        boolean expOpcaoPrimTipoPrato = true;
        Assert.assertEquals(encComplementoPrimTipoPrato, expComplementoPrimTipoPrato, "Verificação do complemento do primeiro tipo de prato após a edição");
        Assert.assertEquals(encOpcaoPrimTipoPrato, expOpcaoPrimTipoPrato, "Verificação da opção do primeiro tipo de prato após a edição");

        alterarComplementoTipoPratoPadraoCiclo("");
        click(opcaoPrimTipoPratPadrCiclo);
        click(botaoSalvar);
        tempo();

        encComplementoPrimTipoPrato = getText(complementoPrimTipoPratPadrCiclo);
        encOpcaoPrimTipoPrato = driver.findElement(opcaoPrimTipoPratPadrCiclo).getAttribute("className").contains("checked");
        expComplementoPrimTipoPrato = "";
        expOpcaoPrimTipoPrato = false;
        Assert.assertEquals(encComplementoPrimTipoPrato, expComplementoPrimTipoPrato, "Verificação se o complemento do primeiro tipo de prato voltou para o valor que estava no início da edição");
        Assert.assertEquals(encOpcaoPrimTipoPrato, expOpcaoPrimTipoPrato, "Verificação se o valor da opção do primeiro tipo de prato voltou para o valor que estava no início da edição");
    }

    public void tentarAddCicloCodigoRepetido() {
        click(botaoAdicionar);
        sendKeys(campoCodigo, "1");
        sendKeys(campoNome, "PREPARO");
        click(botaoSalvar);

        String mensagem = getText(mensagemAlerta);
        String mensagemEsperada = "Impossível adicionar. Registro já existe.";
        Assert.assertEquals(mensagem, mensagemEsperada, "Verificação da mensagem exibida na tela, após tentar adicionar um ciclo com código existente");
        click(botaoOk);
        click(botaoCancelar);
    }

    public void campoObrigatoriosFormAddCiclo1() {
        tempo();
        click(botaoAdicionar);
        tempo();
        click(botaoSalvar);

        String codigo = getText(mensagemObrigatorioCodigo);
        String nome = getText(mensagemObrigatorioNome);

        String mensagemEsperada = "Campo obrigatório";
        Assert.assertEquals(codigo, mensagemEsperada, "Verificação mensagem de campo obrigatório no campo código");
        Assert.assertEquals(nome, mensagemEsperada, "Verificação mensagem de campo obrigatório no campo nome");
        click(botaoCancelar);
    }

    private void alterarNomeCiclo(String nomeCiclo) {
        Actions actions = new Actions(driver);
        actions.click(driver.findElement(nomeCicloLinha1)).build().perform();
        tempo();
        actions.sendKeys(Keys.BACK_SPACE).build().perform();
        tempo();
        actions.sendKeys(nomeCiclo).build().perform();
        tempo();
        actions.sendKeys(Keys.ENTER).build().perform();
        tempo();
    }

    private void alterarComplementoTipoPratoPadraoCiclo(String complemento) {
        tempo();
        tempo();
        Actions actions = new Actions(driver);
        actions.click(driver.findElement(complementoPrimTipoPratPadrCiclo)).build().perform();
        tempo();
        actions.sendKeys(Keys.BACK_SPACE).build().perform();
        tempo();
        actions.sendKeys(complemento).build().perform();
        tempo();
        actions.sendKeys(Keys.ENTER).build().perform();
        tempo();
    }

    private void preencherCampoProcurarTelaInicial(String texto) {
        tempo();
        tempo();
        tempo();
        tempo();
        tempo();
        tempo();
        if (returnClassOpened(botaoAbrirOpcoesControleTelaInicial) && !returnClassOpened(botaoPesquisarFiltro)) {
            click(botaoPesquisarFiltro);
        } else if (!returnClassOpened(botaoAbrirOpcoesControleTelaInicial)){
            click(botaoAbrirOpcoesControleTelaInicial);
            click(botaoPesquisarFiltro);
        }
        clearAndSendKeys(campoProcurar, texto);
        tempo();
    }

    private boolean returnClassOpened(By locator) {
        return driver.findElement(locator).getAttribute("className").contains("opened");
    }

}
