package com.javaseleniumtemplate.pages;

import com.javaseleniumtemplate.bases.PageBase;
import org.openqa.selenium.By;
import org.openqa.selenium.WebElement;
import org.openqa.selenium.support.ui.ExpectedConditions;
import org.openqa.selenium.support.ui.WebDriverWait;
import org.testng.Assert;

import java.util.ArrayList;
import java.util.List;

public class DietaPadraoPage extends PageBase {

    By botaoMenu = By.xpath("//div[@class='bars']");
    By campoPesquisar = By.xpath("//section[@class='zh-container-search-menu']//input[@type='text']");
    By opcaoTelaDietaPadrao = By.xpath("//span[text() = 'Dieta Padrão']");

    By botaoAdicionar = By.xpath("//div[@class=\"zh-footer-center\"]//div[@class=\"zh-test-box\"]");
    By botaoSalvar = By.xpath("//div[@class=\"zh-footer-right\"]");
    By botaoEditar = By.xpath("//div[@class=\"zh-footer-center\"]/ul/li[1]");
    By botaoExcluir = By.xpath("//div[@class=\"zh-footer-center\"]/ul/li[2]");
    By botaoVoltar = By.xpath("//div[@class=\"zh-footer-left\"]");
    By botaoCancelar = By.xpath("//div[@class=\"zh-footer-left\"]");
    By botaoSim = By.xpath("//section[@class=\"zh-container-alert\"]//button[@data-zh-id=\"zh-footer-alert-button-0\"]");
    By botaoOkAlerta = By.xpath("//section[@class=\"zh-container-alert\"]//button");
    By botaoDeOpcoesDaTela = By.xpath("//div[@data-ng-if=\"widget.isFloatingControlVisible()\"]//div[@data-zh-floating-control]");
    By botaoPesquisar = By.xpath("//div[@class=\"control-menu\"]//li[@data-zh-id=\"zh-floating-control-custom-action-1\"]");
    By campoProcurarTelaInicial = By.xpath("//li[@class=\"float-action expandable fix-position-bottom opened\"]//input");

    By checkBoxCardapio = By.xpath("//label[@for=\"zh-checkbox-IDTIPODIET\"]//div[@class=\"zh-box mousetrap zh-ripple-effect\"]");
    By checkBoxAtiva = By.xpath("//label[@for=\"zh-checkbox-IDDIETAATIVA\"]//div[@class=\"zh-box mousetrap zh-ripple-effect\"]");
    By inputCardapio = By.id("zh-checkbox-IDTIPODIET");
    By inputAtiva = By.id("zh-checkbox-IDDIETAATIVA");

    By campoDietaPadrao = By.id("CDDIETPAD");
    By campoNomeDietaPadrao = By.id("DSDIETPAD");
    By campoGrupo = By.id("CDDIETGRUP");
    By grupoFitness = By.xpath("//div[@data-zh-id=\"10753491612068963158655\"]//span[text() = '0001 | FITNESS']");
    By campoDescricaoComplementar = By.id("DSCOMPDIETP");

    By telaIniCodigoDietaPadrao1 = By.xpath("//div[@id=\"grid-10753491613287349645650\"]//div[@class=\"body-content\"]/div[1]//div[@data-zh-field-name=\"CDDIETPAD\"]/span");
    By telaIniNomeDietaPadrao1 = By.xpath("//div[@id=\"grid-10753491613287349645650\"]//div[@class=\"body-content\"]/div[1]//div[@data-zh-field-name=\"DSDIETPAD\"]/span");
    By telaIniEspecificacao1 = By.xpath("//div[@id=\"grid-10753491613287349645650\"]//div[@class=\"body-content\"]/div[1]//div[@data-zh-field-name=\"IDFORMDIET\"]/span");
    By telaIniGrupo1 = By.xpath("//div[@id=\"grid-10753491613287349645650\"]//div[@class=\"body-content\"]/div[1]//div[@data-zh-field-name=\"CDDIETGRUP\"]/span");
    By telaIniCardapio1 = By.xpath("//div[@id=\"grid-10753491613287349645650\"]//div[@class=\"body-content\"]/div[1]//div[@data-zh-field-name=\"IDTIPODIET\"]/span");
    By telaIniDescricao1 = By.xpath("//div[@id=\"grid-10753491613287349645650\"]//div[@class=\"body-content\"]/div[1]//div[@data-zh-field-name=\"DSCOMPDIETP\"]/span");
    By telaIniAtiva1 = By.xpath("//div[@id=\"grid-10753491613287349645650\"]//div[@class=\"body-content\"]/div[1]//div[@data-zh-field-name=\"IDDIETAATIVA\"]/span");

    By listaEspecificacoes = By.xpath("//div[@data-zh-id=\"1075349161192792862654\"]//ul[@class=\"list zh-new-select-list\"]/li");
    By campoEspecificacao = By.xpath("//div[@data-zh-id=\"1075349161192792862654\"]//div[@class=\"new-select input-text form-input-margin-bottom mousetrap form-control zh-text-align-{{field.align || 'left'}} ng-pristine ng-untouched ng-valid\"]");
    By valorCampoEspecificacao = By.xpath("//div[@data-zh-id=\"1075349161192792862654\"]//div[@class=\"new-select input-text form-input-margin-bottom mousetrap form-control zh-text-align-{{field.align || 'left'}} ng-pristine ng-untouched ng-valid\"]/span");
    By especificacaoNormal = By.xpath("//div[@data-zh-id=\"1075349161192792862654\"]//ul[@class=\"list zh-new-select-list\"]//li[text() = 'Normal']");
    By especificacaoDietaEspecial = By.xpath("//div[@data-zh-id=\"1075349161192792862654\"]//ul[@class=\"list zh-new-select-list\"]//li[text() = 'Dieta Especial']");

    By campoObrigatorioCodigoDietaPadrao = By.xpath("//div[@data-zh-id=\"10753491611189102648651\"]//div[@class=\"zh-validation\"]/span");
    By campoObrigatorioNomeDietaPadrao = By.xpath("//div[@data-zh-id=\"10753491611084829418653\"]//div[@class=\"zh-validation\"]/span");
    By campoObrigatorioEspecificacao = By.xpath("//div[@data-zh-id=\"1075349161192792862654\"]//div[@class=\"zh-validation\"]/span");

    By mensagemAlerta = By.xpath("//section[@class=\"zh-container-alert\"]//p[@class=\"zh-text-alert\"]");
    By mensagemCantoSuperiorDireito = By.xpath("//*[@class=\"zh-notification-messages\"]//span[@class=\"notification-message-text\"]");

    public void acessarTela() {
        tempoParaAguardarTelaInicial();
        waitForElement(botaoMenu);
        click(botaoMenu);
        sendKeys(campoPesquisar, "Dieta Padrão");
        click(opcaoTelaDietaPadrao);
    }

    public void adicionarDieta() {
        tempo();
        tempo();
        tempo();
        click(botaoAdicionar);
        sendKeys(campoDietaPadrao, "5");
        sendKeys(campoNomeDietaPadrao, "SAUDÁVEL");
        clicarCampoSelecionarValor(campoEspecificacao, especificacaoNormal);
        clicarCampoSelecionarValor(campoGrupo, grupoFitness);
        sendKeys(campoDescricaoComplementar, "Descrição de teste automatizado");
        click(botaoSalvar);
    }

    public void verificarDietaAdicionada() {
        preencherCampoProcurarTelaInicial("0005");
        tempo();
        //valores esperados na tela inicial
        String expCodigoDietaPadrao = "0005";
        String expNomeDietaPadrao = "SAUDÁVEL";
        String expEspecificacao = "Normal";
        String expGrupo = "0001";
        String expCardapio = "Não";
        String expDescricao = "Descrição de teste automatizado";
        String expAtiva = "Não";

        //valores encontrados na tela inicial
        String encCodigoDietaPadrao = getText(telaIniCodigoDietaPadrao1);
        String encNomeDietaPadrao = getText(telaIniNomeDietaPadrao1);
        String encEspecificacao = getText(telaIniEspecificacao1);
        String encGrupo = getText(telaIniGrupo1);
        String encCardapio = getText(telaIniCardapio1);
        String encDescricao = getText(telaIniDescricao1);
        String encAtiva = getText(telaIniAtiva1);

        Assert.assertEquals(encCodigoDietaPadrao, expCodigoDietaPadrao, "Verificar na tela inicial, o 'código' da dieta padrão adicionada");
        Assert.assertEquals(encNomeDietaPadrao, expNomeDietaPadrao, "Verificar na tela inicial, o 'nome' da dieta padrão adicionada");
        Assert.assertEquals(encEspecificacao, expEspecificacao, "Verificar na tela inicial, a 'especificação' da dieta padrão adicionada");
        Assert.assertEquals(encGrupo, expGrupo, "Verificar na tela inicial, o 'grupo' da dieta padrão adicionada");
        Assert.assertEquals(encCardapio, expCardapio, "Verificar na tela inicial, o 'cardápio' da dieta padrão adicionada");
        Assert.assertEquals(encDescricao, expDescricao, "Verificar na tela inicial, a 'descrição' da dieta padrão adicionada");
        Assert.assertEquals(encAtiva, expAtiva, "Verificar na tela inicial, a 'ativa' da dieta padrão adicionada");

        tempo();
        click(telaIniNomeDietaPadrao1);
        tempo();
        click(botaoEditar);
        tempo();

        //valores esperados na tela após acessar a dieta
        expCodigoDietaPadrao = "0005";
        expNomeDietaPadrao = "SAUDÁVEL";
        expEspecificacao = "Normal";
        expGrupo = "0001";
        expDescricao = "Descrição de teste automatizado";

        //valores encontrados na tela após acessar a dieta
        encCodigoDietaPadrao = driver.findElement(campoDietaPadrao).getAttribute("value");
        encNomeDietaPadrao = driver.findElement(campoNomeDietaPadrao).getAttribute("value");
        encEspecificacao = getText(valorCampoEspecificacao);
        encGrupo = getText(campoGrupo);
        encDescricao = driver.findElement(campoDescricaoComplementar).getAttribute("value");

        Assert.assertEquals(encCodigoDietaPadrao, expCodigoDietaPadrao, "Verificação do 'código' da dieta padrão adicionada no início do teste");
        Assert.assertEquals(encNomeDietaPadrao, expNomeDietaPadrao, "Verificação do 'nome' da dieta padrão adicionada no início do teste");
        Assert.assertEquals(encEspecificacao, expEspecificacao, "Verificação da 'especificação' da dieta padrão adicionada no início do teste");
        Assert.assertEquals(encGrupo, expGrupo, "Verificação do 'grupo' da dieta padrão adicionada no início do teste");
        Assert.assertEquals(encDescricao, expDescricao, "Verificação da 'descrição complementar' da dieta padrão adicionada no início do teste");
        click(botaoCancelar);
        tempo();
        click(botaoVoltar);
    }

    public void editarDieta() {
        preencherCampoProcurarTelaInicial("0004");
        click(telaIniNomeDietaPadrao1);
        tempo();
        click(botaoEditar);
        tempo();

        boolean encCampoDietaPadrao = returnIfElementIsEnabled(campoDietaPadrao);
        boolean expCampoDietaPadrao = false;
        Assert.assertEquals(encCampoDietaPadrao, expCampoDietaPadrao, "Verificar se no momento da edição o campo 'dieta padrão' está desabilitado");

        clearAndSendKeys(campoNomeDietaPadrao, "FRUTAS");
        verificarListaDeEspecificacao();
        click(especificacaoDietaEspecial);
        clearAndSendKeys(campoDescricaoComplementar, "Descrição alterada");

        boolean cardapio = returnIfElementIsSelected(inputCardapio);
        boolean ativa = returnIfElementIsSelected(inputAtiva);
        Assert.assertEquals(cardapio, false, "Verificar se o check-box de cardápio, por padrão vem desmarcado");
        Assert.assertEquals(ativa, false, "Verificar se o check-box de ativa, por padrão vem desmarcado");

        click(checkBoxCardapio);
        click(checkBoxAtiva);
        cardapio = returnIfElementIsSelected(inputCardapio);
        ativa = returnIfElementIsSelected(inputAtiva);
        Assert.assertEquals(cardapio, true, "Verificar se após clicar no check-box de cardápio o mesmo fica selecionado");
        Assert.assertEquals(ativa, true, "Verificar se após clicar no check-box de ativa o mesmo fica selecionado");
        click(botaoSalvar);
        verificarMensagemSalvoSucessoNoCantoSuperiorDireito();
        click(botaoVoltar);
    }

    public void verificarDietaEditada() {
        preencherCampoProcurarTelaInicial("0004");
        //valores esperados
        String expNome = "FRUTAS";
        String expEspecificacao = "Dieta Especial";
        String expDescricao = "Descrição alterada";
        String expCardapio = "Sim";
        String expAtiva = "Sim";

        //valores encontrados
        String encNome = getText(telaIniNomeDietaPadrao1);
        String encEspecificacao = getText(telaIniEspecificacao1);
        String encDescricao = getText(telaIniDescricao1);
        String encCardapio = getText(telaIniCardapio1);
        String encAtiva = getText(telaIniAtiva1);

        Assert.assertEquals(encNome, expNome, "Verificar valor do 'nome' na tela inicial após a edição da dieta padrão");
        Assert.assertEquals(encEspecificacao, expEspecificacao, "Verificar valor da 'especificação' na tela inicial após a edição da dieta padrão");
        Assert.assertEquals(encDescricao, expDescricao, "Verificar valor da 'descrição' na tela inicial após a edição da dieta padrão");
        Assert.assertEquals(encCardapio, expCardapio, "Verificar valor do 'cardápio' na tela inicial após a edição da dieta padrão");
        Assert.assertEquals(encAtiva, expAtiva, "Verificar valor da 'ativa' na tela inicial após a edição da dieta padrão");
    }

    public void desfaserEdicaoDaDietaPadrao() {
        tempo();
        click(telaIniNomeDietaPadrao1);
        click(botaoEditar);
        clearAndSendKeys(campoNomeDietaPadrao, "PASTOSA");
        clicarCampoSelecionarValor(campoEspecificacao, especificacaoNormal);
        clear(campoDescricaoComplementar);
        click(checkBoxCardapio);
        click(checkBoxAtiva);
        click(botaoSalvar);
        verificarMensagemSalvoSucessoNoCantoSuperiorDireito();
        click(botaoVoltar);
    }

    public void excluirDieta() {
        preencherCampoProcurarTelaInicial("0005");
        tempo();
        click(telaIniNomeDietaPadrao1);
        click(botaoExcluir);

        String mensagem = getText(mensagemAlerta);
        String mensagemEsperada = "Deseja excluir o registro?";
        Assert.assertEquals(mensagem, mensagemEsperada, "Verificar mensagem de alerta exibida na tela após clicar para excluir uma dieta padrão");
        click(botaoSim);

        mensagem = getText(mensagemAlerta);
        mensagemEsperada = "Deletado com sucesso!";
        Assert.assertEquals(mensagem, mensagemEsperada, "Verificar mensagem  exibida na tela informando que o registro foi deletado com sucesso");
        click(botaoOkAlerta);
    }

    public void tentarExcluirDietaNaoPermitida() {
        preencherCampoProcurarTelaInicial("0001");
        click(telaIniCodigoDietaPadrao1);
        click(botaoExcluir);

        String mensagem = getText(mensagemAlerta);
        String mensagemEsperada = "Deseja excluir o registro?";
        Assert.assertEquals(mensagem, mensagemEsperada, "Verificar mensagem exibida na tela após clicar para excluir a dieta padrão");
        click(botaoSim);

        mensagem = getText(mensagemAlerta);
        mensagemEsperada = "Exclusão não permitida! O registro possui registros filhos.";
        Assert.assertEquals(mensagem, mensagemEsperada, "Verificar mensagem exibida na tela após tentar excluir uma dieta que possui registros filhos");
        click(botaoOkAlerta);
        click(botaoVoltar);
    }

    private void verificarListaDeEspecificacao() {
        click(campoEspecificacao);
        List<String> especificacoes = new ArrayList<>();
        especificacoes.add("Normal");
        especificacoes.add("Lactario");
        especificacoes.add("Enteral/Parenteral");
        especificacoes.add("Room Service");
        especificacoes.add("Dieta Especial");

        long timeout = 0;
        List<WebElement> result = (new WebDriverWait(driver, timeout))
                .until(ExpectedConditions
                        .visibilityOfAllElementsLocatedBy(
                                listaEspecificacoes
                        )
                );

        for (int index = 0; index < result.size(); index ++) {
            Assert.assertEquals(result.get(index).getText(), especificacoes.get(index), "Verificação do item " + (index + 1) + " da lista de especificações");
        }
    }

    private void verificarMensagemSalvoSucessoNoCantoSuperiorDireito() {
        String mensagemExcluidoSucesso = getText(mensagemCantoSuperiorDireito);
        Assert.assertEquals(mensagemExcluidoSucesso, "Salvo com sucesso.", "Verificação da mensagem de excluído om sucesso, após a exclusão do grupo");
    }

    public void tentarAddRegistroComCodigoExistente() {
        tempo();
        tempo();
        tempo();
        click(botaoAdicionar);
        sendKeys(campoDietaPadrao, "1");
        sendKeys(campoNomeDietaPadrao, "VEGANA");
        clicarCampoSelecionarValor(campoEspecificacao, especificacaoNormal);
        click(botaoSalvar);

        String mensagem = getText(mensagemAlerta);
        String mensagemEsperada = "Impossível adicionar. Registro já existe.";
        Assert.assertEquals(mensagem, mensagemEsperada, "Verificar mensagem exibida na tela após sentar adicionar uma dieta com o código do grupo já cadastrado");
        click(botaoOkAlerta);
        tempo();
        click(botaoCancelar);
    }

    public void cardapioNaoPodeSerDesmarcado() {
        preencherCampoProcurarTelaInicial("0002");
        click(telaIniNomeDietaPadrao1);
        click(botaoEditar);
        click(checkBoxCardapio);
        click(botaoSalvar);

        String mensagem = getText(mensagemAlerta);
        String mensagemEsperada = "Cardápio não pode ser desmarcado, há cardápio cadastrado com a Dieta Padrão informada.";
        Assert.assertEquals(mensagem, mensagemEsperada, "Verificar mensagem exibida na tela informando que o cardápio não pode ser desmarcado");
        click(botaoOkAlerta);
        tempo();
        click(botaoCancelar);
    }

    public void camposObrigatorios() {
        tempo();
        click(botaoAdicionar);
        tempo();
        click(botaoSalvar);

        String codigo = getText(campoObrigatorioCodigoDietaPadrao);
        String nome = getText(campoObrigatorioNomeDietaPadrao);
        String especificacao = getText(campoObrigatorioEspecificacao);
        String mensagemEsperada = "Campo obrigatório";

        Assert.assertEquals(codigo, mensagemEsperada, "Verificação da mensagem de campo obrigatório no campo 'dieta padrão'");
        Assert.assertEquals(nome, mensagemEsperada, "Verificação da mensagem de campo obrigatório no campo 'nome da dieta padrão'");
        Assert.assertEquals(especificacao, mensagemEsperada, "Verificação da mensagem de campo obrigatório no campo 'especificação'");
        click(botaoCancelar);
    }

    private void preencherCampoProcurarTelaInicial(String texto) {
        tempo();
        tempo();
        tempo();
        tempo();
        tempo();
        if (returnClassOpened(botaoDeOpcoesDaTela) && !returnClassOpened(botaoPesquisar)) {
            click(botaoPesquisar);
        } else if (!returnClassOpened(botaoDeOpcoesDaTela)){
            click(botaoDeOpcoesDaTela);
            click(botaoPesquisar);
        }
        clearAndSendKeys(campoProcurarTelaInicial, texto);
        tempo();
    }

    private boolean returnClassOpened(By locator) {
        return driver.findElement(locator).getAttribute("className").contains("opened");
    }

}
