package com.javaseleniumtemplate.pages;

import com.javaseleniumtemplate.bases.PageBase;
import org.openqa.selenium.By;
import org.testng.Assert;

import java.util.ArrayList;
import java.util.List;

public class EmissaoCardapioSemanaPage extends PageBase {

    By botaoMenu = By.xpath("//div[@class='bars']");
    By campoPesquisar = By.xpath("//section[@class='zh-container-search-menu']//input[@type='text']");
    By telaEmissaoCarpioSemana = By.xpath("//span[text() = 'Emissão do Cardápio da Semana']");

    By campoRelatorio = By.xpath("//div[@class='zh-select-native-div']/div[2]");
    By relatorioSemanaAlergenico = By.xpath("//div[@class='zh-select-native-div']//li[text() = 'Emissão de Cardápio da Semana - Alergênico']");
    By relatorioCardapioSemana = By.xpath("//div[@class='zh-select-native-div']//li[text() = 'Emissão do Cardápio da Semana']");
    By relatorioCardapioCusto = By.xpath("//div[@class='zh-select-native-div']//li[text() = 'Emissão de Cardápio da Semana (Custo)']");

    By botaoCampoUnidade = By.xpath("//div[@id=\"NMFILIAL\"]//span[@style=\"background-image: none; display: block;\"]");
    By campoUnidade = By.id("NMFILIAL");
    By unidadeDepositoJabaquara = By.xpath("//div[@data-zh-id=\"13767247994127411761243\"]//span[text() = '0002 | DEPOSITO JABAQUARA']");

    By campoSemanaInicial = By.id("SEMANAINICIAL");
    By botaoCampoSemanaInicial = By.xpath("//div[@data-zh-id=\"13767247992940326966254\"]//span[@style=\"background-image: none; display: block;\"]");
    By botaoMenosSemanaInicial = By.xpath("//div[@data-zh-id=\"13767247991114054680252\"]//button[@class=\"spin-button spin-button-minus\"]");
    By botaoMaisSemanaInicial = By.xpath("//div[@data-zh-id=\"13767247991114054680252\"]//button[@class=\"spin-button spin-button-plus\"]");
    By campoNumeroSemanaInicial = By.id("NRSEMANAINI");

    By campoSemanaFinal = By.id("SEMANAFINAL");
    By botaoCampoSemanaFinal = By.xpath("//div[@data-zh-id=\"13767247992831040250258\"]//span[@style=\"background-image: none; display: block;\"]");
    By botaoMenosSemanaFinal = By.xpath("//div[@data-zh-id=\"13767247991222791771256\"]//button[@class=\"spin-button spin-button-minus\"]");
    By botaoMaisSemanaFinal = By.xpath("//div[@data-zh-id=\"13767247991222791771256\"]//button[@class=\"spin-button spin-button-plus\"]");
    By campoNumeroSemanaFinal = By.id("NRSEMANAFIN");

    By todosServicos = By.xpath("//div[@data-zh-id='13767247992176345398250']//div[@class='zh-box mousetrap zh-ripple-effect']");
    By campoServico = By.id("NMSERVICO");
    By servicoAlmocoEspecial = By.xpath("//div[@data-zh-field-name='NMSERVICO']//span[text() = 'ALMOÇO ESPECIAL']");
    By servicoJantar = By.xpath("//div[@data-zh-field-name='NMSERVICO']//span[text() = 'JANTAR']");

    By todosDiasSemana = By.xpath("//div[@data-zh-id='1376724799282993180671']//div[@class=\"zh-box mousetrap zh-ripple-effect\"]");
    By campoDiasSemana = By.id("WEEK_DAYS");
    By diaDomingo = By.xpath("//div[@data-zh-field-name='DESCRIPTION']//span[text() = 'Domingo']");
    By diaSegundaFeira = By.xpath("//div[@data-zh-field-name='DESCRIPTION']//span[text() = 'Segunda-Feira']");

    By botaoOk = By.xpath("//section[@class='popup-container']//div[@class='zh-footer-right']//span[text() = 'Ok']");

    By comensaisNaoImprimir = By.xpath("//label[@for=\"radio-IMPCOMENSAIS-N\"]//div[@class=\"zh-inner-circle\"]");
    By comensaisNumero = By.xpath("//label[@for=\"radio-IMPCOMENSAIS-NUMERO\"]//div[@class=\"zh-inner-circle\"]");
    By comensaisPercentual = By.xpath("//label[@for=\"radio-IMPCOMENSAIS-PERCENTUAL\"]//div[@class=\"zh-inner-circle\"]");
    By radioButtonComensaisNaoImprimir = By.id("radio-IMPCOMENSAIS-N");
    By radioButtonComensaisNumero = By.id("radio-IMPCOMENSAIS-NUMERO");
    By radioButtonComensaisPercentual = By.id("radio-IMPCOMENSAIS-PERCENTUAL");

    By agruparPorSemana = By.xpath("//label[@for=\"radio-AGRUPAR-SEMANA\"]//div[@class=\"zh-inner-circle\"]");
    By radioButtonAgruparPorSemana = By.id("radio-AGRUPAR-SEMANA");
    By agruparPorServico = By.xpath("//label[@for=\"radio-AGRUPAR-SERVICO\"]//div[@class=\"zh-inner-circle\"]");
    By radioButtonAgruparPorServico = By.id("radio-AGRUPAR-SERVICO");

    By mensagemObrigatorioUnidade = By.xpath("//div[@data-zh-id=\"13767247994127411761243\"]//div[@class=\"zh-validation\"]/span");
    By mensagemObrigatorioServico = By.xpath("//div[@data-zh-id=\"1376724799108472373246\"]//div[@class=\"zh-validation\"]/span");
    By mensagemObrigatorioSemanaInicial = By.xpath("//div[@data-zh-id=\"13767247992940326966254\"]//div[@class=\"zh-validation\"]/span");
    By mensagemObrigatorioSemanaFinal = By.xpath("//div[@data-zh-id=\"13767247992831040250258\"]//div[@class=\"zh-validation\"]/span");
    By mensagemObrigatorioImprimirDiasSemana = By.xpath("//div[@data-zh-id=\"137672479951145371670\"]//div[@class=\"zh-validation\"]/span");
    By mensagemObrigatorioTipoCusto = By.xpath("//div[@data-zh-id=\"13767247994007212137266\"]//div[@class=\"zh-validation\"]/span");

    By imprimirMensagem = By.xpath("//label[@for=\"zh-checkbox-IMPMENSAGEM\"]");
    By imprimirNomeFantasia = By.xpath("//label[@for=\"zh-checkbox-IMPNMFANTASIA\"]");
    By quebraDePagina = By.xpath("//label[@for=\"zh-checkbox-QUEBRARPAG\"]");
    By quebraPorMes = By.xpath("//label[@for=\"zh-checkbox-QUEBRAMES\"]");
    By checkBoxImprimirMensagem = By.id("zh-checkbox-IMPMENSAGEM");
    By checkBoxImprimirNomeFantasia = By.id("zh-checkbox-IMPNMFANTASIA");
    By checkBoxQuebraDePagina = By.id("zh-checkbox-QUEBRARPAG");
    By checkBoxQuebraPorMes = By.id("zh-checkbox-QUEBRAMES");

    By botaoCampoTipoCusto = By.xpath("//div[@id=\"NMTIPOCUSTO\"]//span[@style=\"background-image: none; display: block;\"]");
    //para verificar se o campo tipo de custo está habilitado
    By campoTipoCustoImput = By.xpath("//div[@id=\"NMTIPOCUSTO\"]/input");

    By campoTipoCusto = By.id("NMTIPOCUSTO");
    By tipoCustoMedioBrutoAtual = By.xpath("//div[@data-zh-id=\"13767247994007212137266\"]//span[text() = 'Custo Médio Bruto Atual']");
    By valorCampoTipoDeCusto = By.xpath("//div[@id=\"NMTIPOCUSTO\"]//span[@class=\"value\"]");
    By calculoCustoReferencia = By.xpath("//div[@data-zh-id=\"13767247994142796452267\"]//label[@for=\"radio-TPDATA-0\"]//div[@data-zh-contenteditable=\"true\"]");
    By calculoCustoCardapio = By.xpath("//div[@data-zh-id=\"13767247994142796452267\"]//label[@for=\"radio-TPDATA-1\"]//div[@data-zh-contenteditable=\"true\"]");
    By radioButtonCalculoCustoReferencia = By.id("radio-TPDATA-0");
    By radioButtonCalculoCustoCardapio = By.id("radio-TPDATA-1");

    By tipoPdf = By.xpath("//label[@for='radio-QR2TYPE-PDF']//div[@contenteditable='true']");
    By botaoRelatorio = By.xpath("//div[@class='zh-footer-right']");
    By botaoConfirmar = By.xpath("//section[@id='popup']//span[text() = 'Confirmar']");

    public void acessarTela() {
        tempoParaAguardarTelaInicial();
        waitForElement(botaoMenu);
        tempo();
        click(botaoMenu);
        sendKeys(campoPesquisar, "Emissão do Cardápio da Semana");
        click(telaEmissaoCarpioSemana);
    }

    public void selecionaRelatorio(String nomeDoRelatorio) {
        if(nomeDoRelatorio == "Emissão de Cardápio da Semana - Alergênico") {
            clicarCampoSelecionarValor(campoRelatorio, relatorioSemanaAlergenico);
        } else if(nomeDoRelatorio == "Emissão do Cardápio da Semana") {
            clicarCampoSelecionarValor(campoRelatorio, relatorioCardapioSemana);
        } else if(nomeDoRelatorio == "Emissão de Cardápio da Semana (Custo)") {
            clicarCampoSelecionarValor(campoRelatorio, relatorioCardapioCusto);
        }
    }

    public void selecionarUnidade() {
        clicarCampoSelecionarValor(campoUnidade, unidadeDepositoJabaquara);
    }

    public void selecionarServico() {
        click(todosServicos);
        click(campoServico);
        click(servicoAlmocoEspecial);
        click(servicoJantar);
        click(botaoOk);
    }

    public void selecionarDias() {
        click(todosDiasSemana);
        click(todosDiasSemana);
        click(campoDiasSemana);
        click(diaDomingo);
        click(diaSegundaFeira);
        click(botaoOk);
    }

    public void selecionarAgruparPorServico() {
        click(agruparPorServico);
    }

    public void selecionarBaseCardapio() {
        click(calculoCustoCardapio);
    }

    public void selecionarComensal(String nomeComensal) {
        if (nomeComensal == "Não imprimir") {
            click(comensaisNaoImprimir);
        } else if (nomeComensal == "Número") {
            click(comensaisNumero);
        } else if (nomeComensal == "Percentual") {
            click(comensaisPercentual);
        }
    }

    public void camposObrigatorios(String relatorio) {
        //selecionar o relatório que foi passado como parâmetros para está função
        switch (relatorio) {
            case "Emissão do Cardápio da Semana":
                clicarCampoSelecionarValor(campoRelatorio, relatorioCardapioSemana);
                break;
            case "Emissão de Cardápio da Semana (Custo)":
                clicarCampoSelecionarValor(campoRelatorio, relatorioCardapioCusto);
                tempo();
                javaScriptExecutor.executeScript("document.querySelector(\"body > span > section > section > div.default-window > section.everything > div > section > section > div\").scrollBy(0, 500)");
                click(botaoCampoTipoCusto);
                break;
            case "Emissão de Cardápio da Semana - Alergênico":
                clicarCampoSelecionarValor(campoRelatorio, relatorioSemanaAlergenico);
                break;
        }

        click(botaoCampoUnidade);
        click(todosServicos);
        click(botaoCampoSemanaInicial);
        click(botaoCampoSemanaFinal);

        if (relatorio != "Emissão de Cardápio da Semana (Custo)") {
            click(todosDiasSemana);
            click(todosDiasSemana);
        }

        click(botaoRelatorio);

        //mensagens encontradas nos campos obrigatórios
        String unidade = getText(mensagemObrigatorioUnidade);
        String servico = getText(mensagemObrigatorioServico);
        String semanaInicial = getText(mensagemObrigatorioSemanaInicial);
        String semanaFinal = getText(mensagemObrigatorioSemanaFinal);

        String mensagemEsperada = "Campo obrigatório";
        Assert.assertEquals(unidade, mensagemEsperada, "Verificação da mensagem de campo obrigatório do campo unidade");
        Assert.assertEquals(servico, mensagemEsperada, "Verificação da mensagem de campo obrigatório do campo serviço");
        Assert.assertEquals(semanaInicial, mensagemEsperada, "Verificação da mensagem de campo obrigatório do campo semana inicial");
        Assert.assertEquals(semanaFinal, mensagemEsperada, "Verificação da mensagem de campo obrigatório do campo semana final");


        if (relatorio == "Emissão de Cardápio da Semana (Custo)") {
            String tipoCusto = getText(mensagemObrigatorioTipoCusto);
            Assert.assertEquals(tipoCusto, mensagemEsperada, "Verificação da mensagem de campo obrigatório do campo tipo de custo");
        } else if (relatorio == "Emissão do Cardápio da Semana" || relatorio == "Emissão de Cardápio da Semana - Alergênico") {
            String imprimirDiasSemana = getText(mensagemObrigatorioImprimirDiasSemana);
            Assert.assertEquals(imprimirDiasSemana, mensagemEsperada, "Verificação da mensagem de campo obrigatório do campo imprimir dias da semana");
        }
    }

    public void interacaoNumeroEDataSemanaInicial() {
        String dataInicial = "";
        String numeroSemanaInicial = "";

        click(botaoCampoSemanaInicial);
        click(campoSemanaInicial);
        sendKeys(campoSemanaInicial, "30/06/2023");
        click(campoNumeroSemanaFinal);
        dataInicial = getValue(campoSemanaInicial);
        numeroSemanaInicial = getValue(campoNumeroSemanaInicial);
        Assert.assertEquals(dataInicial, "30/06/2023", "Verificação do valor da data inicial, após a interação com este campo");
        Assert.assertEquals(numeroSemanaInicial, "26", "Verificação do número da semana inicial, após a alteração da data da semana inicial");

        click(botaoMaisSemanaInicial);
        dataInicial = getValue(campoSemanaInicial);
        numeroSemanaInicial = getValue(campoNumeroSemanaInicial);
        Assert.assertEquals(dataInicial, "03/07/2023", "Verificação do valor da data inicial, após clicar no '+' da semana inicial");
        Assert.assertEquals(numeroSemanaInicial, "27", "Verificação do número da semana inicial, após clicar no '+' da semana inicial");

        click(botaoMenosSemanaInicial);
        click(botaoMenosSemanaInicial);
        dataInicial = getValue(campoSemanaInicial);
        numeroSemanaInicial = getValue(campoNumeroSemanaInicial);
        Assert.assertEquals(dataInicial, "19/06/2023", "Verificação do valor da data inicial, após clicar dua vezes no '-' da semana inicial");
        Assert.assertEquals(numeroSemanaInicial, "25", "Verificação do número da semana inicial, após após clicar dua vezes no '-' da semana inicial");
    }

    public void interacaoNumeroEDataSemanaFinal() {
        String dataFinal = "";
        String numeroSemanaFinal = "";

        click(botaoCampoSemanaFinal);
        click(campoSemanaFinal);
        sendKeys(campoSemanaFinal, "20/09/2023");
        click(campoNumeroSemanaInicial);
        dataFinal = getValue(campoSemanaFinal);
        numeroSemanaFinal = getValue(campoNumeroSemanaFinal);
        Assert.assertEquals(dataFinal, "20/09/2023", "Verificação do valor da data final, após a interação com este campo");
        Assert.assertEquals(numeroSemanaFinal, "38", "Verificação do número da semana final, após a alteração da data da semana final");

        click(botaoMaisSemanaFinal);
        dataFinal = getValue(campoSemanaFinal);
        numeroSemanaFinal = getValue(campoNumeroSemanaFinal);
        Assert.assertEquals(dataFinal, "01/10/2023", "Verificação do valor da data final, após clicar no '+' da semana final");
        Assert.assertEquals(numeroSemanaFinal, "39", "Verificação do número da semana final, após clicar no '+' da semana final");

        click(botaoMenosSemanaFinal);
        click(botaoMenosSemanaFinal);
        dataFinal = getValue(campoSemanaFinal);
        numeroSemanaFinal = getValue(campoNumeroSemanaFinal);
        Assert.assertEquals(dataFinal, "17/09/2023", "Verificação do valor da data final, após clicar dua vezes no '-' da semana final");
        Assert.assertEquals(numeroSemanaFinal, "37", "Verificação do número da semana final, após após clicar dua vezes no '-' da semana final");
    }

    public void selecionarTipoDeCusto() {
        clicarCampoSelecionarValor(campoTipoCusto, tipoCustoMedioBrutoAtual);
        String tipoCusto = getText(valorCampoTipoDeCusto);
        Assert.assertEquals(tipoCusto, "Custo Médio Bruto Atual", "Verificar o valor apresentado no campo tipo de custo, após selecionar o tipo de custo desejado");
    }

    public void verificarBotoesCalcularCustoPlanejado() {
        tempo();
        javaScriptExecutor.executeScript("document.querySelector(\"body > span > section > section > div.default-window > section.everything > div > section > section > div\").scrollBy(0, 500)");

        click(calculoCustoReferencia);
        boolean referencia = returnIfElementIsSelected(radioButtonCalculoCustoReferencia);
        Assert.assertEquals(referencia, true, "Verificar se após clicar na opção 'de Referência' cálcular custo planejado com base na data, de fato a opção está sendo selecionada");

        click(calculoCustoCardapio);
        boolean cardapio = returnIfElementIsSelected(radioButtonCalculoCustoCardapio);
        Assert.assertEquals(cardapio, true, "Verificar se após clicar na opção 'de Cardápio' cálcular custo planejado com base na data, de fato a opção está sendo selecionada");
    }

    public void verificarBotoesAgruparPor() {
        click(agruparPorSemana);
        boolean semana = returnIfElementIsSelected(radioButtonAgruparPorSemana);
        Assert.assertEquals(semana, true, "Verificar se após clicar na opção 'Semana' em agrupar por, de fato a opção está sendo selecionada");

        click(agruparPorServico);
        boolean servico = returnIfElementIsSelected(radioButtonAgruparPorServico);
        Assert.assertEquals(servico, true, "Verificar se após clicar na opção 'Servico' em agrupar por, de fato a opção está sendo selecionada");
    }

    public void verificarBotoesComensais() {
        click(comensaisNaoImprimir);
        boolean naoImprimir = returnIfElementIsSelected(radioButtonComensaisNaoImprimir);
        Assert.assertEquals(naoImprimir, true, "Verificação se após clicar na opção 'Não Imprimir' das comensais, de fato a opção fica selecionada");

        click(comensaisNumero);
        boolean numero = returnIfElementIsSelected(radioButtonComensaisNumero);
        Assert.assertEquals(numero, true, "Verificação se após clicar na opção 'Número' das comensais, de fato a opção fica selecionada");

        click(comensaisPercentual);
        boolean percentual = returnIfElementIsSelected(radioButtonComensaisPercentual);
        Assert.assertEquals(percentual, true, "Verificação se após clicar na opção 'Percentual' das comensais, de fato a opção fica selecionada");
    }

    public void camposTipoCustoHabilitosPelosRelatorios() {
        clicarCampoSelecionarValor(campoRelatorio, relatorioCardapioSemana);
        verificarCamposTipoCusto(false, "Emissão do Cardápio da Semana");
        clicarCampoSelecionarValor(campoRelatorio, relatorioCardapioCusto);
        verificarCamposTipoCusto(true, "Emissão de Cardápio da Semana (Custo)");
        clicarCampoSelecionarValor(campoRelatorio, relatorioSemanaAlergenico);
        verificarCamposTipoCusto(false, "Emissão de Cardápio da Semana - Alergênico");
    }

    public void verificarOpcoesCheckBox() {
        boolean checkImprimirMensagem = returnIfElementIsSelected(checkBoxImprimirMensagem);
        Assert.assertEquals(checkImprimirMensagem, false, "Verificar se assim que a tela carrega o check-box de 'imprimir mensagem' está desmarcado");
        click(imprimirMensagem);
        checkImprimirMensagem = returnIfElementIsSelected(checkBoxImprimirMensagem);
        Assert.assertEquals(checkImprimirMensagem, true, "Verificar se clicar em 'imprimir mensagem' a opção fica marcada");

        boolean checkImprimirNome = returnIfElementIsSelected(checkBoxImprimirNomeFantasia);
        Assert.assertEquals(checkImprimirNome, false, "Verificar se assim que a tela carrega o check-box de 'imprimir nome fantasia' está desmarcado");
        click(imprimirNomeFantasia);
        checkImprimirNome = returnIfElementIsSelected(checkBoxImprimirNomeFantasia);
        Assert.assertEquals(checkImprimirNome, true, "Verificar se clicar em 'imprimir nome fantasia' a opção fica marcada");

        boolean checkQuebraDePagina = returnIfElementIsSelected(checkBoxQuebraDePagina);
        Assert.assertEquals(checkQuebraDePagina, true, "Verificar se assim que a tela carrega o check-box de 'quebra de página' está marcado");
        click(quebraDePagina);
        checkQuebraDePagina = returnIfElementIsSelected(checkBoxQuebraDePagina);
        Assert.assertEquals(checkQuebraDePagina, false, "Verificar se clicar em 'quebra de página' a opção fica desmarcada");

        boolean checkQuebraPorMes = returnIfElementIsSelected(checkBoxQuebraPorMes);
        Assert.assertEquals(checkQuebraPorMes, true, "Verificar se assim que a tela carrega o check-box de 'quebra por mês' está marcado");
        click(quebraPorMes);
        checkQuebraPorMes = returnIfElementIsSelected(checkBoxQuebraPorMes);
        Assert.assertEquals(checkQuebraPorMes, false, "Verificar se clicar em 'quebra por mês' a opção fica desmarcada");
    }

    private void verificarCamposTipoCusto(boolean estaHabilitado, String relatorio) {
        tempo();
        javaScriptExecutor.executeScript("document.querySelector(\"body > span > section > section > div.default-window > section.everything > div > section > section > div\").scrollBy(0, 500)");
        boolean tipoCusto = returnIfElementIsEnabled(campoTipoCustoImput);
        boolean referencia = returnIfElementIsEnabled(radioButtonCalculoCustoReferencia);
        boolean cardapio = returnIfElementIsEnabled(radioButtonCalculoCustoCardapio);

        Assert.assertEquals(tipoCusto, estaHabilitado, "Verificando se o campo tipo custo está habilitado durante o relatório " + relatorio);
        Assert.assertEquals(referencia, estaHabilitado, "Verificando se o radio button referência está habilitado durante o relatório " + relatorio);
        Assert.assertEquals(cardapio, estaHabilitado, "Verificando se o radio button cardápio está habilitado durante o relatório " + relatorio);
        refresh();
    }

    public void geraRelatorio() {
        super.geraRelatorio(botaoRelatorio, tipoPdf, botaoConfirmar);
        fecharGuiaDoRelatorio();
    }

    private void fecharGuiaDoRelatorio() {
        tempo();
        tempo();
        String winHandleBefore = driver.getWindowHandle();
        List<String> aba = new ArrayList<>(driver.getWindowHandles());
        driver.switchTo().window(aba.get(1));
        driver.getCurrentUrl();
        driver.close();
        driver.switchTo().window(winHandleBefore);
    }

}
