package com.javaseleniumtemplate.pages;

import com.javaseleniumtemplate.bases.PageBase;
import org.openqa.selenium.By;
import org.openqa.selenium.WebElement;
import org.openqa.selenium.support.ui.ExpectedConditions;
import org.openqa.selenium.support.ui.WebDriverWait;
import org.testng.Assert;

import java.util.ArrayList;
import java.util.List;

public class EmissaoRetiradasPage extends PageBase {

    By botaoMenu = By.xpath("//div[@class='bars']");
    By campoPesquisar = By.xpath("//section[@class='zh-container-search-menu']//input[@type='text']");
    By telaEmissaoDasRetiradas = By.xpath("//span[text() = 'Emissão das Retiradas']");

    By campoRelatorio = By.id("REPORT_NAME");
    By relatorioOrdenadoPorData = By.xpath("//div[@data-zh-id=\"11743557715611585042944\"]//div[@class=\"list-items show-select\"]//span[text() = 'Retirada Planejamento (Ordenado por Data)']");
    By relatorioOrdenadoPorServico = By.xpath("//div[@data-zh-id=\"11743557715611585042944\"]//div[@class=\"list-items show-select\"]//span[text() = 'Retirada Planejamento (Ordenado por Serviço)']");
    By relatorioAcumuladoAnalitico = By.xpath("//div[@data-zh-id=\"11743557715611585042944\"]//div[@class=\"list-items show-select\"]//span[text() = 'Retirada Planejamento (Acumulado Analítico)']");
    By relatorioAcumuladoSintetico = By.xpath("//div[@data-zh-id=\"11743557715611585042944\"]//div[@class=\"list-items show-select\"]//span[text() = 'Retirada Planejamento (Acumulado Sintético)']");
    By relatorioProdRetNaoAtualizadosEstoque = By.xpath("//div[@data-zh-id=\"11743557715611585042944\"]//div[@class=\"list-items show-select\"]//span[text() = 'Produtos Retirados não atualizados no Estoque']");

    By campoUnidade = By.id("NMFILIAL");
    By unidadeDepositoJabaquara = By.xpath("//div[@data-zh-id=\"11743557714285671142945\"]//div[@class=\"list-items show-select\"]//span[text() = '0002 | DEPOSITO JABAQUARA']");
    By campoDataInicial = By.id("DTINTERVAL_START");
    By campoDataFinal = By.id("DTINTERVAL_END");

    By campoAlmoxarifado = By.id("DSALMOXARIFE");
    By almoxarifadoMateriaPrimaQuarentena = By.xpath("//div[@data-zh-id=\"11743557718253733182952\"]//div[@class=\"list-items show-select\"]//span[text() = '1 | MATERIA PRIMA QUARENTENA']");

    By botaoCampoRelatorio = By.xpath("//div[@id=\"REPORT_NAME\"]//span[@style=\"background-image: none; display: block;\"]");
    By botaoCampoUnidade = By.xpath("//div[@id=\"NMFILIAL\"]//span[@style=\"background-image: none; display: block;\"]");
    By botaoCampoIntervaloData = By.xpath("//div[@id=\"DTINTERVAL\"]//span[@style=\"background-image: none; display: block;\"][2]");
    By botaoCampoNivelTotalizacao = By.xpath("//div[@id=\"NPTOTALIZACAO\"]//span[@style=\"background-image: none; display: block;\"]");
    By botaoOk = By.xpath("//section[@class=\"popup-container\"]//div[@class=\"zh-footer-right\"]");

    By checkBoxTodosServicos = By.xpath("//label[@for=\"zh-checkbox-TODOS_SERVICOS\"]//div[@class=\"zh-box mousetrap zh-ripple-effect\"]");
    By campoServico = By.id("NMSERVICO");
    By servicoRetiradas = By.xpath("//div[@data-zh-field-name=\"NMSERVICO\"]//span[text() = 'RETIRADAS']");
    By servicoJanta = By.xpath("//div[@data-zh-field-name=\"NMSERVICO\"]//span[text() = 'JANTA']");

    By checkBoxImprimirQuantZero = By.xpath("//label[@for=\"zh-checkbox-QTRETIRADA\"]//div[@class=\"zh-box mousetrap zh-ripple-effect\"]");
    By inputImprimirQuantZero = By.id("zh-checkbox-QTRETIRADA");

    By radioButtonOrdenacaoCodigo = By.xpath("//div[@data-zh-id=\"11743557726910654512961\"]//label[@for=\"radio-NRTAMCODIGO-10\"]/div");
    By radioButtonOrdenacaoAlfabetica = By.xpath("//div[@data-zh-id=\"11743557726910654512961\"]//label[@for=\"radio-NRTAMCODIGO-0\"]/div");
    By inputOrdencaoCodigo = By.id("radio-NRTAMCODIGO-10");
    By inputOrdenacaoAlfabetica = By.id("radio-NRTAMCODIGO-0");

    By campoNivelTotalizacao = By.id("NPTOTALIZACAO");
    By opcoesNiveisTotalizacao = By.xpath("//div[@data-zh-id=\"11743557723977003902962\"]//div[@class=\"list-items show-select\"]/span");
    By nivelSelecionado = By.xpath("//div[@id=\"NPTOTALIZACAO\"]//span[@class=\"value\"]");

    By mensagemObrigatorioRelatorio = By.xpath("//div[@data-zh-id=\"11743557715611585042944\"]//div[@class=\"zh-validation\"]/span");
    By mensagemObrigatorioUnidade = By.xpath("//div[@data-zh-id=\"11743557714285671142945\"]//div[@class=\"zh-validation\"]/span");
    By mensagemObrigatorioIntervaloData = By.xpath("//div[@data-zh-id=\"11743557730667580121692\"]//div[@class=\"zh-validation\"]/span");
    By mensagemObrigatorioServico = By.xpath("//div[@data-zh-id=\"1174355775888693782954\"]//div[@class=\"zh-validation\"]/span");
    By mensagemObrigatorioNivelTotalizacao = By.xpath("//div[@data-zh-id=\"11743557723977003902962\"]//div[@class=\"zh-validation\"]/span");

    By botaoRelatorio = By.xpath("//div[@class='zh-footer-right']");
    By tipoPdf = By.xpath("//label[@for='radio-QR2TYPE-PDF']//div[@class='zh-inner-circle']");
    By botaoConfirmar = By.xpath("//section[@id='popup']//div[@class='zh-footer-right']//span[text() = 'Confirmar']");

    public void acessarTela() {
        tempoParaAguardarTelaInicial();
        waitForElement(botaoMenu);
        click(botaoMenu);
        sendKeys(campoPesquisar, "Emissão das Retiradas");
        click(telaEmissaoDasRetiradas);
    }

    public void selecionarRelatorio(String nomeRelatorio) {
        tempo();
        switch (nomeRelatorio) {
            case "Retirada Planejamento (Ordenado por Data)":
                clicarCampoSelecionarValor(campoRelatorio, relatorioOrdenadoPorData);
                break;
            case "Retirada Planejamento (Ordenado por Serviço)":
                clicarCampoSelecionarValor(campoRelatorio, relatorioOrdenadoPorServico);
                break;
            case "Retirada Planejamento (Acumulado Analítico)":
                clicarCampoSelecionarValor(campoRelatorio, relatorioAcumuladoAnalitico);
                break;
            case "Retirada Planejamento (Acumulado Sintético)":
                clicarCampoSelecionarValor(campoRelatorio, relatorioAcumuladoSintetico);
                break;
            case "Produtos Retirados não atualizados no Estoque":
                clicarCampoSelecionarValor(campoRelatorio, relatorioProdRetNaoAtualizadosEstoque);
                break;
        }
    }

    public void selecionarUnidade() {
        clicarCampoSelecionarValor(campoUnidade, unidadeDepositoJabaquara);
    }

    public void preencherDatas(String dataInicial, String dataFinal) {
        super.preencherDatas(campoDataInicial, campoDataFinal, dataInicial, dataFinal);
    }

    public void selecionarAlmoxarifado() {
        click(campoAlmoxarifado);
        tempo();
        click(campoAlmoxarifado);
        tempo();
        click(almoxarifadoMateriaPrimaQuarentena);
    }

    public void selecionarServicos() {
        click(checkBoxTodosServicos);
        tempo();
        click(campoServico);
        tempo();
        click(servicoRetiradas);
        click(servicoJanta);
        click(botaoOk);
    }

    public void campoObrigatorios() {
        click(botaoCampoRelatorio);
        click(botaoCampoUnidade);
        click(botaoCampoIntervaloData);
        click(checkBoxTodosServicos);
        click(botaoCampoNivelTotalizacao);
        click(botaoRelatorio);

        String relatorio = getText(mensagemObrigatorioRelatorio);
        String unidade = getText(mensagemObrigatorioUnidade);
        String intervaloData = getText(mensagemObrigatorioIntervaloData);
        String servico = getText(mensagemObrigatorioServico);
        String nivelTotalizacao = getText(mensagemObrigatorioNivelTotalizacao);

        String mensagemEsperada = "Campo obrigatório";
        Assert.assertEquals(relatorio, mensagemEsperada, "Verificar mensagem de campo obrigatório no campo 'relatório'");
        Assert.assertEquals(unidade, mensagemEsperada, "Verificar mensagem de campo obrigatório no campo 'unidade'");
        Assert.assertEquals(intervaloData, "Campo obrigatório!", "Verificar mensagem de campo obrigatório no campo 'intervalo de data'");
        Assert.assertEquals(servico, mensagemEsperada, "Verificar mensagem de campo obrigatório no campo 'serviço'");
        Assert.assertEquals(nivelTotalizacao, mensagemEsperada, "Verificar mensagem de campo obrigatório no campo 'nível para totalização'");
    }

    public void verificarOpcoesDeOrdenacao() {
        click(radioButtonOrdenacaoCodigo);
        boolean codigo = returnIfElementIsSelected(inputOrdencaoCodigo);
        boolean alfabetica = returnIfElementIsSelected(inputOrdenacaoAlfabetica);
        Assert.assertTrue(codigo, "Verificar se a ordenação de 'código' está selecionada");
        Assert.assertFalse(alfabetica, "Verificar se com a ordenação de 'código' selecionada, a 'alfabetíca' não está selecionada");

        click(radioButtonOrdenacaoAlfabetica);
        codigo = returnIfElementIsSelected(inputOrdencaoCodigo);
        alfabetica = returnIfElementIsSelected(inputOrdenacaoAlfabetica);
        Assert.assertTrue(alfabetica, "Verificar se após clicar na ordenação 'alfabética', a mesma passa a estar selecionada");
        Assert.assertFalse(codigo, "Verificar se após selecionar a ordenação 'alfabética' está selecionada, a ordenação por 'código' passa a não estar mais selecionada");
    }

    public void selecionarImprimirQuantZero() {
        click(checkBoxImprimirQuantZero);
        boolean imprimirQuantZero = returnIfElementIsSelected(inputImprimirQuantZero);
        Assert.assertTrue(imprimirQuantZero, "Verificar se o check-box 'Imprimir Quantidade Zero' está selecionado");
    }

    public void verificarNiveisDeTotalizacao() {
        tempo();
        click(campoNivelTotalizacao);
        tempo();

        long timeout = 0;
        List<WebElement> results = (new WebDriverWait(driver, timeout))
                .until(ExpectedConditions
                        .visibilityOfAllElementsLocatedBy(
                                opcoesNiveisTotalizacao
                        )
                );

        Assert.assertEquals(results.size(), 6, "Verificar a quantidade de níveis para totalização");

        int valorNivel = 0;
        for (WebElement nivel : results) {
            Assert.assertEquals(nivel.getText(), String.valueOf(valorNivel));
            valorNivel++;
        }

        results.get(3).click();
        Assert.assertEquals(getText(nivelSelecionado), "3", "Verificar valor do nível de totalização selecionado");
    }

    public void geraRelatorio() {
        super.geraRelatorio(botaoRelatorio, tipoPdf, botaoConfirmar);
        fecharGuiaDoRelatorio();
    }

    private void fecharGuiaDoRelatorio() {
        tempo();
        tempo();
        String winHandleBefore = driver.getWindowHandle();
        List<String> aba = new ArrayList<>(driver.getWindowHandles());
        driver.switchTo().window(aba.get(1));
        driver.getCurrentUrl();
        driver.close();
        driver.switchTo().window(winHandleBefore);
    }








}
