package com.javaseleniumtemplate.pages;

import com.javaseleniumtemplate.bases.PageBase;
import org.openqa.selenium.By;
import org.testng.Assert;

public class ExclusaoDeCardapioPage extends PageBase {
    By clicaMenu = By.xpath("//*[@type = 'button']");
    By confirmaAcessoTela = By.xpath("//*[@class = 'navbar-brand zh-header-title has-header-info']");
    By clicaPlanejamento = By.xpath("//*[@class = 'menu-link']//*[contains(text(),'Planejamento')]");
    By clicaCardapio = By.xpath("/html/body/span/section/section/div[2]/section[1]/div/aside/div[2]/nav/ul/li[1]/ul/li[2]/ul/li[1]/span/span[3]");
    By clicaExclusaoCardapio = By.xpath("//ul[@class = 'sub-menu']//span[@class = 'menu-link']//span[contains(text(),'Exclusão de Cardápio')]");

    By agrupamentoUnidade = By.xpath("//div[@id = 'NMGRUPFILI']//span[@zh-icon='no-border search']");
    By selecionaAgrupamento = By.xpath("//div[@class = 'tr cell1']");
    By limpaAgrupamento = By.xpath("//div[@class = 'zh-select-multiple zh-select-autocomplete mousetrap zh-field-NMGRUPFILI zh-text-align-left']//span[@zh-icon= 'no-border close-x']");
    By lupaFiltro = By.xpath("//span[@class = 'action-icon search-action-icon zh-icon zh-icon-search zh-icon-no-border zh-icon-color-white']");
    By campoFilial = By.xpath("//div[@id = 'CDFILIAL']");
    By informaBusca = By.xpath("//input[@class = 'mousetrap zh-input-search-floating ng-pristine ng-valid ng-touched']");
    By selecionaBusca = By.xpath("//span[@data-ng-if='!row.__group']");
    By btnOk = By.xpath("//span[text() = 'Ok']");
    By checkBoxTodasUnidades = By.xpath("//label[@for = 'zh-checkbox-ALLCDFILIAL']//div[@class = 'zh-box mousetrap zh-ripple-effect']");
    By campoServico = By.xpath("//div[@id = 'CDSERVFILI']");
    By checkBoxTodosServicos = By.xpath("//label[@for = 'zh-checkbox-ALLCDSERVFILI']//div[@class = 'zh-box mousetrap zh-ripple-effect']");
    By limpaData = By.xpath("//div[@class = 'zh-select-multiple mousetrap zh-field-DTINTERVAL']//span[@zh-icon='no-border close-x']");
    By dtInicial = By.xpath("//input[@id = 'DTINTERVAL_START']");
    By dtFinal = By.xpath("//input[@id = 'DTINTERVAL_END']");
    By btnExcluirCardapio = By.xpath("//span[text() = 'Excluir Cardápio']");
    By confirmaExclusao = By.xpath("//button[@class = 'zh-alert-button horizontal']//span[text() = 'Sim']");
    By btnConfirmaMensagem = By.xpath("//button[@class = 'zh-alert-button']");
    By btnCancelar = By.xpath("//section[@class = 'popup-container']//div[@class = 'zh-footer-left']//li[@class = 'previous zh-ripple-effect']");
    By botaoAbrirOpcoesControleTelaInicial = By.xpath("//*[@id='popup']/span/section/section/section/section/div/div[2]/div");
    By botaoPesquisarFiltro = By.xpath("//*[@id='popup']/span/section/section/section/section/div/div[2]/div/div[1]/ul/li[2]");
    By campoProcurar = By.xpath("//*[@id='popup']/span/section/section/section/section/div/div[2]/div/div[1]/ul/li[2]/div/div/div/div[3]/input");
    By msgCardapioBloqueado = By.xpath("//*[@id='popup']/span/section/section/header/div");
    By msgCampoUnidade = By.xpath("/html/body/span/section/section/div[2]/section[2]/div/section/section/div/form/section/div/div[2]/div[1]/div/div[2]/span");
    By msgCampoServico = By.xpath("/html/body/span/section/section/div[2]/section[2]/div/section/section/div/form/section/div/div[3]/div[1]/div/div[2]/span");
    By msgCampoData = By.xpath("/html/body/span/section/section/div[2]/section[2]/div/section/section/div/form/section/div/div[4]/div/div/div[1]/span");
    By msgEncontradaTela = By.xpath("//*[@id='header']/div/div[2]/div[2]");
    By msgCardapioVazio = By.xpath("/html/body/span[1]/section/section/div[2]/aside[1]/aside/section/aside/div/p");
    By msgSucessoExclusao = By.xpath("/html/body/span[1]/section/section/div[2]/aside[1]/aside/section/aside/div/p");



    public void navegaExclusaoCardapio(){
        tempo();
        mudaUrl();
        tempo();
        click(clicaMenu);
        click(clicaPlanejamento);
        click(clicaCardapio);
        click(clicaExclusaoCardapio);
        tempo();
        waitForElement(confirmaAcessoTela);
    }

    public void realizaFiltros(String cdAgrupamento, String cdFilial, String cdServico) {
        if (cdAgrupamento != "") {
            click(agrupamentoUnidade);
            tempo();
            preencherCampoProcurarTelaInicial(botaoAbrirOpcoesControleTelaInicial, botaoPesquisarFiltro, campoProcurar, cdAgrupamento);
            tempo();
            click(selecionaAgrupamento);
        }
        tempo();
        click(campoFilial);
        preencherCampoProcurarTelaInicial(botaoAbrirOpcoesControleTelaInicial, botaoPesquisarFiltro, campoProcurar, cdFilial);
        tempo();
        click(selecionaBusca);
        click(btnOk);
        tempo();
        click(campoServico);
        tempo();
        preencherCampoProcurarTelaInicial(botaoAbrirOpcoesControleTelaInicial, botaoPesquisarFiltro, campoProcurar, cdServico);
        tempo();
        click(selecionaBusca);
        click(btnOk);
        tempo();

    }

    public void informaData(String DTINICIAL, String DTFINAL){
        click(limpaData);
        preencheData(DTINICIAL,DTFINAL,dtInicial,dtFinal);

    }

    public void validarCamposObrigatorios(){
        click(limpaData);
        tempo();
        click(btnExcluirCardapio);
        tempo();
    }

    public String confirmarAcessoTela(){
        return getText(msgEncontradaTela);
    }

    public String msgCampoUnidade(){
        return getText(msgCampoUnidade);
    }

    public String msgCampoServico(){
        return getText(msgCampoServico);
    }

    public String msgCampoData(){
        return getText(msgCampoData);
    }

    public void excluirCardapioBloqueadoVazio(){
        tempo();
        click(btnExcluirCardapio);
        tempo();
        click(confirmaExclusao);
        tempo();

    }

    public String msgCardapioVazio(){
        return getText(msgCardapioVazio);
    }

    public String validaExclusao(){
        return getText(msgSucessoExclusao);
    }

    public void excluirCardapioPeriodo(){
        tempo();
        click(btnExcluirCardapio);
        tempo();
        click(confirmaExclusao);
        tempo();
        Assert.assertEquals(validaExclusao(),"Operação realizada com sucesso.","Erro ao validar exclusão: ");
        tempo();
        click(btnConfirmaMensagem);
        tempo();
    }



    public String retornaMensagemBloqueio(){
        return getText(msgCardapioBloqueado);
    }

}
