package com.javaseleniumtemplate.pages;

import com.javaseleniumtemplate.bases.PageBase;
import org.openqa.selenium.By;
import org.openqa.selenium.Keys;
import org.openqa.selenium.interactions.Actions;
import org.testng.Assert;

import java.util.ArrayList;
import java.util.List;

public class GrupoNutrientesPage extends PageBase {

    By botaoMenu = By.xpath("//div[@class='bars']");
    By campoPesquisar = By.xpath("//section[@class='zh-container-search-menu']//input[@type='text']");
    By opcaoTelaGrupoNutrientes = By.xpath("//span[text() = 'Grupo de Nutrientes']");

    By campoCodigo = By.id("CDGRUPNUTR");
    By campoNome = By.id("NMGRUPNUTR");
    By mensagemObrigatorioCodigo = By.xpath("//div[@data-zh-id=\"1735910934697259685496\"]//div[@class=\"zh-validation\"]/span");
    By mensagemObrigatorioNome = By.xpath("//div[@data-zh-id=\"17359109342785127988497\"]//div[@class=\"zh-validation\"]/span");
    By botaoSalvar = By.xpath("//section[@class=\"popup-container\"]//div[@class=\"zh-footer-right\"]");

    By checkBoxGrupoLinha1 = By.xpath("//div[@id=\"grid-17359109343682978088401\"]//div[@class=\"body-content\"]/div[1]//div[@data-zh-field-name=\"__CHECKBOX\"]/span");
    By codigoGrupoLinha1 = By.xpath("//div[@id=\"grid-17359109343682978088401\"]//div[@class=\"body-content\"]/div[1]//div[@data-zh-field-name=\"CDGRUPNUTR\"]/span");
    By nomeGrupoLinha1 = By.xpath("//div[@id=\"grid-17359109343682978088401\"]//div[@class=\"body-content\"]/div[1]//div[@data-zh-field-name=\"NMGRUPNUTR\"]/span");

    By nutrienteVitaminaA = By.xpath("//div[@data-zh-field-name=\"NMNUTRIENTE\"]//span[text() = 'VITAMINA A']");
    By nutrienteVitaminaE = By.xpath("//div[@data-zh-field-name=\"NMNUTRIENTE\"]//span[text() = 'VITAMINA E']");

    By botaoAbrirOpcoesControleTelaInicial = By.xpath("//div[@data-ng-if=\"widget.isFloatingControlVisible()\"]//div[@data-zh-floating-control]");
    By botaoPesquisarFiltro = By.xpath("//div[@class=\"control-menu\"]//li[@data-zh-id=\"zh-floating-control-custom-action-1\"]");
    By campoProcurar = By.xpath("//li[@class=\"float-action expandable fix-position-bottom opened\"]//input");
    By botaoCancelarAdicaoDeGrupo = By.xpath("//section[@class=\"popup-container\"]//div[@class=\"zh-footer-left\"]");
    By botaoAdicionarGrupo = By.xpath("//div[@id=\"footer\"]//div[@class=\"zh-footer-center\"]//li[@data-zh-id=\"17359109341337517592432\"]");
    By botaoRelatorio = By.xpath("//div[@class=\"zh-footer-center\"]//li[@data-zh-id=\"1735910934379549951204\"]");
    By botaoGerarRelatorio = By.xpath("//section[@class=\"popup-container\"]//div[@class=\"zh-footer-right\"]");
    By botaoAdicionarNutrientes = By.xpath("//div[@id=\"footer\"]//div[@class=\"zh-footer-center\"]//li[@class=\"zh-ripple-effect\"]");
    By botaoAdicionarPoupupNutrientes = By.xpath("//section[@class=\"popup-container\"]//div[@class=\"zh-footer-right\"]");
    By botaoSalvarAlteracoes = By.xpath("//div[@class=\"zh-footer-right\"]");
    By botaoExcluir = By.xpath("//div[@class=\"zh-footer-center\"]//li[@class=\"zh-ripple-effect\"]");
    By botaoVoltar = By.xpath("//div[@class=\"zh-footer-left\"]");
    By botaoSim = By.xpath("//section[@class=\"zh-container-alert\"]//button[@data-zh-id=\"zh-footer-alert-button-0\"]");
    By botaoOk = By.xpath("//section[@class=\"zh-container-alert\"]//button[@type=\"submit\"]");
    By botaoOkGrupoNutrientes = By.xpath("//section[@class=\"popup-container\"]//div[@class=\"zh-footer-right\"]");

    By tipoPdf = By.xpath("//label[@for='radio-QR2TYPE-PDF']/div");
    By botaoConfirmar = By.xpath("//section[@id='popup']//div[@class='zh-footer-right']//span[text() = 'Confirmar']");

    By abaNutrientes = By.xpath("//section[@class=\"container zh-tabbed-container\"]//div[@class=\"zh-tab-scroller\"]//a[text() = 'Nutrientes']");
    By checkBoxNutriente1 = By.xpath("//div[@id=\"grid-17359109342451480642402\"]//div[@class=\"body-content\"]/div[1]//div[@data-zh-field-name=\"__CHECKBOX\"]/span");
    By codigoNutriente1 = By.xpath("//div[@id=\"grid-17359109342451480642402\"]//div[@class=\"body-content\"]/div[1]//div[@data-zh-field-name=\"CDNUTRIENTE\"]/span");
    By nomeNutriente1 = By.xpath("//div[@id=\"grid-17359109342451480642402\"]//div[@class=\"body-content\"]/div[1]//div[@data-zh-field-name=\"NMNUTRIENTE\"]/span");
    By siglaNutriente1 = By.xpath("//div[@id=\"grid-17359109342451480642402\"]//div[@class=\"body-content\"]/div[1]//div[@data-zh-field-name=\"NMREDUZIDO\"]/span");
    By checkBoxNutriente2 = By.xpath("//div[@id=\"grid-17359109342451480642402\"]//div[@class=\"body-content\"]/div[2]//div[@data-zh-field-name=\"__CHECKBOX\"]/span");
    By codigoNutriente2 = By.xpath("//div[@id=\"grid-17359109342451480642402\"]//div[@class=\"body-content\"]/div[2]//div[@data-zh-field-name=\"CDNUTRIENTE\"]/span");
    By nomeNutriente2 = By.xpath("//div[@id=\"grid-17359109342451480642402\"]//div[@class=\"body-content\"]/div[2]//div[@data-zh-field-name=\"NMNUTRIENTE\"]/span");
    By siglaNutriente2 = By.xpath("//div[@id=\"grid-17359109342451480642402\"]//div[@class=\"body-content\"]/div[2]//div[@data-zh-field-name=\"NMREDUZIDO\"]/span");

    By campoRelatorio = By.xpath("//div[@data-zh-id=\"17359109342347132696196\"]//div[@class=\"new-select input-text form-input-margin-bottom mousetrap form-control zh-text-align-{{field.align || 'left'}} ng-pristine ng-untouched ng-valid\"]/span");
    By relatorioGrupoNutrientes = By.xpath("//div[@data-zh-id=\"17359109342347132696196\"]//li[text() = 'Grupo de Nutriente']");
    By campoGrupoNutrientesRelatorio = By.id("CDGRUPNUTR");
    By todosGrupoNutrientes = By.xpath("//label[@for=\"zh-checkbox-T_GRUPO\"]/div");
    By checkTodosGrupoNutrientes = By.id("zh-checkbox-T_GRUPO");
    By grupoCarboidratos = By.xpath("//div[@id='grid-9999']//div[@data-zh-field-name=\"NMGRUPNUTR\"]//span[text() = 'CARBOIDRATOS']");
    By grupoProteinas = By.xpath("//div[@id='grid-9999']//div[@data-zh-field-name=\"NMGRUPNUTR\"]//span[text() = 'PROTEÍNAS']");
    By mensagemObrigatorioGrupoNutrientes = By.xpath("//div[@data-zh-id=\"173591093435721054197\"]//div[@class=\"zh-validation\"]/span");

    //primeiro e segundo grupo, encontrados no container dos grupos de nutrientes após a seleção para geração do relatório
    By containerGrupo1 = By.xpath("//div[@id=\"CDGRUPNUTR\"]//div[@class=\"zh-options-container\"]/span[1]");
    By containerGrupo2 = By.xpath("//div[@id=\"CDGRUPNUTR\"]//div[@class=\"zh-options-container\"]/span[2]");

    By mensagemCantoSuperiorDireito = By.xpath("//ul[@class=\"zh-notification-messages\"]//span[@class=\"notification-message-text\"]");
    By mensagemNenhumRegistroEncontradoGrupo = By.xpath("//div[@id=\"grid-17359109343682978088401\"]//div[@class=\"body-content\"]//p[@class=\"text-center zh-text-search-not-found ng-binding\"]");
    By mensagemNaoHaRegistroNutrientes = By.xpath("//div[@id=\"grid-17359109342451480642402\"]//div[@class=\"body-content\"]//p[@class=\"text-center zh-text-search-not-found ng-binding\"]");
    By mensagemAlerta = By.xpath("//section[@class=\"zh-container-alert\"]//div[@class=\"zh-alert-scroll\"]/p");

    public void acessarTela() {
        tempoParaAguardarTelaInicial();
        waitForElement(botaoMenu);
        click(botaoMenu);
        sendKeys(campoPesquisar, "Grupo de Nutrientes");
        click(opcaoTelaGrupoNutrientes);
    }

    public void adicionarGrupo() {
        click(botaoAdicionarGrupo);
        sendKeys(campoCodigo, "20");
        sendKeys(campoNome, "ÁGUA");
        click(botaoSalvar);

        String mensagem = getText(mensagemCantoSuperiorDireito);
        Assert.assertEquals(mensagem, "Salvo com sucesso.", "Verificar a mensagem de salvo com sucesso exibida no canto superior direito da tela");

        preencherCampoProcurarTelaInicial("20");
        String codigo = getText(codigoGrupoLinha1);
        String nome = getText(nomeGrupoLinha1);
        Assert.assertEquals(codigo, "20", "Verificar código do grupo de nutrientes adicionado");
        Assert.assertEquals(nome, "ÁGUA", "Verificar nome do grupo de nutrientes adicionado");
    }

    public void editarGrupo() {
        preencherCampoProcurarTelaInicial("06");
        alterarNomeGrupo("ÁGUA MINERAL");

        String mensagem = getText(mensagemCantoSuperiorDireito);
        Assert.assertEquals(mensagem, "Salvo com sucesso.", "Verificar mensagem de salvo com sucesso exibida no canto da tela após alterar o nome do grupo");

        refresh();
        preencherCampoProcurarTelaInicial("06");
        String nome = getText(nomeGrupoLinha1);
        Assert.assertEquals(nome, "ÁGUA MINERAL", "Verificar se o nome do grupo foi salvo corretamente");

        alterarNomeGrupo("SAIS MINERAIS");
        tempo();
        nome = getText(nomeGrupoLinha1);
        Assert.assertEquals(nome, "SAIS MINERAIS", "Verificar se o nome do grupo que foi utilizado no teste de edição, foi salvo corretamente retornando para o nome que estava no início do teste");
    }

    public void excluirGrupo() {
        preencherCampoProcurarTelaInicial("20");
        click(checkBoxGrupoLinha1);
        click(botaoExcluir);
        String mensagem = getText(mensagemAlerta);
        Assert.assertEquals(mensagem, "Deletar o(s) registro(s)?", "Verificação mensagem exibida na tela após clicar para excluir o grupo de nutrientes");
        click(botaoSim);
        mensagem = getText(mensagemCantoSuperiorDireito);
        Assert.assertEquals(mensagem, "Excluído com sucesso.", "Verificar mensagem de excluído com sucesso exibida no canto da tela após excluir o grupo de nutrientes");

        //o filtro está sendo aplicado, não deve apresentar
        mensagem = getText(mensagemNenhumRegistroEncontradoGrupo);
        Assert.assertEquals(mensagem, "Nenhum registro foi encontrado", "Verificar se após a exclusão do grupo de nutrientes, não é encontrado nenhum grupo de nutrientes");
    }

    public void adicionarNutrientes() {
        preencherCampoProcurarTelaInicial("02");
        click(codigoGrupoLinha1);
        click(abaNutrientes);
        click(botaoAdicionarNutrientes);
        click(nutrienteVitaminaA);
        click(nutrienteVitaminaE);
        click(botaoAdicionarPoupupNutrientes);

        String mensagem = getText(mensagemCantoSuperiorDireito);
        Assert.assertEquals(mensagem, "Salvo com sucesso", "Verificar mensagem de salvo com sucesso, após adicionar nutrientes ao grupo");

        //dados do primeiro nutriente encontrado na primira linha da lista de nutrientes adicionados
        String encCodigo = getText(codigoNutriente1);
        String encNome = getText(nomeNutriente1);
        String encSigla = getText(siglaNutriente1);
        //dados esperados para o primeiro produto da lista de produtos adicionados
        String expCodigo = "001";
        String expNome = "VITAMINA A";
        String expSigla = "VA";
        Assert.assertEquals(encCodigo, expCodigo, "Verificação do código do primeiro produto encontrado na lista de produtos adicionados, na aba de nutrientes do grupo");
        Assert.assertEquals(encNome, expNome, "Verificação do nome do primeiro produto encontrado na lista de produtos adicionados, na aba de nutrientes do grupo");
        Assert.assertEquals(encSigla, expSigla, "Verificação da sigla do primeiro produto encontrado na lista de produtos adicionados, na aba de nutrientes do grupo");

        //dados do segundo nutriente encontrado na primira linha da lista de nutrientes adicionados
        encCodigo = getText(codigoNutriente2);
        encNome = getText(nomeNutriente2);
        encSigla = getText(siglaNutriente2);
        //dados esperados para o segundo produto da lista de produtos adicionados
        expCodigo = "004";
        expNome = "VITAMINA E";
        expSigla = "VE";
        Assert.assertEquals(encCodigo, expCodigo, "Verificação do código do segundo produto encontrado na lista de produtos adicionados, na aba de nutrientes do grupo");
        Assert.assertEquals(encNome, expNome, "Verificação do nome do segundo produto encontrado na lista de produtos adicionados, na aba de nutrientes do grupo");
        Assert.assertEquals(encSigla, expSigla, "Verificação da sigla do segundo produto encontrado na lista de produtos adicionados, na aba de nutrientes do grupo");
    }

    public void excluirNutrientes() {
        click(checkBoxNutriente1);
        click(checkBoxNutriente2);
        click(botaoExcluir);

        String mensagem = getText(mensagemAlerta);
        String mensagemEsperada = "Deseja excluir o(s) registro(s)?";
        Assert.assertEquals(mensagem, mensagemEsperada, "Verificação mensagem alerta exibida após clicar para excluir os nutrientes");
        click(botaoSim);

        mensagem = getText(mensagemCantoSuperiorDireito);
        Assert.assertEquals(mensagem, "Excluído com sucesso!", "Verificar mensagem de excluído com sucesso, após excluir os nutrientes");
        tempo();
        mensagem = getText(mensagemNaoHaRegistroNutrientes);
        Assert.assertEquals(mensagem, "Não há registros", "Verificar mensagem de não há registros exibida no grid após excluir os nutrientes do grupo");

        click(botaoVoltar);
    }

    public void camposObrigatoriosAdicionarGrupo() {
        click(botaoAdicionarGrupo);
        tempo();
        click(botaoSalvar);

        //mensagem de campo obrigatório encontrada no código e nome
        String mensagemCodigo = getText(mensagemObrigatorioCodigo);
        String mensagemNome = getText(mensagemObrigatorioNome);

        String mensagemEsperada = "Campo obrigatório";
        Assert.assertEquals(mensagemCodigo, mensagemEsperada, "Verificação da mensagem de campo obrigatório, no campo código");
        Assert.assertEquals(mensagemNome, mensagemEsperada, "Verificação da mensagem de campo obrigatório, no campo nome");
        click(botaoCancelarAdicaoDeGrupo);
    }

    public void tentarAdicionarCodigoExistente() {
        tempo();
        click(botaoAdicionarGrupo);
        sendKeys(campoCodigo, "1");
        sendKeys(campoNome, "AÇUCARES");
        click(botaoSalvar);

        //mensagem alerta de código já existente
        String mensagem = getText(mensagemAlerta);
        String mensagemEsperada = "Código do Grupo de Nutrientes já existe!";
        Assert.assertEquals(mensagem, mensagemEsperada, "Verificação da mensagem de alerta exibida após tentar adicionar um código já existente");
        click(botaoOk);
        click(botaoCancelarAdicaoDeGrupo);
    }

    public void tentarExcluirGrupoComRegistrosFilhos() {
        preencherCampoProcurarTelaInicial("01");
        click(checkBoxGrupoLinha1);
        click(botaoExcluir);

        String mensagem = getText(mensagemAlerta);
        Assert.assertEquals(mensagem, "Deletar o(s) registro(s)?", "Verificação mensagem alerta da exclusão");
        click(botaoSim);
        tempo();

        mensagem = getText(mensagemAlerta);
        String mensagemEsperada = "Exclusão não permitida! O registro possui registros filhos.";
        Assert.assertEquals(mensagem, mensagemEsperada, "Verificação da mensagem de alerta informando que o registro não pode ser excluído pois possui registros filhos");
        click(botaoOk);
        tempo();
        click(codigoGrupoLinha1);
    }

    public void gerarRelatorio() {
        click(botaoRelatorio);
        clicarCampoSelecionarValor(campoRelatorio, relatorioGrupoNutrientes);

        boolean checkTodosGrupos = returnIfElementIsSelected(checkTodosGrupoNutrientes);
        Assert.assertEquals(checkTodosGrupos, false, "Verificar se quando o poupup do relatório carrega o campo todos os grupos de nutrientes está desmarcado");
        click(todosGrupoNutrientes);
        checkTodosGrupos = returnIfElementIsSelected(checkTodosGrupoNutrientes);
        Assert.assertEquals(checkTodosGrupos, true, "Verificar se após clicar no check todos os grupos de nutrientes, o mesmo fica selecionado");
        click(todosGrupoNutrientes);

        click(campoGrupoNutrientesRelatorio);
        click(grupoCarboidratos);
        click(grupoProteinas);
        click(botaoOkGrupoNutrientes);

        //primeiro e segundo grupo, encontrados no container após a seleção dos grupos
        String encPrimeiroGrupo = getText(containerGrupo1);
        String encSegundoGrupo = getText(containerGrupo2);

        //grupos esperados
        String expPrimeiroGrupo = "×CARBOIDRATOS";
        String expSegundoGrupo = "×PROTEÍNAS";

        Assert.assertEquals(encPrimeiroGrupo, expPrimeiroGrupo, "Verificação do primeiro grupo encontrado no container dos grupos após a seleção para a geração do relatório");
        Assert.assertEquals(encSegundoGrupo, expSegundoGrupo, "Verificação do segundo grupo encontrado no container dos grupos após a seleção para a geração do relatório");

        click(botaoGerarRelatorio);
        click(tipoPdf);
        tempo();
        click(botaoConfirmar);
        tempo();
        tempo();

        List<String> aba = new ArrayList<>(driver.getWindowHandles());
        driver.switchTo().window(aba.get(1));
        driver.getCurrentUrl();
        driver.close();
        driver.switchTo().window(aba.get(0));
        tempo();
    }

    public void campoObrigatorioRelatorio() {
        click(botaoRelatorio);
        click(botaoGerarRelatorio);

        String mensagemObrigatorio = getText(mensagemObrigatorioGrupoNutrientes);
        String mensagemEsperada = "Campo obrigatório";
        Assert.assertEquals(mensagemObrigatorio, mensagemEsperada, "Verificação mensagem de campo obrigatório no campo grupo de nutrientes da tela de geração do relatório");
    }

    private void alterarNomeGrupo(String nome) {
        tempo();
        Actions actions = new Actions(driver);
        actions.moveToElement(driver.findElement(nomeGrupoLinha1)).click().build().perform();
        tempo();
        actions.sendKeys(Keys.BACK_SPACE).build().perform();
        tempo();
        actions.sendKeys(nome).build().perform();
        tempo();
        actions.sendKeys(Keys.ENTER).build().perform();
        tempo();
        click(botaoSalvarAlteracoes);
    }

    private void preencherCampoProcurarTelaInicial(String texto) {
        tempo();
        tempo();
        tempo();
        tempo();
        tempo();
        if (returnClassOpened(botaoAbrirOpcoesControleTelaInicial) && !returnClassOpened(botaoPesquisarFiltro)) {
            click(botaoPesquisarFiltro);
        } else if (!returnClassOpened(botaoAbrirOpcoesControleTelaInicial)){
            click(botaoAbrirOpcoesControleTelaInicial);
            click(botaoPesquisarFiltro);
        }
        clearAndSendKeys(campoProcurar, texto);
        tempo();
        tempo();
    }

    private boolean returnClassOpened(By locator) {
        return driver.findElement(locator).getAttribute("className").contains("opened");
    }

}
