package com.javaseleniumtemplate.pages;

import com.javaseleniumtemplate.bases.PageBase;
import org.openqa.selenium.By;
import org.openqa.selenium.Keys;
import org.openqa.selenium.interactions.Actions;
import org.testng.Assert;

public class PratoXPorcionamentoPage extends PageBase {

    By botaoMenu = By.xpath("//div[@class='bars']");
    By campoPesquisar = By.xpath("//section[@class='zh-container-search-menu']//input[@type='text']");
    By opcaoTelaPratoXProcionamento = By.xpath("//span[text() = 'Prato x Porcionamento']");

    By botaoAdicionar = By.xpath("//div[@class=\"zh-footer-center\"]//li[@class=\"zh-ripple-effect\"]");
    By botaoSalvar = By.xpath("//div[@class=\"zh-footer-right\"]");
    By botaoSalvarAlteracoes = By.xpath("//div[@class=\"zh-footer-right\"]");
    By botaoOk = By.xpath("//section[@class=\"popup-container\"]//div[@class=\"zh-footer-right\"]");
    By botaoOkAlert = By.xpath("//section[@class=\"zh-container-alert\"]//button[@type=\"submit\"]");
    By botaoSim = By.xpath("//section[@class=\"zh-container-alert\"]//footer[@class=\"zh-footer-alert\"]/button[1]");
    By botaoNao = By.xpath("//section[@class=\"zh-container-alert\"]//footer[@class=\"zh-footer-alert\"]/button[2]");
    By botaoVoltar = By.xpath("//div[@class=\"zh-footer-left\"]");
    By botaoCancelar = By.xpath("//div[@class=\"zh-footer-left\"]");
    By botaoAbrirOpcoesControleTelaInicial = By.xpath("//div[@data-ng-if=\"widget.isFloatingControlVisible()\"]//div[@data-zh-floating-control]");
    By botaoPesquisarFiltro = By.xpath("//div[@class=\"control-menu\"]//li[@data-zh-id=\"zh-floating-control-custom-action-1\"]");
    By campoProcurar = By.xpath("//li[@class=\"float-action expandable fix-position-bottom opened\"]//input");

    By campoPrato = By.id("NMPRATO");
    By pratoFeijoadaSimples = By.xpath("//div[@id=\"grid-9999\"]//div[@data-zh-field-name=\"NMPRATO\"]//span[text() = 'FEIJOADA SIMPLES']");
    By pratoFeijoadaMagra = By.xpath("//div[@id=\"grid-9999\"]//div[@data-zh-field-name=\"NMPRATO\"]//span[text() = 'FEIJOADA MAGRA']");
    By pratoArrozBranco = By.xpath("//div[@id=\"grid-9999\"]//div[@data-zh-field-name=\"NMPRATO\"]//span[text() = 'ARROZ BRANCO']");
    By pratoFeijao = By.xpath("//div[@id=\"grid-9999\"]//div[@data-zh-field-name=\"NMPRATO\"]//span[text() = 'FEIJAO']");
    By campoPorcionamento = By.id("NMMEDICASE");
    By porcionamentoColherSopa = By.xpath("//div[@data-zh-id=\"12211565841717605791664\"]//span[text() = '00003 | COLHER DE SOPA']");
    By porcionamentoColherDeCha = By.xpath("//div[@data-zh-id=\"12211565841717605791664\"]//span[text() = '00004 | COLHER DE CHÁ']");
    By campoQuantidade = By.id("VRPESOMED");

    By mensagemAlerta = By.xpath("//section[@class=\"zh-container-alert\"]//div[@class=\"zh-alert-scroll\"]/p");
    By mensagemCantoSuperiorDireito = By.xpath("//*[@class=\"zh-notification-messages\"]//span[@class=\"notification-message-text\"]");
    By mensagemObrigatorioPrato = By.xpath("//div[@data-zh-id=\"12211565844182166941663\"]//div[@class=\"zh-validation\"]/span");
    By mensagemObrigatorioPorcionamento = By.xpath("//div[@data-zh-id=\"12211565841717605791664\"]//div[@class=\"zh-validation\"]/span");
    By mensagemObrigatorioQuantidade = By.xpath("//div[@data-zh-id=\"1221156584141410800667\"]//div[@class=\"zh-validation\"]/span");

    By codigoPratoLinha1 = By.xpath("//div[@id=\"grid-122115658432633229659\"]//div[@class=\"body-content\"]/div[1]//div[@data-zh-field-name=\"CDPRATO\"]/span");
    By nomePratoLinha1 = By.xpath("//div[@id=\"grid-122115658432633229659\"]//div[@class=\"body-content\"]/div[1]//div[@data-zh-field-name=\"NMPRATO\"]/span");
    By unidadePratoLinha1 = By.xpath("//div[@id=\"grid-122115658432633229659\"]//div[@class=\"body-content\"]/div[1]//div[@data-zh-field-name=\"SGUNIDADE\"]/span");

    By nomePratoLinha2 = By.xpath("//div[@id=\"grid-122115658432633229659\"]//div[@class=\"body-content\"]/div[2]//div[@data-zh-field-name=\"NMPRATO\"]/span");

    By botaoExcluirPorcinamentoLinha1 = By.xpath("//div[@id=\"grid-12211565841548132603661\"]//div[@class=\"body-content\"]/div[1]//div[@data-zh-field-name=\"__LEFT_ACTIONS\"]");
    By nomePorcionamentoLinha1 = By.xpath("//div[@id=\"grid-12211565841548132603661\"]//div[@class=\"body-content\"]/div[1]//div[@data-zh-field-name=\"NMMEDICASE\"]/span");
    By quantidadePorcionamentoLinha1 = By.xpath("//div[@id=\"grid-12211565841548132603661\"]//div[@class=\"body-content\"]/div[1]//div[@data-zh-field-name=\"VRPESOMED\"]/span");
    By botaoExcluirPorcinamentoLinha2 = By.xpath("//div[@id=\"grid-12211565841548132603661\"]//div[@class=\"body-content\"]/div[2]//div[@data-zh-field-name=\"__LEFT_ACTIONS\"]");
    By nomePorcionamentoLinha2 = By.xpath("//div[@id=\"grid-12211565841548132603661\"]//div[@class=\"body-content\"]/div[2]//div[@data-zh-field-name=\"NMMEDICASE\"]/span");
    By quantidadePorcionamentoLinha2 = By.xpath("//div[@id=\"grid-12211565841548132603661\"]//div[@class=\"body-content\"]/div[2]//div[@data-zh-field-name=\"VRPESOMED\"]/span");

    public void acessarTela() {
        tempoParaAguardarTelaInicial();
        waitForElement(botaoMenu);
        click(botaoMenu);
        sendKeys(campoPesquisar, "Prato x Porcionamento");
        click(opcaoTelaPratoXProcionamento);
    }

    public void adicionarPratoXPorcionamento() {
        click(botaoAdicionar);
        click(campoPrato);
        click(pratoFeijoadaSimples);
        click(pratoFeijoadaMagra);
        click(botaoOk);
        clicarCampoSelecionarValor(campoPorcionamento, porcionamentoColherSopa);
        sendKeys(campoQuantidade, "5,6");
        click(botaoSalvar);

        String mensagem = getText(mensagemCantoSuperiorDireito);
        String mensagemEsperada = "Registro adicionado com sucesso!";
        Assert.assertEquals(mensagem, mensagemEsperada, "Verificar mensagem de sucesso exibida no canto superior direito após adicionar um prato x porcionamento");
    }

    public void verificarPratoXPorcionamentoAdicionados() {
        //validando dados do primeiro prato adicionado
        preencherCampoProcurarTelaInicial("000000001");
        //valores encontrados para o prato
        String encCodigo = getText(codigoPratoLinha1);
        String encNomePrato = getText(nomePratoLinha1);
        String encUnidade = getText(unidadePratoLinha1);
        //valores esperados para o prato
        String expCodigo = "00.00.00.001";
        String expNomePrato = "FEIJOADA SIMPLES";
        String expUnidade = "KG";
        Assert.assertEquals(encCodigo, expCodigo, "Verificar código do primeiro prato adicionado");
        Assert.assertEquals(encNomePrato, expNomePrato, "Verificar nome do primeiro prato adicionado");
        Assert.assertEquals(encUnidade, expUnidade, "Verificar unidade do primeiro prato adicionado");
        click(nomePratoLinha1);
        //valores encontrados para o porcionamento
        String encNomePorcionamento = getText(nomePorcionamentoLinha1);
        String encQantidade = getText(quantidadePorcionamentoLinha1);
        //valores esperados para o porcionamento
        String expNomePorcionamento = "COLHER DE SOPA";
        String expQuantidade = "5,60";
        Assert.assertEquals(encNomePorcionamento, expNomePorcionamento, "Verificar nome do porcionamento adicionado");
        Assert.assertEquals(encQantidade, expQuantidade, "Verificar quantidade do porcionamento adicionado");
        click(botaoVoltar);

        //validando dados do segundo prato adicionado
        preencherCampoProcurarTelaInicial("000000002");
        //valores encontrados para o prato
        encCodigo = getText(codigoPratoLinha1);
        encNomePrato = getText(nomePratoLinha1);
        encUnidade = getText(unidadePratoLinha1);
        //valores esperados para o prato
        expCodigo = "00.00.00.002";
        expNomePrato = "FEIJOADA MAGRA";
        expUnidade = "KG";
        Assert.assertEquals(encCodigo, expCodigo, "Verificar código do primeiro prato adicionado");
        Assert.assertEquals(encNomePrato, expNomePrato, "Verificar nome do primeiro prato adicionado");
        Assert.assertEquals(encUnidade, expUnidade, "Verificar unidade do primeiro prato adicionado");
        click(nomePratoLinha1);
        //valores encontrados para o porcionamento
        encNomePorcionamento = getText(nomePorcionamentoLinha1);
        encQantidade = getText(quantidadePorcionamentoLinha1);
        //valores esperados para o porcionamento
        expNomePorcionamento = "COLHER DE SOPA";
        expQuantidade = "5,60";
        Assert.assertEquals(encNomePorcionamento, expNomePorcionamento, "Verificar nome do porcionamento adicionado");
        Assert.assertEquals(encQantidade, expQuantidade, "Verificar quantidade do porcionamento adicionado");
        click(botaoVoltar);
    }

    public void excluirPratoXPorcionamentoAdicionados() {
        preencherCampoProcurarTelaInicial("000000001");
        click(nomePratoLinha1);
        click(botaoExcluirPorcinamentoLinha1);
        verificarMensagensExclusaoPorcionamento();
        preencherCampoProcurarTelaInicial("000000002");
        click(nomePratoLinha1);
        click(botaoExcluirPorcinamentoLinha1);
        verificarMensagensExclusaoPorcionamento();
    }

    public void editarQuantidadePorcionamento() {
        preencherCampoProcurarTelaInicial("000000000");
        click(nomePratoLinha1);
        alterarQuantidadePorcionamento("7");
        String mensagem = getText(mensagemCantoSuperiorDireito);
        String mensagemEsperada = "Alteração realizada com sucesso!";
        Assert.assertEquals(mensagem, mensagemEsperada, "Verificar mensagem de sucesso exibida no canto da tela após alterar a quantidade do porcionamento");

        refresh();
        preencherCampoProcurarTelaInicial("000000000");
        click(nomePratoLinha1);
        String quantidade = getText(quantidadePorcionamentoLinha1);
        Assert.assertEquals(quantidade, "7,00", "Verificar se o porcionamento foi salvo corretamente");
        alterarQuantidadePorcionamento("9");
        tempo();
        tempo();
        tempo();
        quantidade = getText(quantidadePorcionamentoLinha1);
        Assert.assertEquals(quantidade, "9,00", "Verificar se o porcionamento foi salvo corretamente, retornando para o valor que estava no início do teste");
    }

    public void adicionarSegundoPorcionamento() {
        preencherCampoProcurarTelaInicial("000000000");
        click(nomePratoLinha1);
        tempo();
        click(botaoAdicionar);
        clicarCampoSelecionarValor(campoPorcionamento, porcionamentoColherDeCha);
        sendKeys(campoQuantidade, "8");
        click(botaoSalvar);

        String mensagem = getText(mensagemCantoSuperiorDireito);
        String mensagemEsperada = "Registro adicionado com sucesso!";
        Assert.assertEquals(mensagem, mensagemEsperada, "Verificar mensagem de sucesso exibida no canto superior direito da tela após adicionar um novo porcionamento");

        //volores encontrados
        String encNomePorcionamento = getText(nomePorcionamentoLinha2);
        String encQuantidade = getText(quantidadePorcionamentoLinha2);
        //valores esperados
        String expNomePorcionamento = "COLHER DE CHÁ";
        String expQuantidade = "8,00";
        Assert.assertEquals(encNomePorcionamento, expNomePorcionamento, "Verificar nome do porcionamento adicionado");
        Assert.assertEquals(encQuantidade, expQuantidade, "Verificar quantidade do porcionamento adicionado");
    }

    public void excluirSegundoPorcionamento() {
        tempo();
        click(botaoExcluirPorcinamentoLinha2);
        verificarMensagensExclusaoPorcionamento();
    }

    public void tentarAdicionarUmPorcionamentoJaExiste() {
        adicionarSegundoPorcionamento();
        tempo();
        click(botaoAdicionar);
        clicarCampoSelecionarValor(campoPorcionamento, porcionamentoColherDeCha);
        sendKeys(campoQuantidade, "11");
        click(botaoSalvar);

        String mensagem = getText(mensagemAlerta);
        String mensagemEsperada = "Impossível adicionar. Registro já existe.";
        Assert.assertEquals(mensagem, mensagemEsperada, "Verificar mensagem exibida na tela após tentar adicionar um porcionamento que já existe");
        click(botaoOkAlert);
        tempo();
        click(botaoCancelar);
        excluirSegundoPorcionamento();

        boolean existSegundoPorcionamento = returnIfElementExists(nomePorcionamentoLinha2);
        Assert.assertEquals(existSegundoPorcionamento, false, "Verificar se o segundo porcionamento foi excluído");
    }

    public void sobreescreverPratoXPorcionamentoJaExistente() {
        tempo();
        tempo();
        click(botaoAdicionar);
        click(campoPrato);
        click(pratoArrozBranco);
        click(botaoOk);
        clicarCampoSelecionarValor(campoPorcionamento, porcionamentoColherSopa);
        sendKeys(campoQuantidade, "5");
        click(botaoSalvar);

        String mensagem = getText(mensagemAlerta);
        String mensagemEsperada = "O porcionamento dos seguintes pratos será sobreposto (ARROZ BRANCO). Deseja continuar?";
        Assert.assertEquals(mensagem, mensagemEsperada, "Verificar mensagem exibida na tela após tentar adicionar um prato x porcionamento que já existe");
        click(botaoSim);

        preencherCampoProcurarTelaInicial("000000005");
        boolean existPrato = returnIfElementExists(nomePratoLinha2);
        Assert.assertEquals(existPrato, false, "Verificar se não foi adicionado um segundo prato após tentar salvar um prato x porcionamento que já existe");
        click(codigoPratoLinha1);
        String quantidade = getText(quantidadePorcionamentoLinha1);
        Assert.assertEquals(quantidade, "5,00", "Verificar se a quantidade do porcionamento foi alterada após adicionar um prato x porcionamento que já existe");
        alterarQuantidadePorcionamento("8,00");
        tempo();
        quantidade = getText(quantidadePorcionamentoLinha1);
        Assert.assertEquals(quantidade, "8,00", "Verificar se a quantidade do porcionamento foi alterada, retornando para o valor que estava no início do teste");
    }

    public void naoSobreescreverPorcionamento() {
        tempo();
        tempo();
        click(botaoAdicionar);
        click(campoPrato);
        click(pratoFeijao);
        click(botaoOk);
        clicarCampoSelecionarValor(campoPorcionamento, porcionamentoColherDeCha);
        sendKeys(campoQuantidade, "6");
        click(botaoSalvar);

        String mensagem = getText(mensagemAlerta);
        String mensagemEsperada = "O porcionamento dos seguintes pratos será sobreposto (FEIJAO). Deseja continuar?";
        Assert.assertEquals(mensagem, mensagemEsperada, "Verificar mensagem exibida na tela após tentar adicionar um prato x porcionamento que já existe");
        click(botaoNao);
        tempo();
        click(botaoCancelar);

        preencherCampoProcurarTelaInicial("000000004");
        tempo();
        tempo();
        String nomePrato1 = getText(nomePratoLinha1);
        String nomePratoEsperado = "FEIJAO";
        Assert.assertEquals(nomePrato1, nomePratoEsperado, "Verificar nome do prato exibido na primeira linha após pesquisar pelo código do prato");
        boolean existPrato = returnIfElementExists(nomePratoLinha2);
        Assert.assertEquals(existPrato, false, "Verificar se não foi adicionado um segundo prato após tentar salvar um prato x porcionamento que já existe");

        click(nomePratoLinha1);
        String quantidade = getText(quantidadePorcionamentoLinha1);
        Assert.assertEquals(quantidade, "7,00", "Verificar se a quantidade do porcionamento não foi alterada após tentar adicionar um prato x porcionamento que já existe");
    }

    public void camposObrigatoriosAddPratoXPorcionamento() {
        click(botaoAdicionar);
        tempo();
        click(botaoSalvar);

        String prato = getText(mensagemObrigatorioPrato);
        String porcionamento = getText(mensagemObrigatorioPorcionamento);
        String quantidade = getText(mensagemObrigatorioQuantidade);
        String mensagemEsperada = "Campo obrigatório";

        Assert.assertEquals(prato, mensagemEsperada, "Verificar mensagem de campo obrigatório no campo prato, para adicionar um novo prato x porcionamento");
        Assert.assertEquals(porcionamento, mensagemEsperada, "Verificar mensagem de campo obrigatório no campo porcionamento, para adicionar um novo prato x porcionamento");
        Assert.assertEquals(quantidade, mensagemEsperada, "Verificar mensagem de campo obrigatório no campo quantidade, para adicionar um novo prato x porcionamento");
        tempo();
        click(botaoCancelar);
    }

    public void campoObrigatorioAddPorcionamento() {
        preencherCampoProcurarTelaInicial("000000000");
        click(codigoPratoLinha1);
        tempo();
        click(botaoAdicionar);
        tempo();
        click(botaoSalvar);

        String porcionamento = getText(mensagemObrigatorioPorcionamento);
        String quantidade = getText(mensagemObrigatorioQuantidade);
        String mensagemEsperada = "Campo obrigatório";
        Assert.assertEquals(porcionamento, mensagemEsperada, "Verificar mensagem de campo obrigatório no campo porcionamento, para adicionar um novo porcionamento");
        Assert.assertEquals(quantidade, mensagemEsperada, "Verificar mensagem de campo obrigatório no campo quantidade, para adicionar um novo porcionamento");
        click(botaoCancelar);
        tempo();
        click(botaoVoltar);
    }

    public void addPratoComPorcionamentoDiferenteDoExistente() {
        tempo();
        tempo();
        click(botaoAdicionar);
        click(campoPrato);
        click(pratoFeijao);
        click(botaoOk);
        clicarCampoSelecionarValor(campoPorcionamento, porcionamentoColherSopa);
        sendKeys(campoQuantidade, "8,5");
        click(botaoSalvar);


        preencherCampoProcurarTelaInicial("000000004");
        String nomePrato1 = getText(nomePratoLinha1);
        String nomePratoEsperado = "FEIJAO";
        Assert.assertEquals(nomePrato1, nomePratoEsperado, "Verificar nome do prato exibido na primeira linha após pesquisar pelo código do prato");
        boolean existPrato = returnIfElementExists(nomePratoLinha2);
        Assert.assertEquals(existPrato, false, "Verificar se não foi adicionado um segundo prato após tentar salvar um prato x porcionamento que já existe");

        click(codigoPratoLinha1);
        String nomePorcionamento = getText(nomePorcionamentoLinha2);
        String quantidade = getText(quantidadePorcionamentoLinha2);
        Assert.assertEquals(nomePorcionamento, "COLHER DE SOPA", "Verificar se o nome do porcionamento foi adicionado corretamente");
        Assert.assertEquals(quantidade, "8,50", "Verificar se a quantidade do porcionamento foi adicionado corretamente");
        excluirSegundoPorcionamento();
    }

    private void alterarQuantidadePorcionamento(String quantidade) {
        Actions actions = new Actions(driver);
        tempo();
        actions.click(driver.findElement(quantidadePorcionamentoLinha1)).build().perform();
        tempo();
        actions.sendKeys(Keys.BACK_SPACE).build().perform();
        tempo();
        actions.sendKeys(quantidade).build().perform();
        tempo();
        actions.sendKeys(Keys.ENTER).build().perform();
        tempo();
        click(botaoSalvarAlteracoes);
        tempo();
    }

    private void verificarMensagensExclusaoPorcionamento() {
        String mensagem = getText(mensagemAlerta);
        String mensagemEsperada = "Deletar o registro?";
        Assert.assertEquals(mensagem, mensagemEsperada, "Verificar mensagem exibida na tela após clicar para excluir um porcionamento");
        click(botaoSim);
        mensagem = getText(mensagemCantoSuperiorDireito);
        mensagemEsperada = "Excluído com sucesso.";
        Assert.assertEquals(mensagem, mensagemEsperada, "Verificar mensagem de excluído com sucesso exibida no canto superior direito da tela");
    }

    private void preencherCampoProcurarTelaInicial(String texto) {
        try {
            Thread.sleep(9000);
        } catch (InterruptedException e) {
            throw new RuntimeException(e);
        }

        if (returnClassOpened(botaoAbrirOpcoesControleTelaInicial) && !returnClassOpened(botaoPesquisarFiltro)) {
            click(botaoPesquisarFiltro);
        } else if (!returnClassOpened(botaoAbrirOpcoesControleTelaInicial)){
            click(botaoAbrirOpcoesControleTelaInicial);
            tempo();
            click(botaoPesquisarFiltro);
        }
        clearAndSendKeys(campoProcurar, texto);
        tempo();
        tempo();
        tempo();
    }

    private boolean returnClassOpened(By locator) {
        return driver.findElement(locator).getAttribute("className").contains("opened");
    }

}
