package com.javaseleniumtemplate.pages;

import com.javaseleniumtemplate.bases.PageBase;
import org.openqa.selenium.By;
import org.openqa.selenium.WebElement;
import org.openqa.selenium.interactions.Actions;
import org.openqa.selenium.support.ui.ExpectedConditions;
import org.openqa.selenium.support.ui.WebDriverWait;
import org.testng.Assert;

import java.util.ArrayList;
import java.util.List;

public class RequisicaoGeralPage extends PageBase {

    By botaoMenu = By.xpath("//div[@class='bars']");
    By campoPesquisar = By.xpath("//section[@class='zh-container-search-menu']//input[@type='text']");
    By selecionarOpcaoRequisicaoGeral = By.xpath("//span[text() = 'Requisição Geral']");

    By campoRelatorio = By.id("REPORT_NAME");
    By relatorioRequisicaoGeral = By.xpath("//div[@data-zh-id=\"41053431436554494115479\"]//div[@class=\"list-items show-select\"]//span[text() = 'Requisição Geral']");
    By relatorioConsolidado = By.xpath("//div[@data-zh-id=\"41053431436554494115479\"]//div[@class=\"list-items show-select\"]//span[text() = 'Requisição Geral - Consolidado']");
    By relatorioProdutoPorServicoPrato = By.xpath("//div[@data-zh-id=\"41053431436554494115479\"]//div[@class=\"list-items show-select\"]//span[text() = 'Requisição Geral - Produto por Serviço/Prato']");
    By relatorioTipoPrato = By.xpath("//div[@data-zh-id=\"41053431436554494115479\"]//div[@class=\"list-items show-select\"]//span[text() = 'Requisição Geral - (por Tipo de Prato)']");

    By campoDataInicial = By.id("PERIODO_START");
    By campoDataFinal = By.id("PERIODO_END");

    By checkTodasUnidades = By.xpath("//label[@for=\"zh-checkbox-T_CDFILIAL\"]//span[@style=\"background-image: none; display: block;\"]");
    By campoUnidade = By.id("CDFILIAL");
    By unidadeDepositoJabaquara = By.xpath("//div[@data-zh-field-name=\"NMFILIAL\"]//span[text() = 'DEPOSITO JABAQUARA']");
    By unidadeDepositoBC111 = By.xpath("//div[@data-zh-field-name=\"NMFILIAL\"]//span[text() = 'DEPOSITO BC 111']");

    By checkTodosGrupoServico = By.xpath("//label[@for=\"zh-checkbox-T_CDGRUPSERV\"]//span[@style=\"background-image: none; display: block;\"]");
    By campoGrupoServico = By.id("CDGRUPSERV");
    By grupoServicoGeral = By.xpath("//div[@data-zh-field-name=\"NMGRUPSERV\"]//span[text() = 'GERAL']");
    By grupoServicoCompras = By.xpath("//div[@data-zh-field-name=\"NMGRUPSERV\"]//span[text() = 'COMPRAS']");
    By grupoServicoEntregas = By.xpath("//div[@data-zh-field-name=\"NMGRUPSERV\"]//span[text() = 'ENTREGAS']");

    By checkTodosServico = By.xpath("//label[@for=\"zh-checkbox-T_CDSERVFILI\"]//span[@style=\"background-image: none; display: block;\"]");
    By campoServico = By.id("CDSERVFILI");
    By servicoAlmocoEspecial = By.xpath("//div[@data-zh-field-name=\"NMSERVICO\"]//span[text() = 'ALMOÇO ESPECIAL']");
    By servicoJantar = By.xpath("//div[@data-zh-field-name=\"NMSERVICO\"]//span[text() = 'JANTAR']");
    By servicoRetiradas = By.xpath("//div[@data-zh-field-name=\"NMSERVICO\"]//span[text() = 'RETIRADAS']");
    By servicoJanta = By.xpath("//div[@data-zh-field-name=\"NMSERVICO\"]//span[text() = 'JANTA']");

    By checkTipoConsumoCardapio = By.xpath("//label[@for=\"zh-checkbox-PRODCARDAPIO\"]//span[@style=\"background-image: none; display: block;\"]");
    By checkTipoConsumoFixo = By.xpath("//label[@for=\"zh-checkbox-PRODFIXO\"]//span[@style=\"background-image: none; display: block;\"]");
    By checkTipoConsumoPerCapita = By.xpath("//label[@for=\"zh-checkbox-PRODPERCAPITA\"]//span[@style=\"background-image: none; display: block;\"]");
    By inputCheckBoxTipoConsumoCardapio = By.id("zh-checkbox-PRODCARDAPIO");
    By inputCheckBoxTipoConsumoFixo = By.id("zh-checkbox-PRODFIXO");
    By inputCheckBoxTipoConsumoPerCapita = By.id("zh-checkbox-PRODPERCAPITA");

    By inputCheckBoxTipoPrato = By.id("zh-checkbox-TCDTIPOPRAT");
    By checkTodosTipoPrato = By.xpath("//label[@for=\"zh-checkbox-TCDTIPOPRAT\"]//span[@style=\"background-image: none; display: block;\"]");
    By campoTipoPrato = By.id("CDTIPOPRAT");
    By tipoPratoArroz = By.xpath("//div[@data-zh-field-name=\"NMTIPOPRAT\"]//span[text() = 'ARROZ']");
    By tipoPratoGuarnicao = By.xpath("//div[@data-zh-field-name=\"NMTIPOPRAT\"]//span[text() = 'GUARNIÇÃO']");
    By tipoPratoPrincipal = By.xpath("//div[@data-zh-field-name=\"NMTIPOPRAT\"]//span[text() = 'PRATO PRINCIPAL']");
    By tipoPratoSobremesa = By.xpath("//div[@data-zh-field-name=\"NMTIPOPRAT\"]//span[text() = 'SOBREMESA']");

    By checkQuebraPagina = By.xpath("//label[@for=\"zh-checkbox-IDQUEBRAPAGINA\"]//span[@style=\"background-image: none; display: block;\"]");
    By checkCalculaRequisicao = By.xpath("//label[@for=\"zh-checkbox-C_PEACRESCIMO\"]//span[@style=\"background-image: none; display: block;\"]");
    By checkImprimirLinhasBranco = By.xpath("//label[@for=\"zh-checkbox-C_NRLINHABRANCA\"]//div[@class=\"zh-box mousetrap zh-ripple-effect\"]");
    By checkArredondarQuantProd = By.xpath("//label[@for=\"zh-checkbox-IDARREDOND\"]//div[@class=\"zh-box mousetrap zh-ripple-effect\"]");
    By inputCheckBoxQuebraPagina = By.id("zh-checkbox-IDQUEBRAPAGINA");
    By inputCheckBoxImprimirLinhasBranco = By.id("zh-checkbox-C_NRLINHABRANCA");
    By inputCheckBoxArredondarQuantProd = By.id("zh-checkbox-IDARREDOND");
    By inputCheckBoxCalculaRequisicaoGeral = By.id("zh-checkbox-C_PEACRESCIMO");

    By botaoOk = By.xpath("//section[@class=\"popup-container\"]//div[@class=\"zh-footer-right\"]");
    By botaoOkAlerta = By.xpath("//section[@class=\"zh-container-alert\"]//button");
    By botaoCampoRelatorio = By.xpath("//div[@id=\"REPORT_NAME\"]//span[@style=\"background-image: none; display: block;\"]");
    By botaoCampoPeriodo = By.xpath("//div[@id=\"PERIODO\"]//span[@zh-icon=\"no-border close-x\"]");
    By botaoCampoProdutoInicial = By.xpath("//div[@id=\"NMPRODUTOINICIAL\"]//span[@style=\"background-image: none; display: block;\"]");
    By botaoCampoProdutoFinal = By.xpath("//div[@id=\"NMPRODUTOFINAL\"]//span[@style=\"background-image: none; display: block;\"]");
    By campoProcurar = By.xpath("//li[@class=\"float-action expandable fix-position-bottom opened\"]//input[@placeholder=\"Procurar\"]");

    By produtoCreosoto = By.xpath("//div[@data-zh-field-name=\"NMPRODUTO\"]//span[text() = 'CREOSOTO']");
    By produtoCarvaoAtivo = By.xpath("//div[@data-zh-field-name=\"NMPRODUTO\"]//span[text() = 'CARVAO ATIVO']");

    By campoNumeroLinhas = By.id("NRLINHABRANCA");
    By campoPercentualAcrescimo = By.id("PEACRESCIMO");

    By ordencacaoAlfabeticaNivel = By.xpath("//div[@data-zh-id=\"41053431417352810785533\"]//label[@for=\"radio-ORDENA-1\"]/div[1]");

    By campoNivel = By.xpath("//div[@data-zh-id=\"41053431433018515005535\"]//div[@class=\"new-select input-text form-input-margin-bottom mousetrap form-control zh-text-align-{{field.align || 'left'}} ng-pristine ng-untouched ng-valid\"]");
    By opcoesNivel = By.xpath("//div[@data-zh-id=\"41053431433018515005535\"]//ul[@class=\"list zh-new-select-list\"]/li");
    By nivelSelecionado = By.xpath("//div[@data-zh-id=\"41053431433018515005535\"]//span[@class=\"current\"]");

    By mensagemAlerta = By.xpath("//section[@class=\"zh-container-alert\"]//p[@class=\"zh-text-alert\"]");
    By mensagemObrigatorioRelatorio = By.xpath("//div[@data-zh-id=\"41053431436554494115479\"]//div[@class=\"zh-validation\"]/span");
    By mensagemObrigatorioUnidade = By.xpath("//div[@data-zh-id=\"41053431430458633485487\"]//div[@class=\"zh-validation\"]/span");
    By mensagemObrigatorioPeriodo = By.xpath("//div[@data-zh-id=\"41053431429914106005494\"]//div[@class=\"zh-validation\"]/span");
    By mensagemObrigatorioGrupoServico = By.xpath("//div[@data-zh-id=\"41053431429203040265500\"]//div[@class=\"zh-validation\"]/span");
    By mensagemObrigatorioServico = By.xpath("//div[@data-zh-id=\"41053431421393410705506\"]//div[@class=\"zh-validation\"]/span");
    By mensagemObrigatorioTipoPrato = By.xpath("//div[@data-zh-id=\"41053431418863211795514\"]//div[@class=\"zh-validation\"]/span");

    By botaoRelatorio = By.xpath("//div[@class=\"zh-footer-right\"]");
    By tipoPdf = By.xpath("//label[@for=\"radio-QR2TYPE-PDF\"]//div[@class=\"zh-circle mousetrap zh-ripple-effect\"]");
    By botaoConfirmar = By.xpath("//section[@class=\"popup-container\"]//div[@class=\"zh-footer-right\"]");

    public void acessarTela() {
        tempoParaAguardarTelaInicial();
        waitForElement(botaoMenu);
        click(botaoMenu);
        sendKeys(campoPesquisar, "Requisição Geral");
        click(selecionarOpcaoRequisicaoGeral);
    }

    public void selecionarRelatorio(String relatorio) {
        if (relatorio.equals("Requisição Geral")) clicarCampoSelecionarValor(campoRelatorio, relatorioRequisicaoGeral);
        else if (relatorio.equals("Requisição Geral - Consolidado")) clicarCampoSelecionarValor(campoRelatorio, relatorioConsolidado);
        else if (relatorio.equals("Requisição Geral - Produto por Serviço/Prato")) clicarCampoSelecionarValor(campoRelatorio, relatorioProdutoPorServicoPrato);
        else if (relatorio.equals("Requisição Geral - (por Tipo de Prato)")) clicarCampoSelecionarValor(campoRelatorio, relatorioTipoPrato);
    }

    public void preencherDatas(String dataInicial, String dataFinal) {
        super.preencherDatas(campoDataInicial, campoDataFinal, dataInicial, dataFinal);
    }

    public void selecionarUnidades() {
        click(checkTodasUnidades);
        click(campoUnidade);
        click(unidadeDepositoJabaquara);
        click(unidadeDepositoBC111);
        click(botaoOk);
    }

    public void selecionarGrupoServico() {
        click(checkTodosGrupoServico);
        click(campoGrupoServico);
        click(grupoServicoGeral);
        click(grupoServicoCompras);
        click(grupoServicoEntregas);
        click(botaoOk);
    }

    public void selecionarServicos() {
        click(checkTodosServico);
        click(campoServico);
        click(servicoAlmocoEspecial);
        click(servicoJantar);
        click(servicoRetiradas);
        click(servicoJanta);
        click(botaoOk);
    }

    public void selecionarTipoPrato() {
        click(checkTodosTipoPrato);
        click(campoTipoPrato);
        click(tipoPratoArroz);
        click(tipoPratoGuarnicao);
        click(tipoPratoPrincipal);
        click(tipoPratoSobremesa);
        click(botaoOk);
    }

    public void selecionarProdutos() {
        javaScriptExecutor.executeScript("document.querySelector(\"body > span > section > section > div.default-window > section.everything > div > section > section > div\").scrollBy(0, 300)");
        click(botaoCampoProdutoInicial);
        sendKeys(campoProcurar, "101110100100");
        click(produtoCreosoto);
        click(botaoCampoProdutoFinal);
        sendKeys(campoProcurar, "101110202400");
        click(produtoCarvaoAtivo);
    }

    public void validarTipoConsumo() {
        boolean cardapio = returnIfElementIsSelected(inputCheckBoxTipoConsumoCardapio);
        boolean fixo = returnIfElementIsSelected(inputCheckBoxTipoConsumoFixo);
        boolean perCapita = returnIfElementIsSelected(inputCheckBoxTipoConsumoPerCapita);
        Assert.assertTrue(cardapio, "Verificar se a opção de tipo consumo 'Cardápio' está selecinada");
        Assert.assertTrue(fixo, "Verificar se a opção de tipo consumo 'Fixo' está selecinada");
        Assert.assertTrue(perCapita, "Verificar se a opção de tipo consumo 'Per Capita' está selecinada");

        click(checkTipoConsumoCardapio);
        click(checkTipoConsumoFixo);
        click(checkTipoConsumoPerCapita);

        cardapio = returnIfElementIsSelected(inputCheckBoxTipoConsumoCardapio);
        fixo = returnIfElementIsSelected(inputCheckBoxTipoConsumoFixo);
        perCapita = returnIfElementIsSelected(inputCheckBoxTipoConsumoPerCapita);
        Assert.assertFalse(cardapio, "Verificar se a opção de tipo consumo 'Cardápio' não está selecinada");
        Assert.assertFalse(fixo, "Verificar se a opção de tipo consumo 'Fixo' não está selecinada");
        Assert.assertFalse(perCapita, "Verificar se a opção de tipo consumo 'Per Capita' não está selecinada");

        click(botaoRelatorio);
        String mensagem = getText(mensagemAlerta);
        String mensagemEsperada = "Deve haver ao menos um tipo de consumo selecionado";
        Assert.assertEquals(mensagem, mensagemEsperada, "Verificar mensagem exibida na tela após tentar gerar o relatório sem selecionar ao menos um tipo de consumo");
        click(botaoOkAlerta);
    }

    public void validarCampoNumeroDeLinhas() {
        boolean opcaoImprimirLinhasBranco = returnIfElementIsSelected(inputCheckBoxImprimirLinhasBranco);
        boolean campoNrLinhas = returnIfElementIsEnabled(campoNumeroLinhas);
        Assert.assertFalse(opcaoImprimirLinhasBranco, "Verificar se a opção 'Imprimir Linhas em Branco' não está selecionada");
        Assert.assertFalse(campoNrLinhas, "Verificar se o campo 'Nr. Linhas' está desabilitado");

        click(checkImprimirLinhasBranco);
        opcaoImprimirLinhasBranco = returnIfElementIsSelected(inputCheckBoxImprimirLinhasBranco);
        campoNrLinhas = returnIfElementIsEnabled(campoNumeroLinhas);
        Assert.assertTrue(opcaoImprimirLinhasBranco, "Verificar se a opção 'Imprimir Linhas em Branco' está selecionada");
        Assert.assertTrue(campoNrLinhas, "Verificar se o campo 'Nr. Linhas' está habilitado");

        sendKeys(campoNumeroLinhas, "15");
        String quantLinhas = getValue(campoNumeroLinhas);
        Assert.assertEquals(quantLinhas, "15", "Verificar valor inserido no campo 'Nr. Linhas'");
    }

    public void validarCampoPercentualAcrescimo() {
        boolean calculaRequisicaoGeral = returnIfElementIsSelected(inputCheckBoxCalculaRequisicaoGeral);
        boolean percentualAcrescimo = returnIfElementIsEnabled(campoPercentualAcrescimo);
        Assert.assertTrue(calculaRequisicaoGeral, "Verificar se a opção 'Calcula Requisição Geral' está selecionada");
        Assert.assertTrue(percentualAcrescimo, "Verificar se o campo 'Percentual de Acréscimo' está habilitado");

        clearAndSendKeys(campoPercentualAcrescimo, "3,75");
        Actions actions = new Actions(driver);
        actions.moveToElement(driver.findElement(campoPercentualAcrescimo), 0, 50).click().build().perform();
        String percentual = getValue(campoPercentualAcrescimo);
        Assert.assertEquals(percentual, "3,750", "Verificar valor inserido no campo 'Percentual de Acréscimo'");

        click(checkCalculaRequisicao);
        calculaRequisicaoGeral = returnIfElementIsSelected(inputCheckBoxCalculaRequisicaoGeral);
        percentualAcrescimo = returnIfElementIsEnabled(campoPercentualAcrescimo);
        Assert.assertFalse(calculaRequisicaoGeral, "Verificar se a opção 'Calcula Requisição Geral' não está selecionada");
        Assert.assertFalse(percentualAcrescimo, "Verificar se o campo 'Percentual de Acréscimo' está desabilitado");
    }

    public void verificarNiveis() {
        tempo();
        tempo();
        javaScriptExecutor.executeScript("document.querySelector(\"body > span > section > section > div.default-window > section.everything > div > section > section > div\").scrollBy(0, 300)");
        tempo();
        click(ordencacaoAlfabeticaNivel);
        tempo();
        click(campoNivel);
        tempo();

        long timeout = 0;
        List<WebElement> results = (new WebDriverWait(driver, timeout))
                .until(ExpectedConditions
                        .visibilityOfAllElementsLocatedBy(
                                opcoesNivel
                        )
                );

        Assert.assertEquals(results.size(), 6, "Verificar a quantidade de níveis para totalização");

        int valorNivel = 0;
        for (WebElement nivel : results) {
            String niv = "Nível " + valorNivel;
            Assert.assertEquals(nivel.getText(), niv);
            valorNivel++;
        }

        results.get(3).click();
        Assert.assertEquals(getText(nivelSelecionado), "Nível 3", "Verificar valor do nível de totalização selecionado");
    }

    public void mensagemServicoNaoUtilizaRequisicaoRetirada() {
        click(botaoRelatorio);
        click(tipoPdf);
        click(botaoConfirmar);

        String mensagem = getText(mensagemAlerta);
        String mensagemEsperada = "Existe(m) serviço(s) que não utiliza(m) requisição/retirada por prato.";
        Assert.assertEquals(mensagem, mensagemEsperada, "Verificar mensagem de alerta exibida na tela ao tentar gerar o relatório de tipo de prato com todos os serviços selecionados");
        click(botaoOkAlerta);
    }

    public void verificarCampoTipoPratoHabilitado(String relatorio) {
        boolean tipoPrato = returnIfElementIsEnabled(inputCheckBoxTipoPrato);
        if (relatorio.equals("Requisição Geral - (por Tipo de Prato)"))
            Assert.assertTrue(tipoPrato, "Verificar se o campo tipo de prato está habilitado com o relatório: " + relatorio);
        else
            Assert.assertFalse(tipoPrato, "Verificar se o campo tipo prato está desabilitado com o relatório " + relatorio);
    }

    public void verificarOpcoesDeExibicaoHabilitadosPelosRelatorios(String relatorio) {
        boolean quebraPagina = returnIfElementIsEnabled(inputCheckBoxQuebraPagina);
        boolean imprimirLinhasBranco = returnIfElementIsEnabled(inputCheckBoxImprimirLinhasBranco);
        boolean arredondarQuantProd = returnIfElementIsEnabled(inputCheckBoxArredondarQuantProd);
        boolean calcularRequisicaoGeral = returnIfElementIsEnabled(inputCheckBoxCalculaRequisicaoGeral);

        if (relatorio.equals("Requisição Geral")) Assert.assertTrue(quebraPagina, "Verificar se a opção 'Quebra de Página' está habilitada com o relatório " + relatorio);
        else Assert.assertFalse(quebraPagina, "Verificar se a opção 'Quebra de Página' está desabilitada com o relatório " + relatorio);

        Assert.assertTrue(imprimirLinhasBranco, "Verificar se a opção 'Imprimir Linhas em Branco' está habilitada com o relatório " + relatorio);
        Assert.assertTrue(arredondarQuantProd, "Verificar se a opção 'Arredonda Qtde. dos Produtos' está habilitada com o relatório " + relatorio);
        Assert.assertTrue(calcularRequisicaoGeral, "Verificar se a opção 'Calcula Requisição Geral' está habilitada com o relatório " + relatorio);
    }

    public void verificarCheckBoxDasOpcoesDeExibicaoDosRelatorios() {
        boolean quebraPagina = returnIfElementIsSelected(inputCheckBoxQuebraPagina);
        boolean imprimirLinhasBranco = returnIfElementIsSelected(inputCheckBoxImprimirLinhasBranco);
        boolean arredondaQuantProd = returnIfElementIsSelected(inputCheckBoxArredondarQuantProd);
        boolean calculaRequisicaoGeral = returnIfElementIsSelected(inputCheckBoxCalculaRequisicaoGeral);
        Assert.assertTrue(quebraPagina, "Verificar se o check-box da opção 'Quebra de Página' está selecionado");
        Assert.assertFalse(imprimirLinhasBranco, "Verificar se o check-box da opção 'Imprimir Linhas em Branco' está selecionado");
        Assert.assertFalse(arredondaQuantProd, "Verificar se o check-box da opção 'Arredonda Qtde. dos Produtos' está selecionado");
        Assert.assertTrue(calculaRequisicaoGeral, "Verificar se o check-box da opção 'Calcula Requisição Geral' está selecionado");

        click(checkQuebraPagina);
        click(checkImprimirLinhasBranco);
        click(checkArredondarQuantProd);
        click(checkCalculaRequisicao);

        quebraPagina = returnIfElementIsSelected(inputCheckBoxQuebraPagina);
        imprimirLinhasBranco = returnIfElementIsSelected(inputCheckBoxImprimirLinhasBranco);
        arredondaQuantProd = returnIfElementIsSelected(inputCheckBoxArredondarQuantProd);
        calculaRequisicaoGeral = returnIfElementIsSelected(inputCheckBoxCalculaRequisicaoGeral);
        Assert.assertFalse(quebraPagina, "Verificar se o check-box da opção 'Quebra de Página' está selecionado");
        Assert.assertTrue(imprimirLinhasBranco, "Verificar se o check-box da opção 'Imprimir Linhas em Branco' está selecionado");
        Assert.assertTrue(arredondaQuantProd, "Verificar se o check-box da opção 'Arredonda Qtde. dos Produtos' está selecionado");
        Assert.assertFalse(calculaRequisicaoGeral, "Verificar se o check-box da opção 'Calcula Requisição Geral' está selecionado");
    }

    public void camposObrigatorios() {
        click(botaoCampoRelatorio);
        click(checkTodasUnidades);
        click(botaoCampoPeriodo);
        click(checkTodosGrupoServico);
        click(checkTodosServico);
        click(botaoRelatorio);

        String relatorio = getText(mensagemObrigatorioRelatorio);
        String unidade = getText(mensagemObrigatorioUnidade);
        String periodo = getText(mensagemObrigatorioPeriodo);
        String grupoServico = getText(mensagemObrigatorioGrupoServico);
        String servico = getText(mensagemObrigatorioServico);

        String mensagemEsperada = "Campo obrigatório";
        Assert.assertEquals(relatorio, mensagemEsperada, "Verificar mensagem de campo obrigatório no campo 'Relatório'");
        Assert.assertEquals(unidade, mensagemEsperada, "Verificar mensagem de campo obrigatório no campo 'Unidade'");
        Assert.assertEquals(periodo, mensagemEsperada, "Verificar mensagem de campo obrigatório no campo 'Período'");
        Assert.assertEquals(grupoServico, mensagemEsperada, "Verificar mensagem de campo obrigatório no campo 'Grupo de Serviço'");
        Assert.assertEquals(servico, mensagemEsperada, "Verificar mensagem de campo obrigatório no campo 'Serviço'");

        refresh();
        selecionarRelatorio("Requisição Geral - (por Tipo de Prato)");
        click(checkTodosTipoPrato);
        click(botaoRelatorio);
        String tipoPrato = getText(mensagemObrigatorioTipoPrato);
        Assert.assertEquals(tipoPrato, mensagemEsperada, "Verificar mensagem de campo obrigatório no campo 'Tipo de Prato'");
    }

    public void gerarRelatorio() {
        click(botaoRelatorio);
        click(tipoPdf);
        click(botaoConfirmar);
        fecharGuiaDoRelatorio();
    }

    private void fecharGuiaDoRelatorio() {
        tempo();
        tempo();
        String winHandleBefore = driver.getWindowHandle();
        List<String> aba = new ArrayList<>(driver.getWindowHandles());
        driver.switchTo().window(aba.get(1));
        driver.getCurrentUrl();
        driver.close();
        driver.switchTo().window(winHandleBefore);
    }

}
