package com.javaseleniumtemplate.pages;

import com.javaseleniumtemplate.bases.PageBase;
import org.openqa.selenium.By;
import org.openqa.selenium.Keys;
import org.openqa.selenium.interactions.Actions;
import org.testng.Assert;

public class RetiradaPlanejamentoPage extends PageBase {

    By botaoMenu = By.xpath("//div[@class='bars']");
    By campoPesquisar = By.xpath("//section[@class='zh-container-search-menu']//input[@type='text']");
    By telaRetiradaPlanejamento = By.xpath("//span[text() = 'Retirada (Planejamento)']");

    By campoUnidadeFiltroIni = By.id("NMFILIAL");
    By unidadeDepositoJabaquara = By.xpath("//div[@data-zh-id=\"249399591780718684326\"]//span[text() = '0002 | DEPOSITO JABAQUARA']");
    By unidadeDepositoBc111 = By.xpath("//div[@data-zh-id=\"249399591780718684326\"]//span[text() = '0003 | DEPOSITO BC 111']");

    By campoServicoFiltroIni = By.id("NMSERVICO");
    By servicoAlmocoEspecial = By.xpath("//div[@data-zh-id=\"2493995912104281832707\"]//span[text() = '00002 | ALMOÇO ESPECIAL']");
    By servicoAlmoco = By.xpath("//div[@data-zh-id=\"2493995912104281832707\"]//span[text() = '00003 | ALMOÇO']");

    By servicoFiltroNovaRetirada = By.xpath("//div[@data-zh-id=\"24939959139354777442723\"]//div[@id=\"NMSERVICO\"]//span[@class=\"value\"]");
    By dataRetiradaFiltroNovaRetirada = By.id("DTRETIRADA");
    By dataCardapioFiltroNovaRetirada = By.id("DTCARDAPIO");

    By campoDataRetiradaFiltroIni = By.id("DTRETIRADA");
    By cabecalhoCustoTotal = By.xpath("//aside[@data-zh-id=\"24939959136746819682701\"]//span[@class=\"stripe-value-custo\"]");

    By botaoAplicarFiltro = By.xpath("//section[@class=\"popup-container\"]//div[@class=\"zh-footer-right\"]");
    By botaoCampoUnidadeFiltroIni = By.xpath("//div[@data-zh-id=\"249399591780718684326\"]//span[@style=\"background-image: none; display: block;\"]");
    By botaoCampoDataRetFiltroIni = By.xpath("//div[@data-zh-id=\"24939959137243723022711\"]//span[@style=\"background-image: none; display: block;\"]");
    By botaoSim = By.xpath("//section[@class=\"zh-container-alert\"]//button[1]");
    By botaoConfirmar = By.xpath("//section[@class=\"popup-container\"]//div[@class=\"zh-footer-right\"]");
    By botaoSalvar = By.xpath("//div[@class=\"zh-footer-right\"]");
    By botaoSalvarAlteracoes = By.xpath("//div[@class=\"zh-footer-right\"]");
    By botaoOkAlerta = By.xpath("//section[@class=\"zh-container-alert\"]//button");
    By botaoVoltar = By.xpath("//div[@class=\"zh-footer-left\"]");
    By botaoExcluir = By.xpath("//div[@class=\"zh-footer-center\"]//li");
    By botaoAdicionar = By.xpath("//div[@class=\"zh-footer-center\"]//li");
    By botaoCancelarFiltroRomaneio = By.xpath("//section[@class=\"popup-container\"]//div[@class=\"zh-footer-left\"]");
    By botaoCampoAlmoxarifado = By.xpath("//div[@id=\"DSALMOXARIFE\"]//span[@style=\"background-image: none; display: block;\"]");
    By botaoCampoProdutoFormTipoPrato = By.xpath("//div[@id=\"NMPRODUTO\"]//span[@style=\"background-image: none; display: block;\"]");
    By botaoCampoProdutoFormProduto = By.xpath("//div[@id=\"NMPRODUTO\"]//span[@style=\"background-image: none; display: block;\"]");
    By botaoCampoTipoRetiradaFormTipoPrato = By.xpath("//div[@data-zh-id=\"24939959115513766182841\"]//span[@style=\"background-image: none; display: block;\"]");
    By botaoCampoTipoRetiradaFormProduto = By.xpath("//div[@data-zh-id=\"24939959115513766182841\"]//span[@style=\"background-image: none; display: block;\"]");
    By botaoAcoes = By.xpath("//div[@class=\"zh-footer-right\"]");

    By campoTipoPrato = By.id("NMTIPOPRAT");
    By tipoPratoGuarnicao = By.xpath("//div[@data-zh-id=\"2493995913344106762829\"]//span[text() = '02 | GUARNIÇÃO']");
    By campoPrato = By.id("NMPRATO");
    By pratoStrogonoff = By.xpath("//div[@data-zh-id=\"249399591592251592832\"]//span[text() = '00.00.00.003 | STROGONOFF TRANSPORTADA']");
    By campoProduto = By.id("NMPRODUTO");
    By produtoPoteVidroAmbar = By.xpath("//div[@data-zh-field-name=\"NMPRODUTO\"]//span[text() = 'POTE VIDRO AMBAR DE 3KG COM TAMPA GL 18MM DIN']");
    By produtoOleoCopaiba = By.xpath("//div[@data-zh-id=\"24939959129913704632836\"]//span[text() = '1.01.1.1.01.003.00 | OLEO DE COPAIBA']");
    By produtoCaixaPapelao = By.xpath("//div[@data-zh-field-name=\"NMPRODUTO\"]//span[text() = 'CAIXA DE PAPELAO NATUBABY']");
    By campoQuantExtra = By.id("QTEXTRARETI");
    By campoQuantDevolvida = By.id("QTDEVOLVRETI");
    By campoQuantConsumida = By.id("QTRETIRADA");
    By campoTipoRetirada = By.id("NMTIPORETI");
    By tipoRetiradaConsumoEmpresa = By.xpath("//div[@data-zh-id=\"24939959115513766182841\"]//span[text() = '02 | CONSUMO DE EMPRESA']");

    By campoAlmoxarifado = By.id("DSALMOXARIFE");
    By almoxarifadoMateriaPrimaQuarentena = By.xpath("//div[@data-zh-id=\"0\"]//div[@class=\"list-items show-select\"]//span[text() = '1 | MATERIA PRIMA QUARENTENA']");
    By almoxarifadoMateriaPrimaAprov = By.xpath("//div[@data-zh-id=\"0\"]//div[@class=\"list-items show-select\"]//span[text() = '2 | MATERIA PRIMA APROVADO']");
    By almoxarifadoMaterialEmbAprov = By.xpath("//div[@data-zh-id=\"0\"]//div[@class=\"list-items show-select\"]//span[text() = '4 | MATERIAL EMBALAGEM APROVADO']");
    By campoLote = By.id("NRLOTEESTQ");
    By loteOleoCopaiba = By.xpath("//div[@data-zh-id=\"0\"]//div[@class=\"list-items show-select\"]//span[text() = \"22092082 | 31/12/2099 | 99.999,00\"]");
    By lotePoteVidroAmbar = By.xpath("//div[@data-zh-id=\"0\"]//span[text() = '19060215 | 01/06/2029 | 96,00']");
    By loteLactose10345 = By.xpath("//div[@data-zh-id=\"0\"]//div[@class=\"list-items show-select\"]//span[text() = \"21082346 | 29/11/2022 | 10.345,00\"]");
    By loteLactose10346 = By.xpath("//div[@data-zh-id=\"0\"]//div[@class=\"list-items show-select\"]//span[text() = \"21082346 | 29/11/2022 | 10.346,00\"]");
    By loteCopoMedida11880 = By.xpath("//div[@data-zh-id=\"0\"]//span[text() = '19090391 | 01/10/2024 | 11.880,00']");
    By loteCopoMedida11991 = By.xpath("//div[@data-zh-id=\"0\"]//span[text() = '19090391 | 01/10/2024 | 11.991,00']");
    By loteCaixaPapelao = By.xpath("//div[@data-zh-id=\"0\"]//span[text() = '19060213 | 07/12/2021 | 250,00']");

    By checkBoxRetTipoPrato1 = By.xpath("//div[@id=\"grid-2493995917964005972871\"]//div[@class=\"body-content\"]/div[1]//div[@data-zh-field-name=\"__CHECKBOX\"]");
    By codigoRetTipoPrato1 = By.xpath("//div[@id=\"grid-2493995917964005972871\"]//div[@class=\"body-content\"]/div[1]//div[@data-zh-field-name=\"CDTIPOPRAT\"]/span");
    By nomeRetTipoPrato1 = By.xpath("//div[@id=\"grid-2493995917964005972871\"]//div[@class=\"body-content\"]/div[1]//div[@data-zh-field-name=\"NMTIPOPRAT\"]/span");
    By codigoPratoRetTipoPrato1 = By.xpath("//div[@id=\"grid-2493995917964005972871\"]//div[@class=\"body-content\"]/div[1]//div[@data-zh-field-name=\"CDPRATO\"]/span");
    By nomePratoRetTipoPrato1 = By.xpath("//div[@id=\"grid-2493995917964005972871\"]//div[@class=\"body-content\"]/div[1]//div[@data-zh-field-name=\"NMPRATO\"]/span");

    By checkBoxProdutoRetTipoPrato1 = By.xpath("//div[@id=\"grid-24939959122776413062891\"]//div[@class=\"body-content\"]/div[1]//div[@data-zh-field-name=\"__CHECKBOX\"]");
    By codigoProdutoRetTipoPrato1 = By.xpath("//div[@id=\"grid-24939959122776413062891\"]//div[@class=\"body-content\"]/div[1]//div[@data-zh-field-name=\"CDARVPROD\"]/span");
    By nomeProdutoRetTipoPrato1 = By.xpath("//div[@id=\"grid-24939959122776413062891\"]//div[@class=\"body-content\"]/div[1]//div[@data-zh-field-name=\"NMPRODUTO\"]/span");
    By unidadeProdutoRetTipoPrato1 = By.xpath("//div[@id=\"grid-24939959122776413062891\"]//div[@class=\"body-content\"]/div[1]//div[@data-zh-field-name=\"SGUNIDADE\"]/span");
    By quantPrevistaProdutoRetTipoPrato1 = By.xpath("//div[@id=\"grid-24939959122776413062891\"]//div[@class=\"body-content\"]/div[1]//div[@data-zh-field-name=\"QTPREVISRETI\"]/span");
    By quantExtraProdutoRetTipoPrato1 = By.xpath("//div[@id=\"grid-24939959122776413062891\"]//div[@class=\"body-content\"]/div[1]//div[@data-zh-field-name=\"QTEXTRARETI\"]/span");
    By quantDevolvidaProdutoRetTipoPrato1 = By.xpath("//div[@id=\"grid-24939959122776413062891\"]//div[@class=\"body-content\"]/div[1]//div[@data-zh-field-name=\"QTDEVOLVRETI\"]/span");
    By quantConsumidaProdutoRetTipoPrato1 = By.xpath("//div[@id=\"grid-24939959122776413062891\"]//div[@class=\"body-content\"]/div[1]//div[@data-zh-field-name=\"QTRETIRADA\"]/span");
    By valorUnitarioProdutoRetTipoPrato1 = By.xpath("//div[@id=\"grid-24939959122776413062891\"]//div[@class=\"body-content\"]/div[1]//div[@data-zh-field-name=\"VRUNILANCTO\"]/span");
    By tipoRetiradaProdutoRetTipoPrato1 = By.xpath("//div[@id=\"grid-24939959122776413062891\"]//div[@class=\"body-content\"]/div[1]//div[@data-zh-field-name=\"NMTIPORETI\"]/span");
    By statusProdutoRetTipoPrato1 = By.xpath("//div[@id=\"grid-24939959122776413062891\"]//div[@class=\"body-content\"]/div[1]//div[@data-zh-field-name=\"IDEVOLESTOQ\"]/span");
    By almoxarifadoProdutoRetTipoPrato1 = By.xpath("//div[@id=\"grid-24939959122776413062891\"]//div[@class=\"body-content\"]/div[1]//div[@data-zh-field-name=\"CDALMOXARIFE\"]/span");
    By localizacaoProdutoRetTipoPrato1 = By.xpath("//div[@id=\"grid-24939959122776413062891\"]//div[@class=\"body-content\"]/div[1]//div[@data-zh-field-name=\"CDLOCALESTOQ\"]/span");
    By loteProdutoRetTipoPrato1 = By.xpath("//div[@id=\"grid-24939959122776413062891\"]//div[@class=\"body-content\"]/div[1]//div[@data-zh-field-name=\"NRLOTEESTQ\"]/span");
    By checkBoxProdutoRetTipoPrato2 = By.xpath("//div[@id=\"grid-24939959122776413062891\"]//div[@class=\"body-content\"]/div[2]//div[@data-zh-field-name=\"__CHECKBOX\"]");
    By codigoProdutoRetTipoPrato2 = By.xpath("//div[@id=\"grid-24939959122776413062891\"]//div[@class=\"body-content\"]/div[2]//div[@data-zh-field-name=\"CDARVPROD\"]/span");
    By nomeProdutoRetTipoPrato2 = By.xpath("//div[@id=\"grid-24939959122776413062891\"]//div[@class=\"body-content\"]/div[2]//div[@data-zh-field-name=\"NMPRODUTO\"]/span");
    By unidadeProdutoRetTipoPrato2 = By.xpath("//div[@id=\"grid-24939959122776413062891\"]//div[@class=\"body-content\"]/div[2]//div[@data-zh-field-name=\"SGUNIDADE\"]/span");
    By quantPrevistaProdutoRetTipoPrato2 = By.xpath("//div[@id=\"grid-24939959122776413062891\"]//div[@class=\"body-content\"]/div[2]//div[@data-zh-field-name=\"QTPREVISRETI\"]/span");
    By quantExtraProdutoRetTipoPrato2 = By.xpath("//div[@id=\"grid-24939959122776413062891\"]//div[@class=\"body-content\"]/div[2]//div[@data-zh-field-name=\"QTEXTRARETI\"]/span");
    By quantDevolvidaProdutoRetTipoPrato2 = By.xpath("//div[@id=\"grid-24939959122776413062891\"]//div[@class=\"body-content\"]/div[2]//div[@data-zh-field-name=\"QTDEVOLVRETI\"]/span");
    By quantConsumidaProdutoRetTipoPrato2 = By.xpath("//div[@id=\"grid-24939959122776413062891\"]//div[@class=\"body-content\"]/div[2]//div[@data-zh-field-name=\"QTRETIRADA\"]/span");
    By valorUnitarioProdutoRetTipoPrato2 = By.xpath("//div[@id=\"grid-24939959122776413062891\"]//div[@class=\"body-content\"]/div[2]//div[@data-zh-field-name=\"VRUNILANCTO\"]/span");
    By tipoRetiradaProdutoRetTipoPrato2 = By.xpath("//div[@id=\"grid-24939959122776413062891\"]//div[@class=\"body-content\"]/div[2]//div[@data-zh-field-name=\"NMTIPORETI\"]/span");
    By statusProdutoRetTipoPrato2 = By.xpath("//div[@id=\"grid-24939959122776413062891\"]//div[@class=\"body-content\"]/div[2]//div[@data-zh-field-name=\"IDEVOLESTOQ\"]/span");
    By almoxarifadoProdutoRetTipoPrato2 = By.xpath("//div[@id=\"grid-24939959122776413062891\"]//div[@class=\"body-content\"]/div[2]//div[@data-zh-field-name=\"CDALMOXARIFE\"]/span");
    By localizacaoProdutoRetTipoPrato2 = By.xpath("//div[@id=\"grid-24939959122776413062891\"]//div[@class=\"body-content\"]/div[2]//div[@data-zh-field-name=\"CDLOCALESTOQ\"]/span");
    By loteProdutoRetTipoPrato2 = By.xpath("//div[@id=\"grid-24939959122776413062891\"]//div[@class=\"body-content\"]/div[2]//div[@data-zh-field-name=\"NRLOTEESTQ\"]/span");

    By produtoBissulfatoPotassio = By.xpath("//div[@data-zh-field-name=\"NMPRODUTO\"]//span[text() = 'BISSULFATO DE POTASSIO']");
    By produtoCanfora = By.xpath("//div[@data-zh-field-name=\"NMPRODUTO\"]//span[text() = 'CANFORA']");
    By tipoRetiradaConsumoProducao = By.xpath("//div[@data-zh-id=\"24939959115513766182841\"]//div[@class=\"list-items show-select\"]//span[text() = '01 | CONSUMO DE PRODUÇÃO']");
    By almoxarifadoProdutoAcabado = By.xpath("//div[@data-zh-id=\"0\"]//span[text() = '1 | PRODUTO ACABADO APROVADO']");
    By loteBissulfatoPotassio9991Almox3 = By.xpath("//div[@data-zh-id=\"0\"]//span[text() = '3 | 31/12/2099 | 9.991,00']");
    By loteBissulfatoPotassio9999Almox145 = By.xpath("//div[@data-zh-id=\"0\"]//span[text() = '145 | 31/12/2099 | 9.999,00']");
    By loteCanfora9999 = By.xpath("//div[@data-zh-id=\"0\"]//span[text() = '201 | 31/12/2099 | 9.999,00']");
    By loteOleoAmendoas19995 = By.xpath("//div[@data-zh-id=\"0\"]//span[text() = '111 | 31/12/2099 | 19.995,00']");
    By loteOleoAmendoas19992 = By.xpath("//div[@data-zh-id=\"0\"]//span[text() = '111 | 31/12/2099 | 19.992,50']");
    By loteQuerosene9924 = By.xpath("//div[@data-zh-id=\"0\"]//span[text() = '200 | 31/12/2099 | 9.924,00']");
    By loteQuerosene9969 = By.xpath("//div[@data-zh-id=\"0\"]//span[text() = '200 | 31/12/2099 | 9.969,00']");

    By checkBoxRetProduto1 = By.xpath("//div[@id=\"grid-2493995912567898485180\"]//div[@class=\"body-content\"]/div[1]//div[@data-zh-field-name=\"__CHECKBOX\"]");
    By codigoProdutoRetProduto1 = By.xpath("//div[@id=\"grid-2493995912567898485180\"]//div[@class=\"body-content\"]/div[1]//div[@data-zh-field-name=\"CDARVPROD\"]/span");
    By nomeProdutoRetProduto1 = By.xpath("//div[@id=\"grid-2493995912567898485180\"]//div[@class=\"body-content\"]/div[1]//div[@data-zh-field-name=\"NMPRODUTO\"]/span");
    By unidadeRetProduto1 = By.xpath("//div[@id=\"grid-2493995912567898485180\"]//div[@class=\"body-content\"]/div[1]//div[@data-zh-field-name=\"SGUNIDADE\"]/span");
    By quantPrevistaRetProduto1 = By.xpath("//div[@id=\"grid-2493995912567898485180\"]//div[@class=\"body-content\"]/div[1]//div[@data-zh-field-name=\"QTPREVISRETI\"]/span");
    By quantExtraRetProduto1 = By.xpath("//div[@id=\"grid-2493995912567898485180\"]//div[@class=\"body-content\"]/div[1]//div[@data-zh-field-name=\"QTEXTRARETI\"]/span");
    By quantDevolvidaRetProduto1 = By.xpath("//div[@id=\"grid-2493995912567898485180\"]//div[@class=\"body-content\"]/div[1]//div[@data-zh-field-name=\"QTDEVOLVRETI\"]/span");
    By quantConsumidaRetProduto1 = By.xpath("//div[@id=\"grid-2493995912567898485180\"]//div[@class=\"body-content\"]/div[1]//div[@data-zh-field-name=\"QTRETIRADA\"]/span");
    By valorUnitarioRetProduto1 = By.xpath("//div[@id=\"grid-2493995912567898485180\"]//div[@class=\"body-content\"]/div[1]//div[@data-zh-field-name=\"VRUNILANCTO\"]/span");
    By tipoRetiradaRetProduto1 = By.xpath("//div[@id=\"grid-2493995912567898485180\"]//div[@class=\"body-content\"]/div[1]//div[@data-zh-field-name=\"NMTIPORETI\"]/span");
    By statusRetProduto1 = By.xpath("//div[@id=\"grid-2493995912567898485180\"]//div[@class=\"body-content\"]/div[1]//div[@data-zh-field-name=\"IDEVOLESTOQ\"]/span");
    By codigoAlmoxRetProduto1 = By.xpath("//div[@id=\"grid-2493995912567898485180\"]//div[@class=\"body-content\"]/div[1]//div[@data-zh-field-name=\"CDALMOXARIFE\"]/span");
    By localizacaoRetProduto1 = By.xpath("//div[@id=\"grid-2493995912567898485180\"]//div[@class=\"body-content\"]/div[1]//div[@data-zh-field-name=\"CDLOCALESTOQ\"]/span");
    By loteRetProduto1 = By.xpath("//div[@id=\"grid-2493995912567898485180\"]//div[@class=\"body-content\"]/div[1]//div[@data-zh-field-name=\"NRLOTEESTQ\"]/span");
    By checkBoxRetProduto2 = By.xpath("//div[@id=\"grid-2493995912567898485180\"]//div[@class=\"body-content\"]/div[2]//div[@data-zh-field-name=\"__CHECKBOX\"]");
    By codigoProdutoRetProduto2 = By.xpath("//div[@id=\"grid-2493995912567898485180\"]//div[@class=\"body-content\"]/div[2]//div[@data-zh-field-name=\"CDARVPROD\"]/span");
    By nomeProdutoRetProduto2 = By.xpath("//div[@id=\"grid-2493995912567898485180\"]//div[@class=\"body-content\"]/div[2]//div[@data-zh-field-name=\"NMPRODUTO\"]/span");
    By unidadeRetProduto2 = By.xpath("//div[@id=\"grid-2493995912567898485180\"]//div[@class=\"body-content\"]/div[2]//div[@data-zh-field-name=\"SGUNIDADE\"]/span");
    By quantPrevistaRetProduto2 = By.xpath("//div[@id=\"grid-2493995912567898485180\"]//div[@class=\"body-content\"]/div[2]//div[@data-zh-field-name=\"QTPREVISRETI\"]/span");
    By quantExtraRetProduto2 = By.xpath("//div[@id=\"grid-2493995912567898485180\"]//div[@class=\"body-content\"]/div[2]//div[@data-zh-field-name=\"QTEXTRARETI\"]/span");
    By quantDevolvidaRetProduto2 = By.xpath("//div[@id=\"grid-2493995912567898485180\"]//div[@class=\"body-content\"]/div[2]//div[@data-zh-field-name=\"QTDEVOLVRETI\"]/span");
    By quantConsumidaRetProduto2 = By.xpath("//div[@id=\"grid-2493995912567898485180\"]//div[@class=\"body-content\"]/div[2]//div[@data-zh-field-name=\"QTRETIRADA\"]/span");
    By valorUnitarioRetProduto2 = By.xpath("//div[@id=\"grid-2493995912567898485180\"]//div[@class=\"body-content\"]/div[2]//div[@data-zh-field-name=\"VRUNILANCTO\"]/span");
    By tipoRetiradaRetProduto2 = By.xpath("//div[@id=\"grid-2493995912567898485180\"]//div[@class=\"body-content\"]/div[2]//div[@data-zh-field-name=\"NMTIPORETI\"]/span");
    By statusRetProduto2 = By.xpath("//div[@id=\"grid-2493995912567898485180\"]//div[@class=\"body-content\"]/div[2]//div[@data-zh-field-name=\"IDEVOLESTOQ\"]/span");
    By codigoAlmoxRetProduto2 = By.xpath("//div[@id=\"grid-2493995912567898485180\"]//div[@class=\"body-content\"]/div[2]//div[@data-zh-field-name=\"CDALMOXARIFE\"]/span");
    By localizacaoRetProduto2 = By.xpath("//div[@id=\"grid-2493995912567898485180\"]//div[@class=\"body-content\"]/div[2]//div[@data-zh-field-name=\"CDLOCALESTOQ\"]/span");
    By loteRetProduto2 = By.xpath("//div[@id=\"grid-2493995912567898485180\"]//div[@class=\"body-content\"]/div[2]//div[@data-zh-field-name=\"NRLOTEESTQ\"]/span");

    By acaoNovaRetirada = By.xpath("//section[@class=\"popup-content\"]//ul[@class=\"zh-actions-list\"]//span[text() = 'Nova Retirada']");
    By acaoExcluirRetirada = By.xpath("//section[@class=\"popup-content\"]//ul[@class=\"zh-actions-list\"]//span[text() = 'Excluir Retirada']");
    By acaoExibirRomaneio = By.xpath("//section[@class=\"popup-content\"]//ul[@class=\"zh-actions-list\"]//span[text() = 'Exibir Romaneio']");
    By acaoExibirResumo = By.xpath("//section[@class=\"popup-content\"]//ul[@class=\"zh-actions-list\"]//span[text() = 'Exibir Resumo']");
    By acaoAtualizarEstoque = By.xpath("//section[@class=\"popup-content\"]//ul[@class=\"zh-actions-list\"]//span[text() = 'Atualizar Estoque']");

    By botaoCampoDataDeRetirada = By.xpath("//div[@data-zh-id=\"24939959119517570372769\"]//span[@style=\"background-image: none; display: block;\"]");
    By botaoCampoDataAteRetirada = By.xpath("//div[@data-zh-id=\"2493995915463418302770\"]//span[@style=\"background-image: none; display: block;\"]");
    By botaoCampoDataDeCardapio = By.xpath("//div[@data-zh-id=\"24939959134720090112771\"]//span[@style=\"background-image: none; display: block;\"]");
    By botaoCampoDataAteCardapio = By.xpath("//div[@data-zh-id=\"24939959116485330492772\"]//span[@style=\"background-image: none; display: block;\"]");
    By campoDataDeRetiradaFiltroRomaneio = By.id("DTRETIRADAINI");
    By campoDataAteRetiradaFiltroRomaneiro = By.id("DTRETIRADAFIN");
    By campoDataDeCardapioFiltroRomaneio = By.id("DTCARDAPIOINI");
    By campoDataAteCardapioFiltroRomaneio = By.id("DTCARDAPIOFIN");

    By codigoServicoRomaneio1 = By.xpath("//div[@id=\"grid-24939959114454336042751\"]//div[@class=\"body-content\"]/div[1]//div[@data-zh-field-name=\"CDSERVFILI\"]/span");
    By nomeServicoRomaneio1 = By.xpath("//div[@id=\"grid-24939959114454336042751\"]//div[@class=\"body-content\"]/div[1]//div[@data-zh-field-name=\"NMSERVICO\"]/span");
    By dataRetiradaRomaneio1 = By.xpath("//div[@id=\"grid-24939959114454336042751\"]//div[@class=\"body-content\"]/div[1]//div[@data-zh-field-name=\"DTRETIRADA\"]/span");
    By dataCardapioRomaneio1 = By.xpath("//div[@id=\"grid-24939959114454336042751\"]//div[@class=\"body-content\"]/div[1]//div[@data-zh-field-name=\"DTCARDAPIO\"]/span");
    By numeroRequisicaoRomaneio1 = By.xpath("//div[@id=\"grid-24939959114454336042751\"]//div[@class=\"body-content\"]/div[1]//div[@data-zh-field-name=\"NRREQUEXTRRE\"]/span");
    By numeroLancamentoRomaneio1 = By.xpath("//div[@id=\"grid-24939959114454336042751\"]//div[@class=\"body-content\"]/div[1]//div[@data-zh-field-name=\"NRLANCESTQ\"]/span");

    By codigoProdutoExibirResumo1 = By.xpath("//div[@id=\"grid-24939959133770068892777\"]//div[@class=\"body-content\"]/div[1]//div[@data-zh-field-name=\"CDARVPROD\"]//span");
    By nomeExibirResumo1 = By.xpath("//div[@id=\"grid-24939959133770068892777\"]//div[@class=\"body-content\"]/div[1]//div[@data-zh-field-name=\"NMPRODUTO\"]//span");
    By unidadeExibirResumo1 = By.xpath("//div[@id=\"grid-24939959133770068892777\"]//div[@class=\"body-content\"]/div[1]//div[@data-zh-field-name=\"SGUNIDADE\"]//span");
    By quantPrevistaExibirResumo1 = By.xpath("//div[@id=\"grid-24939959133770068892777\"]//div[@class=\"body-content\"]/div[1]//div[@data-zh-field-name=\"QTPREVISRETI\"]//span");
    By quantExtraExibirResumo1 = By.xpath("//div[@id=\"grid-24939959133770068892777\"]//div[@class=\"body-content\"]/div[1]//div[@data-zh-field-name=\"QTEXTRARETI\"]//span");
    By quantDevolvidaExibirResumo1 = By.xpath("//div[@id=\"grid-24939959133770068892777\"]//div[@class=\"body-content\"]/div[1]//div[@data-zh-field-name=\"QTDEVOLVRETI\"]//span");
    By quantConsumidaExibirResumo1 = By.xpath("//div[@id=\"grid-24939959133770068892777\"]//div[@class=\"body-content\"]/div[1]//div[@data-zh-field-name=\"QTRETIRADA\"]//span");
    By custoExibirResumo1 = By.xpath("//div[@id=\"grid-24939959133770068892777\"]//div[@class=\"body-content\"]/div[1]//div[@data-zh-field-name=\"CUSTO\"]//span");
    By quantEstoqueExibirResumo1 = By.xpath("//div[@id=\"grid-24939959133770068892777\"]//div[@class=\"body-content\"]/div[1]//div[@data-zh-field-name=\"QTESTDIACON\"]//span");

    By campoProcurar = By.xpath("//li[@class=\"float-action expandable fix-position-bottom opened\"]//input[@placeholder=\"Procurar\"]");
    By mensagemAlerta = By.xpath("//section[@class=\"zh-container-alert\"]//p[@class=\"zh-text-alert\"]");
    By mensagemObrigatorioUnidadeFiltroIni = By.xpath("//div[@data-zh-id=\"249399591780718684326\"]//div[@class=\"zh-validation\"]/span");
    By mensagemObrigatorioServicoFiltroIni = By.xpath("//div[@data-zh-id=\"2493995912104281832707\"]//div[@class=\"zh-validation\"]/span");
    By mensagemObrigatorioDataRetirada = By.xpath("//div[@data-zh-id=\"24939959137243723022711\"]//div[@class=\"zh-validation\"]/span");
    By mensagemObrigatorioDataCardapio = By.xpath("//div[@data-zh-id=\"24939959126392878562713\"]//div[@class=\"zh-validation\"]/span");
    By mensagemObrigatorioTipoPrato = By.xpath("//div[@data-zh-id=\"2493995913344106762829\"]//div[@class=\"zh-validation\"]/span");
    By mensagemObrigatorioPrato = By.xpath("//div[@data-zh-id=\"249399591592251592832\"]//div[@class=\"zh-validation\"]/span");
    By mensagemObrigatorioProduto = By.xpath("//div[@data-zh-id=\"24939959129913704632836\"]//div[@class=\"zh-validation\"]/span");
    By mensagemObrigatorioQuantExtra = By.xpath("//div[@data-zh-id=\"24939959115300353362845\"]//div[@class=\"zh-validation\"]/span");
    By mensagemObrigatorioQuantDevolvida = By.xpath("//div[@data-zh-id=\"2493995918287041042848\"]//div[@class=\"zh-validation\"]/span");
    By mensagemObrigatorioQuantConsumida = By.xpath("//div[@data-zh-id=\"24939959142298878422851\"]//div[@class=\"zh-validation\"]/span");
    By mensagemObrigatorioTipoPratoRetirada = By.xpath("//div[@data-zh-id=\"24939959115513766182841\"]//div[@class=\"zh-validation\"]/span");
    By mensagemObrigatorioAlmoxarifado = By.xpath("//section[@class=\"zh-field-group\"]//div[@class=\"field-group-rows\"]//div[@class=\"row\"][2]//div[@data-zh-id=\"0\"]//div[@class=\"zh-validation\"]//span[@class=\"zh-validation-error\"]");
    By mensagemObrigatorioLote = By.xpath("//section[@class=\"zh-field-group\"]//div[@class=\"field-group-rows\"]//div[@class=\"row\"][3]//div[@data-zh-id=\"0\"]//div[@class=\"zh-validation\"]//span[@class=\"zh-validation-error\"]");

    public void acessarTela() {
        tempoParaAguardarTelaInicial();
        waitForElement(botaoMenu);
        click(botaoMenu);
        sendKeys(campoPesquisar, "Retirada (Planejamento)");
        click(telaRetiradaPlanejamento);
    }

    public void preencherFiltroInicial(String tipoRetirada, String data) {
        tempo();
        tempo();
        tempo();
        //selecionar unidade e serviço
        if (tipoRetirada.equals("Tipo de Prato")) {
            clicarCampoSelecionarValor(campoUnidadeFiltroIni, unidadeDepositoJabaquara);
            tempo();
            clicarCampoSelecionarValor(campoServicoFiltroIni, servicoAlmocoEspecial);
        } else if (tipoRetirada.equals("Produto")) {
            clicarCampoSelecionarValor(campoUnidadeFiltroIni, unidadeDepositoBc111);
            tempo();
            clicarCampoSelecionarValor(campoServicoFiltroIni, servicoAlmoco);
        }

        tempo();
        click(botaoCampoDataRetFiltroIni);
        click(campoDataRetiradaFiltroIni);
        sendKeys(campoDataRetiradaFiltroIni, data);
        click(campoUnidadeFiltroIni);
        click(botaoAplicarFiltro);
    }

    public void alertaNaoExisteRetirada() {
        String mensagem = getText(mensagemAlerta);
        String mensagemEsperada = "Não existe retirada para os dados informados.\nDeseja realizar uma nova retirada?";
        Assert.assertEquals(mensagem, mensagemEsperada, "Verificar mensagem exibida na tela após aplicar o filtro em uma data que não possuí retirada");
        click(botaoSim);
    }

    public void confirmarFiltroNovaRetirada(String tipoRetirada, String data) {
        String encServico = getText(servicoFiltroNovaRetirada);
        String encDataRetirada = getValue(dataRetiradaFiltroNovaRetirada);
        String encDataCardapio = getValue(dataCardapioFiltroNovaRetirada);

        String expServico = "";
        if (tipoRetirada.equals("Tipo de Prato")) expServico = "00002 | ALMOÇO ESPECIAL";
        else if (tipoRetirada.equals("Produto")) expServico = "00003 | ALMOÇO";

        Assert.assertEquals(encServico, expServico, "Verificar serviço preenchido no campo 'serviço' do filtro nova retirada, após aplicar o filtro inicial");
        Assert.assertEquals(encDataRetirada, data, "Verificar serviço preenchido no campo 'data retirada' do filtro nova retirada, após aplicar o filtro inicial");
        Assert.assertEquals(encDataCardapio, data, "Verificar serviço preenchido no campo 'data cardápio' do filtro nova retirada, após aplicar o filtro inicial");
        click(botaoConfirmar);
    }

    public void adicionarRetTipoPratoGuarnicaoProdOleoCopaiba() {
        clicarCampoSelecionarValor(campoTipoPrato, tipoPratoGuarnicao);
        clicarCampoSelecionarValor(campoPrato, pratoStrogonoff);
        clicarCampoSelecionarValor(campoProduto, produtoOleoCopaiba);
        clearAndSendKeys(campoQuantExtra, "8");
        clearAndSendKeys(campoQuantDevolvida, "2");
        clicarCampoSelecionarValor(campoTipoRetirada, tipoRetiradaConsumoEmpresa);
        click(botaoSalvar);

        tempo();
        tempo();
        clicarCampoSelecionarValor(campoAlmoxarifado, almoxarifadoMateriaPrimaAprov);
        tempo();
        clicarCampoSelecionarValor(campoLote, loteOleoCopaiba);
        click(botaoConfirmar);

        String mensagem = getText(mensagemAlerta);
        String mensagemEsperada = "Retirada incluída com sucesso.";
        Assert.assertEquals(mensagem, mensagemEsperada, "Verificar mensagem exibida na tela após adicionar uma retirada de tipo de prato");
        click(botaoOkAlerta);
    }

    public void verificarRetTipoPratoGuarnicaoProdOleoCopaiba() {
        //valores encontrados
        String encCodigoTipoPrato = getText(codigoRetTipoPrato1);
        String encNomeTipoPrato = getText(nomeRetTipoPrato1);
        String encCodigoPrato = getText(codigoPratoRetTipoPrato1);
        String encNomePrato = getText(nomePratoRetTipoPrato1);

        //valores esperados
        String expCodigoTipoPrato = "02";
        String expNomeTipoPrato = "GUARNIÇÃO";
        String expCodigoPrato = "00.00.00.003";
        String expNomePrato = "STROGONOFF TRANSPORTADA";
        Assert.assertEquals(encCodigoTipoPrato, expCodigoTipoPrato, "Verificar 'código do tipo de prato' adicionado na retirada");
        Assert.assertEquals(encNomeTipoPrato, expNomeTipoPrato, "Verificar 'nome do tipo de prato' adicionado na retirada");
        Assert.assertEquals(encCodigoPrato, expCodigoPrato, "Verificar 'código do prato' adicionado na retirada");
        Assert.assertEquals(encNomePrato, expNomePrato, "Verificar 'nome do prato' adicionado na retirada");
    }

    public void verificarProdutoRetTipoPratoGuarnicaoProdOleoCopaiba() {
        click(nomePratoRetTipoPrato1);
        //valores encontrados
        String encCodigo = getText(codigoProdutoRetTipoPrato1);
        String encNome = getText(nomeProdutoRetTipoPrato1);
        String encUnidade = getText(unidadeProdutoRetTipoPrato1);
        String encQuantPrevista = getText(quantPrevistaProdutoRetTipoPrato1);
        String encQuantExtra = getText(quantExtraProdutoRetTipoPrato1);
        String encQuantDevolvida = getText(quantDevolvidaProdutoRetTipoPrato1);
        String encQuantConsumida = getText(quantConsumidaProdutoRetTipoPrato1);
        String encValorUnitario = getText(valorUnitarioProdutoRetTipoPrato1);
        String encTipoRetirada = getText(tipoRetiradaProdutoRetTipoPrato1);
        javaScriptExecutor.executeScript("document.querySelector(\"#grid-24939959122776413062891 > div.body-scroll-control\").scrollBy(2000, 0)");
        String encStatus = getText(statusProdutoRetTipoPrato1);
        String encAlmoxarifado = getText(almoxarifadoProdutoRetTipoPrato1);
        String encLocalizacao = getText(localizacaoProdutoRetTipoPrato1);
        String encLote = getText(loteProdutoRetTipoPrato1);

        //valores esperados
        String expCodigo = "1.01.1.1.01.003.00";
        String expNome = "OLEO DE COPAIBA";
        String expUnidade = "L";
        String expQuantPrevista = "0,00000";
        String expQuantExtra = "8,00000";
        String expQuantDevolvida = "2,00000";
        String expQuantConsumida = "6,00000";
        String expValorUnitario = "5,00000";
        String expTipoRetirada = "CONSUMO DE EMPRESA";
        String expStatus = "Evoluído";
        String expAlmoxarifado = "2";
        String expLocalizacao = "";
        String expLote = "22092082";

        Assert.assertEquals(encCodigo, expCodigo, "Verificar 'código' do produto adicionado na retirada de tipo de prato");
        Assert.assertEquals(encNome, expNome, "Verificar 'nome' do produto adicionado na retirada de tipo de prato");
        Assert.assertEquals(encUnidade, expUnidade, "Verificar 'unidade' do produto adicionado na retirada de tipo de prato");
        Assert.assertEquals(encQuantPrevista, expQuantPrevista, "Verificar 'qt prevista' do produto adicionado na retirada de tipo de prato");
        Assert.assertEquals(encQuantExtra, expQuantExtra, "Verificar 'qt extra' do produto adicionado na retirada de tipo de prato");
        Assert.assertEquals(encQuantDevolvida, expQuantDevolvida, "Verificar 'qt devolvida' do produto adicionado na retirada de tipo de prato");
        Assert.assertEquals(encQuantConsumida, expQuantConsumida, "Verificar 'qt consumida' do produto adicionado na retirada de tipo de prato");
        Assert.assertEquals(encValorUnitario, expValorUnitario, "Verificar 'valor unit' do produto adicionado na retirada de tipo de prato");
        Assert.assertEquals(encTipoRetirada, expTipoRetirada, "Verificar 'tipo de retirada' do produto adicionado na retirada de tipo de prato");
        Assert.assertEquals(encStatus, expStatus, "Verificar 'status' do produto adicionado na retirada de tipo de prato");
        Assert.assertEquals(encAlmoxarifado, expAlmoxarifado, "Verificar 'almoxarifado' do produto adicionado na retirada de tipo de prato");
        Assert.assertEquals(encLocalizacao, expLocalizacao, "Verificar 'localização' do produto adicionado na retirada de tipo de prato");
        Assert.assertEquals(encLote, expLote, "Verificar 'lote' do produto adicionado na retirada de tipo de prato");
        click(botaoVoltar);
    }

    public void verificarCustoTotalAposAddRetTipoPrato() {
        float custoTotal = Float.parseFloat(getText(cabecalhoCustoTotal).replace(",", "."));
        click(nomePratoRetTipoPrato1);

        float quantConsumida = Float.parseFloat(getText(quantConsumidaProdutoRetTipoPrato1).replace(",", "."));
        float valorUnitario = Float.parseFloat(getText(valorUnitarioProdutoRetTipoPrato1).replace(",", "."));
        boolean calculoCorreto = (custoTotal == quantConsumida * valorUnitario);
        Assert.assertTrue(calculoCorreto, "Verificar se o cálculo do custo total da retirada está correto. Verificação realiza após adicionar o primeiro tipo prato na retirada");
        click(botaoVoltar);
    }

    public void excluirRetiradaTipoPrato() {
        click(checkBoxRetTipoPrato1);
        click(botaoExcluir);

        String mensagem = getText(mensagemAlerta);
        String mensagemEsperada = "Deletar o(s) registro(s)?";
        Assert.assertEquals(mensagem, mensagemEsperada, "Verificar mensagem exibida na tela após clicar para excluir a retirada de tipo de prato");
        click(botaoSim);

        mensagem = getText(mensagemAlerta);
        mensagemEsperada = "Retirada excluída com sucesso.";
        Assert.assertEquals(mensagem, mensagemEsperada, "Verificar mensagem exibida na tela após a exclusão da retirada de tipo de prato");
        click(botaoOkAlerta);
    }

    public void editarQuntidadeProdutoPeloInLine() {
        click(nomePratoRetTipoPrato1);
        alterarValorDoCampo(quantExtraProdutoRetTipoPrato1, "10");
        tempo();
        clicarCampoSelecionarValor(campoAlmoxarifado, almoxarifadoMateriaPrimaQuarentena);
        tempo();
        tempo();
        clicarCampoSelecionarValor(campoLote, loteLactose10345);
        click(botaoConfirmar);
        tempo();
        alterarValorDoCampo(quantDevolvidaProdutoRetTipoPrato1, "6");
        tempo();
        clicarCampoSelecionarValor(campoAlmoxarifado, almoxarifadoMateriaPrimaQuarentena);
        tempo();
        clicarCampoSelecionarValor(campoLote, loteLactose10345);
        click(botaoConfirmar);
        tempo();
        click(botaoSalvarAlteracoes);

        String mensagem = getText(mensagemAlerta);
        String mensagemEsperada = "Salvo com sucesso.";
        Assert.assertEquals(mensagem, mensagemEsperada, "Verificar mensagem exibida na tela após salvar as alterações das quantidade do produto pelo inline");
        click(botaoOkAlerta);
    }

    public void editarQuntidadeProdutoPeloInLineReturnValoresIniciais() {
        click(nomePratoRetTipoPrato1);
        alterarValorDoCampo(quantDevolvidaProdutoRetTipoPrato1, "0");
        tempo();
        clicarCampoSelecionarValor(campoAlmoxarifado, almoxarifadoMateriaPrimaQuarentena);
        tempo();
        tempo();
        clicarCampoSelecionarValor(campoLote, loteLactose10346);
        click(botaoConfirmar);
        tempo();
        alterarValorDoCampo(quantExtraProdutoRetTipoPrato1, "5");
        tempo();
        clicarCampoSelecionarValor(campoAlmoxarifado, almoxarifadoMateriaPrimaQuarentena);
        tempo();
        clicarCampoSelecionarValor(campoLote, loteLactose10346);
        tempo();
        click(botaoConfirmar);
        tempo();
        click(botaoSalvarAlteracoes);

        String mensagem = getText(mensagemAlerta);
        String mensagemEsperada = "Salvo com sucesso.";
        Assert.assertEquals(mensagem, mensagemEsperada, "Verificar mensagem exibida na tela após salvar as alterações das quantidade do produto pelo inline");
        click(botaoOkAlerta);
    }

    public void tentarLancarQuantDevolMaiorQueExtra() {
        alterarValorDoCampo(quantDevolvidaProdutoRetTipoPrato1, "100");

        String mensagem = getText(mensagemAlerta);
        String mensagemEsperada = "Quantidade devolvida não pode ser maior que a quantidade requisitada.";
        Assert.assertEquals(mensagem, mensagemEsperada, "Verificar mensagem exibida na tela após tentar adicionar uma quantidade devolvida maior que a extra");
        click(botaoOkAlerta);

        //valores encontrados
        String encQuantPrevista = getText(quantPrevistaProdutoRetTipoPrato1);
        String encQuantExtra = getText(quantExtraProdutoRetTipoPrato1);
        String encQuantDevolvida = getText(quantDevolvidaProdutoRetTipoPrato1);
        String encQuantConsumida = getText(quantConsumidaProdutoRetTipoPrato1);

        //valores esperados
        String expQuantPrevista = "0,00000";
        String expQuantExtra = "7,00000";
        String expQuantDevolvida = "0,00000";
        String expQuantConsumida = "7,00000";
        Assert.assertEquals(encQuantPrevista, expQuantPrevista, "Verificar valor da 'quantidade prevista' após tentar lançar uma quantidade devolvida maior que a extra");
        Assert.assertEquals(encQuantExtra, expQuantExtra, "Verificar valor da 'quantidade extra' após tentar lançar uma quantidade devolvida maior que a extra");
        Assert.assertEquals(encQuantDevolvida, expQuantDevolvida, "Verificar valor da 'quantidade devolvida' após tentar lançar uma quantidade devolvida maior que a extra");
        Assert.assertEquals(encQuantConsumida, expQuantConsumida, "Verificar valor da 'quantidade consumida' após tentar lançar uma quantidade devolvida maior que a extra");
    }

    public void verificarQuantidadesAposEdicaoInLine(int sequenciaEdicao) {
        //valores encontrados
        String encQuantPrevista = getText(quantPrevistaProdutoRetTipoPrato1);
        String encQuantExtra = getText(quantExtraProdutoRetTipoPrato1);
        String encQuantDevolvida = getText(quantDevolvidaProdutoRetTipoPrato1);
        String encQuantConsumida = getText(quantConsumidaProdutoRetTipoPrato1);

        //valores esperados
        String expQuantPrevista = "";
        String expQuantExtra = "";
        String expQuantDevolvida = "";
        String expQuantConsumida = "";

        if (sequenciaEdicao == 1) {
            expQuantPrevista = "0,00000";
            expQuantExtra = "10,00000";
            expQuantDevolvida = "6,00000";
            expQuantConsumida = "4,00000";
        } else if (sequenciaEdicao == 2) {
            expQuantPrevista = "0,00000";
            expQuantExtra = "5,00000";
            expQuantDevolvida = "0,00000";
            expQuantConsumida = "5,00000";
        }

        Assert.assertEquals(encQuantPrevista, expQuantPrevista, "Verificar valor da 'qt prevista' após a " + sequenciaEdicao + "ª alteração das quantidades por meio do inline");
        Assert.assertEquals(encQuantExtra, expQuantExtra, "Verificar valor da 'qt extra' após a " + sequenciaEdicao + "ª alteração das quantidades por meio do inline");
        Assert.assertEquals(encQuantDevolvida, expQuantDevolvida, "Verificar valor da 'qt devolvida' após a" + sequenciaEdicao + "ª alteração das quantidades por meio do inline");
        Assert.assertEquals(encQuantConsumida, expQuantConsumida, "Verificar valor da 'qt consumida' após a " + sequenciaEdicao + "ª alteração das quantidades por meio do inline");
        click(botaoVoltar);

        boolean custoTotalCorreto = verificarCustoTotalRetTipoPratoApenas1Prod();
        Assert.assertTrue(custoTotalCorreto, "Verificar se após a " + sequenciaEdicao + "ª edição das quantidades do produto, o custo total foi recalculado corretamente");
    }

    public void adicionarSegundoProdutoRetTipoPrato() {
        tempo();
        click(nomePratoRetTipoPrato1);
        tempo();
        click(botaoAdicionar);

        click(botaoCampoProdutoFormTipoPrato);
        sendKeys(campoProcurar, "POTE VIDRO AMBAR DE 3KG COM TAMPA GL 18MM DIN");
        click(produtoPoteVidroAmbar);
        clearAndSendKeys(campoQuantExtra, "9");
        clearAndSendKeys(campoQuantDevolvida, "2,5");
        click(botaoSalvar);

        tempo();
        tempo();
        clicarCampoSelecionarValor(campoAlmoxarifado, almoxarifadoMaterialEmbAprov);
        tempo();
        clicarCampoSelecionarValor(campoLote, lotePoteVidroAmbar);
        click(botaoConfirmar);

        String mensagem = getText(mensagemAlerta);
        String mensagemEsperada = "Salvo com sucesso.";
        Assert.assertEquals(mensagem, mensagemEsperada, "Verificar mensagem exibida na tela após adicionar um segundo produto à retirada de tipo de prato");
        click(botaoOkAlerta);
    }

    public void verificarSegundoProdutoAddRqtTipoPrato() {
        String quantProdutos = javaScriptExecutor.executeScript("return document.querySelector(\"#grid-24939959122776413062891 > div.body > div\").childElementCount").toString();
        Assert.assertEquals(quantProdutos, "2", "Verificar quantidade de produtos no tipo de prato, após adicionar o segundo produto");

        //valores encontrados
        String encCodigo = getText(codigoProdutoRetTipoPrato2);
        String encNome = getText(nomeProdutoRetTipoPrato2);
        String encUnidade = getText(unidadeProdutoRetTipoPrato2);
        String encQuantPrevista = getText(quantPrevistaProdutoRetTipoPrato2);
        String encQuantExtra = getText(quantExtraProdutoRetTipoPrato2);
        String encQuantDevolvida = getText(quantDevolvidaProdutoRetTipoPrato2);
        javaScriptExecutor.executeScript("document.querySelector(\"#grid-24939959122776413062891 > div.body-scroll-control\").scrollBy(2000, 0)");
        String encQuantConsumida = getText(quantConsumidaProdutoRetTipoPrato2);
        String encValorUnitario = getText(valorUnitarioProdutoRetTipoPrato2);
        String encTipoRetirada = getText(tipoRetiradaProdutoRetTipoPrato2);
        String encStatus = getText(statusProdutoRetTipoPrato2);
        String encAlmoxarifado = getText(almoxarifadoProdutoRetTipoPrato2);
        String encLocalizacao = getText(localizacaoProdutoRetTipoPrato2);
        String encLote = getText(loteProdutoRetTipoPrato2);

        //valores esperados
        String expCodigo = "2.01.2.2.01.011.00";
        String expNome = "POTE VIDRO AMBAR DE 3KG COM TAMPA GL 18MM DIN";
        String expUnidade = "UN";
        String expQuantPrevista = "0,00000";
        String expQuantExtra = "9,00000";
        String expQuantDevolvida = "2,50000";
        String expQuantConsumida = "6,50000";
        String expValorUnitario = "44,50000";
        String expTipoRetirada = "CONSUMO DE PRODUÇÃO";
        String expStatus = "Evoluído";
        String expAlmoxarifado = "4";
        String expLocalizacao = "";
        String expLote = "19060215";

        Assert.assertEquals(encCodigo, expCodigo, "Verificar 'código' do segundo produto adicionado na retirada de tipo de prato");
        Assert.assertEquals(encNome, expNome, "Verificar 'nome' do segundo produto adicionado na retirada de tipo de prato");
        Assert.assertEquals(encUnidade, expUnidade, "Verificar 'unidade' do segundo produto adicionado na retirada de tipo de prato");
        Assert.assertEquals(encQuantPrevista, expQuantPrevista, "Verificar 'qt prevista' do segundo produto adicionado na retirada de tipo de prato");
        Assert.assertEquals(encQuantExtra, expQuantExtra, "Verificar 'qt extra' do segundo produto adicionado na retirada de tipo de prato");
        Assert.assertEquals(encQuantDevolvida, expQuantDevolvida, "Verificar 'qt devolvida' do segundo produto adicionado na retirada de tipo de prato");
        Assert.assertEquals(encQuantConsumida, expQuantConsumida, "Verificar 'qt consumida' do segundo produto adicionado na retirada de tipo de prato");
        Assert.assertEquals(encValorUnitario, expValorUnitario, "Verificar 'valor unit' do segundo produto adicionado na retirada de tipo de prato");
        Assert.assertEquals(encTipoRetirada, expTipoRetirada, "Verificar 'tipo de retirada' do segundo produto adicionado na retirada de tipo de prato");
        Assert.assertEquals(encStatus, expStatus, "Verificar 'status' do segundo produto adicionado na retirada de tipo de prato");
        Assert.assertEquals(encAlmoxarifado, expAlmoxarifado, "Verificar 'almoxarifado' do segundo produto adicionado na retirada de tipo de prato");
        Assert.assertEquals(encLocalizacao, expLocalizacao, "Verificar 'localização' do segundo produto adicionado na retirada de tipo de prato");
        Assert.assertEquals(encLote, expLote, "Verificar 'lote' do segundo produto adicionado na retirada de tipo de prato");
        click(botaoVoltar);

        float calculoCustoTotal = verificarCustoTotalRetTipoPratoPara2Prod();
        click(botaoVoltar);
        float custoTotalExibido = Float.parseFloat(getText(cabecalhoCustoTotal).replace(",", "."));
        Assert.assertEquals(calculoCustoTotal, custoTotalExibido, "Verificar se o cálculo do custo total da retirada está correto após adicionar um segundo produto ao tipo de prato");
    }

    public void editarQuantDevolProdComQuantPrevista() {
        click(nomePratoRetTipoPrato1);
        alterarValorDoCampo(quantDevolvidaProdutoRetTipoPrato2, "111");
        tempo();
        tempo();
        clicarCampoSelecionarValor(campoAlmoxarifado, almoxarifadoMaterialEmbAprov);
        clicarCampoSelecionarValor(campoLote, loteCopoMedida11880);
        click(botaoConfirmar);
        tempo();
        click(botaoSalvarAlteracoes);
        tempo();
        click(botaoOkAlerta);
        verificarQuantAposAlteracaoComQuantPrevRetTipoPrato("Valores Alterados");

        alterarValorDoCampo(quantConsumidaProdutoRetTipoPrato2, "120");
        tempo();
        tempo();
        clicarCampoSelecionarValor(campoAlmoxarifado, almoxarifadoMaterialEmbAprov);
        clicarCampoSelecionarValor(campoLote, loteCopoMedida11991);
        click(botaoConfirmar);
        tempo();
        click(botaoSalvarAlteracoes);
        tempo();
        click(botaoOkAlerta);
        verificarQuantAposAlteracaoComQuantPrevRetTipoPrato("Valores início teste");
    }

    public void tentarLancarQuantDevolMaiorQueReqEmProdQuantPrevista() {
        tempo();
        alterarValorDoCampo(quantDevolvidaProdutoRetTipoPrato1, "300");

        String mensagem = getText(mensagemAlerta);
        String mensagemEsperada = "Quantidade devolvida não pode ser maior que a quantidade requisitada.";
        Assert.assertEquals(mensagem, mensagemEsperada, "Verificar mensagem exibida na tela após tentar alterar a quantidade devolvida para um maior maior que a prevista");
        click(botaoOkAlerta);

        String encQuantPrevista = getText(quantPrevistaProdutoRetTipoPrato1);
        String encQuantExtra = getText(quantExtraProdutoRetTipoPrato1);
        String encQuantDevolvida = getText(quantDevolvidaProdutoRetTipoPrato1);
        String encQuantConsumida = getText(quantConsumidaProdutoRetTipoPrato1);

        String expQuantPrevista = "200,00000";
        String expQuantExtra = "0,00000";
        String expQuantDevolvida = "0,00000";
        String expQuantConsumida = "0,00000";
        Assert.assertEquals(encQuantPrevista, expQuantPrevista, "Verificar se a 'quantidade prevista' não foi alterada após tentar adicionar uma quantidade devolvida maior que a prevista");
        Assert.assertEquals(encQuantExtra, expQuantExtra, "Verificar se a 'quantidade extra' não foi alterada após tentar adicionar uma quantidade devolvida maior que a prevista");
        Assert.assertEquals(encQuantDevolvida, expQuantDevolvida, "Verificar se a 'quantidade devolvida' não foi alterada após tentar adicionar uma quantidade devolvida maior que a prevista");
        Assert.assertEquals(encQuantConsumida, expQuantConsumida, "Verificar se a 'quantidade consumida' não foi alterada após tentar adicionar uma quantidade devolvida maior que a prevista");
    }

    public void excluirSegundoProdutoRetTipoPrato() {
        tempo();
        click(nomePratoRetTipoPrato1);
        tempo();
        click(checkBoxProdutoRetTipoPrato2);
        click(botaoExcluir);

        String mensagem = getText(mensagemAlerta);
        String mensagemEsperada = "Deletar o(s) registro(s)?";
        Assert.assertEquals(mensagem, mensagemEsperada, "Verificar mensagem exibida na tela após clicar para excluir oo segundo produto da retirada de tipo de prato");
        click(botaoSim);

        mensagem = getText(mensagemAlerta);
        mensagemEsperada = "Produto(s) excluído(s) com sucesso.";
        Assert.assertEquals(mensagem, mensagemEsperada, "Verificar mensagem exibida na tela após excluir o segundo produto da retirada de tipo de prato");
        click(botaoOkAlerta);
    }

    public void tentarInserirQuantMaiorQueSaldoEstoqRetTipoPrato() {
        clicarCampoSelecionarValor(campoTipoPrato, tipoPratoGuarnicao);
        clicarCampoSelecionarValor(campoPrato, pratoStrogonoff);
        click(botaoCampoProdutoFormTipoPrato);
        sendKeys(campoProcurar, "CAIXA DE PAPELAO NATUBABY");
        click(produtoCaixaPapelao);
        clearAndSendKeys(campoQuantExtra, "1000");
        click(botaoSalvar);
        tempo();
        tempo();
        clicarCampoSelecionarValor(campoAlmoxarifado, almoxarifadoMaterialEmbAprov);
        clicarCampoSelecionarValor(campoLote, loteCaixaPapelao);
        click(botaoConfirmar);

        String mensagem = getText(mensagemAlerta);
        String mensagemEsperada = "A quantidade consumida informada para o produto é maior do que o saldo disponível no estoque do almoxarifado/localização/lote selecionado!";
        Assert.assertEquals(mensagem, mensagemEsperada, "Verificar mensagem exibida na tela após tentar adicionar um produto qcom quantidade consumior que o saldo no estoque, em uma retirada de tipo de prato");
        click(botaoOkAlerta);
    }

    ////////////////////
    public void adicionarRetProdutoBissulfatoPotassio() {
        click(botaoCampoProdutoFormProduto);
        sendKeys(campoProcurar, "BISSULFATO DE POTASSIO");
        click(produtoBissulfatoPotassio);
        clearAndSendKeys(campoQuantExtra, "11");
        clicarCampoSelecionarValor(campoTipoRetirada, tipoRetiradaConsumoProducao);
        click(botaoSalvar);
        tempo();
        tempo();
        clicarCampoSelecionarValor(campoAlmoxarifado, almoxarifadoProdutoAcabado);
        clicarCampoSelecionarValor(campoLote, loteBissulfatoPotassio9991Almox3);
        click(botaoConfirmar);


        try {
            Thread.sleep(15000);
        } catch (InterruptedException e) {
            throw new RuntimeException(e);
        }


        String mensagem = getText(mensagemAlerta);
        String mensagemEsperada = "Retirada incluída com sucesso.";
        Assert.assertEquals(mensagem, mensagemEsperada, "Verificar mensagem exibida na tela após adicionar uma retirada do tipo produto");
        click(botaoOkAlerta);
    }

    public void verificarRetProdutoBissulfatoPotassio() {
        //valores encontrados
        String encCodigoProduto = getText(codigoProdutoRetProduto1);
        String encNomeProduto = getText(nomeProdutoRetProduto1);
        String encUnidade = getText(unidadeRetProduto1);
        String encQuantPrevista = getText(quantPrevistaRetProduto1);
        String encQuantExtra = getText(quantExtraRetProduto1);
        String encQuantDevolvida = getText(quantDevolvidaRetProduto1);
        String encQuantConsumida = getText(quantConsumidaRetProduto1);
        String encValorUnitario = getText(valorUnitarioRetProduto1);
        javaScriptExecutor.executeScript("document.querySelector(\"#grid-2493995912567898485180 > div.body-scroll-control\").scrollBy(700, 0)");
        String encTipoRetirada = getText(tipoRetiradaRetProduto1);
        String encStatus = getText(statusRetProduto1);
        String encAlmoxarifado = getText(codigoAlmoxRetProduto1);
        String encLocalizacao = getText(localizacaoRetProduto1);
        String encLote = getText(loteRetProduto1);


        //valores esperados
        String expCodigoProduto = "1.01.1.1.02.005.00";
        String expNomeProduto = "BISSULFATO DE POTASSIO";
        String expUnidade = "KG";
        String expQuantPrevista = "0,00000";
        String expQuantExtra = "11,00000";
        String expQuantDevolvida = "0,00000";
        String expQuantConsumida = "11,00000";
        String expValorUnitario = "3,50000";
        String expTipoRetirada = "CONSUMO DE PRODUÇÃO";
        String expStatus = "Evoluído";
        String expAlmoxarifado = "1";
        String expLocalizacao = "";
        String expLote = "3";

        Assert.assertEquals(encCodigoProduto, expCodigoProduto, "Verificar 'código' do produto adicionado na retirada do tipo produto'");
        Assert.assertEquals(encNomeProduto, expNomeProduto, "Verificar 'nome' do produto adicionado na retirada do tipo produto'");
        Assert.assertEquals(encUnidade, expUnidade, "Verificar 'unidade' do produto adicionado na retirada do tipo produto'");
        Assert.assertEquals(encQuantPrevista, expQuantPrevista, "Verificar 'qt prevista' do produto adicionado na retirada do tipo produto'");
        Assert.assertEquals(encQuantExtra, expQuantExtra, "Verificar 'qt extra' do produto adicionado na retirada do tipo produto'");
        Assert.assertEquals(encQuantDevolvida, expQuantDevolvida, "Verificar 'qt devolvida' do produto adicionado na retirada do tipo produto'");
        Assert.assertEquals(encQuantConsumida, expQuantConsumida, "Verificar 'qt consumida' do produto adicionado na retirada do tipo produto'");
        Assert.assertEquals(encValorUnitario, expValorUnitario, "Verificar 'valor unitário' do produto adicionado na retirada do tipo produto'");
        Assert.assertEquals(encTipoRetirada, expTipoRetirada, "Verificar 'tipo de retirada' do produto adicionado na retirada do tipo produto'");
        Assert.assertEquals(encStatus, expStatus, "Verificar 'status' do produto adicionado na retirada do tipo produto'");
        Assert.assertEquals(encAlmoxarifado, expAlmoxarifado, "Verificar 'almoxarifado' do produto adicionado na retirada do tipo produto'");
        Assert.assertEquals(encLocalizacao, expLocalizacao, "Verificar 'localização' do produto adicionado na retirada do tipo produto'");
        Assert.assertEquals(encLote, expLote, "Verificar 'lote' do produto adicionado na retirada do tipo produto'");
    }

    public void verificarCustoTotalAposAdicionarRetiradaProduto() {
        float custoTotal = Float.parseFloat(getText(cabecalhoCustoTotal).replace(",", "."));
        float quantConsumida = Float.parseFloat(getText(quantConsumidaRetProduto1).replace(",", "."));
        float valorUnit = Float.parseFloat(getText(valorUnitarioRetProduto1).replace(",", "."));

        float custoTotalCalculado = quantConsumida * valorUnit;
        Assert.assertEquals(custoTotal, custoTotalCalculado, "Verificar o valor do custo total, após adicionar uma retirada do tipo produto");
    }

    public void excluirRetProduto() {
        click(checkBoxRetProduto1);
        click(botaoExcluir);

        String mensagem = getText(mensagemAlerta);
        String mensagemEsperada = "Deletar o(s) registro(s)?";
        Assert.assertEquals(mensagem, mensagemEsperada, "Verificar mensagem exibida na tela após clicar para excluir a retirada do tipo produto");
        click(botaoSim);

        mensagem = getText(mensagemAlerta);
        mensagemEsperada = "Retirada excluída com sucesso.";
        Assert.assertEquals(mensagem, mensagemEsperada, "Verificar mensagem exibida na tela após a exclusão da retirada do tipo produto");
        click(botaoOkAlerta);
    }

    public void adicionarSeguntoProdRetProduto() {
        tempo();
        tempo();
        click(botaoAdicionar);
        click(botaoCampoProdutoFormProduto);
        sendKeys(campoProcurar, "CANFORA");
        click(produtoCanfora);
        clearAndSendKeys(campoQuantExtra, "5");
        clearAndSendKeys(campoQuantDevolvida, "1");
        click(botaoSalvar);
        tempo();
        tempo();
        clicarCampoSelecionarValor(campoAlmoxarifado, almoxarifadoProdutoAcabado);
        clicarCampoSelecionarValor(campoLote, loteCanfora9999);
        click(botaoConfirmar);

        String mensagem = getText(mensagemAlerta);
        String mensagemEsperada = "Salvo com sucesso.";
        Assert.assertEquals(mensagem, mensagemEsperada, "Verificar mensagem exibida na tela após adicionar um segundo produto à retirada de produto");
        click(botaoOkAlerta);
    }

    public void verificarSegundoProdRetProduto() {
        //valores encontrados
        String encCodigoProduto = getText(codigoProdutoRetProduto2);
        String encNomeProduto = getText(nomeProdutoRetProduto2);
        String encUnidade = getText(unidadeRetProduto2);
        String encQuantPrevista = getText(quantPrevistaRetProduto2);
        String encQuantExtra = getText(quantExtraRetProduto2);
        String encQuantDevolvida = getText(quantDevolvidaRetProduto2);
        String encQuantConsumida = getText(quantConsumidaRetProduto2);
        String encValorUnitario = getText(valorUnitarioRetProduto2);
        javaScriptExecutor.executeScript("document.querySelector(\"#grid-2493995912567898485180 > div.body-scroll-control\").scrollBy(700, 0)");
        String encTipoRetirada = getText(tipoRetiradaRetProduto2);
        String encStatus = getText(statusRetProduto2);
        String encAlmoxarifado = getText(codigoAlmoxRetProduto2);
        String encLocalizacao = getText(localizacaoRetProduto2);
        String encLote = getText(loteRetProduto2);


        //valores esperados
        String expCodigoProduto = "1.01.1.1.02.004.00";
        String expNomeProduto = "CANFORA";
        String expUnidade = "KG";
        String expQuantPrevista = "0,00000";
        String expQuantExtra = "5,00000";
        String expQuantDevolvida = "1,00000";
        String expQuantConsumida = "4,00000";
        String expValorUnitario = "6,50000";
        String expTipoRetirada = "CONSUMO DE PRODUÇÃO";
        String expStatus = "Evoluído";
        String expAlmoxarifado = "1";
        String expLocalizacao = "";
        String expLote = "201";

        Assert.assertEquals(encCodigoProduto, expCodigoProduto, "Verificar 'código' do segundo produto adicionado na retirada do tipo produto'");
        Assert.assertEquals(encNomeProduto, expNomeProduto, "Verificar 'nome' do segundo produto adicionado na retirada do tipo produto'");
        Assert.assertEquals(encUnidade, expUnidade, "Verificar 'unidade' do segundo produto adicionado na retirada do tipo produto'");
        Assert.assertEquals(encQuantPrevista, expQuantPrevista, "Verificar 'qt prevista' do segundo produto adicionado na retirada do tipo produto'");
        Assert.assertEquals(encQuantExtra, expQuantExtra, "Verificar 'qt extra' do segundo produto adicionado na retirada do tipo produto'");
        Assert.assertEquals(encQuantDevolvida, expQuantDevolvida, "Verificar 'qt devolvida' do segundo produto adicionado na retirada do tipo produto'");
        Assert.assertEquals(encQuantConsumida, expQuantConsumida, "Verificar 'qt consumida' do segundo produto adicionado na retirada do tipo produto'");
        Assert.assertEquals(encValorUnitario, expValorUnitario, "Verificar 'valor unitário' do segundo produto adicionado na retirada do tipo produto'");
        Assert.assertEquals(encTipoRetirada, expTipoRetirada, "Verificar 'tipo de retirada' do segundo produto adicionado na retirada do tipo produto'");
        Assert.assertEquals(encStatus, expStatus, "Verificar 'status' do segundo produto adicionado na retirada do tipo produto'");
        Assert.assertEquals(encAlmoxarifado, expAlmoxarifado, "Verificar 'almoxarifado' do segundo produto adicionado na retirada do tipo produto'");
        Assert.assertEquals(encLocalizacao, expLocalizacao, "Verificar 'localização' do segundo produto adicionado na retirada do tipo produto'");
        Assert.assertEquals(encLote, expLote, "Verificar 'lote' do segundo produto adicionado na retirada do tipo produto'");
    }

    public void verificarCustoTotoalAposAddSegundoProdRetProduto() {
        float custoTotal = Float.parseFloat(getText(cabecalhoCustoTotal).replace(",", "."));

        float quantConsumida1 = Float.parseFloat(getText(quantConsumidaRetProduto1).replace(",", "."));
        float valorUnit1 = Float.parseFloat(getText(valorUnitarioRetProduto1).replace(",", "."));
        float quantConsumida2 = Float.parseFloat(getText(quantConsumidaRetProduto2).replace(",", "."));
        float valorUnit2 = Float.parseFloat(getText(valorUnitarioRetProduto2).replace(",", "."));

        float custoTotalCalculado = (quantConsumida1 * valorUnit1) + (quantConsumida2 * valorUnit2);
        Assert.assertEquals(custoTotal, custoTotalCalculado, "Verificar o valor do custo total, após adicionar um segundo produto a uma retirada do tipo produto");
    }

    public void excluirSegundoProdRetProduto() {
        click(checkBoxRetProduto2);
        click(botaoExcluir);

        String mensagem = getText(mensagemAlerta);
        String mensagemEsperada = "Deletar o(s) registro(s)?";
        Assert.assertEquals(mensagem, mensagemEsperada, "Verificar mensagem exibida na tela após clicar para excluir a retirada do tipo produto");
        click(botaoSim);

        mensagem = getText(mensagemAlerta);
        mensagemEsperada = "Produto(s) excluído(s) com sucesso.";
        Assert.assertEquals(mensagem, mensagemEsperada, "Verificar mensagem exibida na tela após a exclusão da retirada do tipo produto");
        click(botaoOkAlerta);

        tempo();
        String quantProdutos = javaScriptExecutor.executeScript("return document.querySelector(\"#grid-2493995912567898485180 > div.body > div\").childElementCount").toString();
        Assert.assertEquals(quantProdutos, "1", "Verificar após a exclusão do segunto produto, a retirada passou a possuir apenas 1 produto");
    }

    public void alterarQuantidadeRetProdutoInLine() {
        tempo();
        tempo();
        alterarValorDoCampo(quantExtraRetProduto1, "7");
        tempo();
        tempo();
        clicarCampoSelecionarValor(campoAlmoxarifado, almoxarifadoProdutoAcabado);
        tempo();
        clicarCampoSelecionarValor(campoLote, loteOleoAmendoas19995);
        click(botaoConfirmar);
        alterarValorDoCampo(quantDevolvidaRetProduto1, "1,5");
        tempo();
        tempo();
        clicarCampoSelecionarValor(campoAlmoxarifado, almoxarifadoProdutoAcabado);
        clicarCampoSelecionarValor(campoLote, loteOleoAmendoas19995);
        click(botaoConfirmar);
        tempo();
        click(botaoSalvarAlteracoes);

        String mensagem = getText(mensagemAlerta);
        String mensagemEsperada = "Salvo com sucesso.";
        Assert.assertEquals(mensagem, mensagemEsperada, "Verificar mensagem exibida na tela após alterar as quantidades do produto na retirada de produto");
        click(botaoOkAlerta);
    }

    public void retornarQuantIniProdRetProduto() {
        alterarValorDoCampo(quantExtraRetProduto1, "3");
        tempo();
        tempo();
        clicarCampoSelecionarValor(campoAlmoxarifado, almoxarifadoProdutoAcabado);
        clicarCampoSelecionarValor(campoLote, loteOleoAmendoas19992);
        click(botaoConfirmar);
        alterarValorDoCampo(quantDevolvidaRetProduto1, "0");
        tempo();
        tempo();
        clicarCampoSelecionarValor(campoAlmoxarifado, almoxarifadoProdutoAcabado);
        clicarCampoSelecionarValor(campoLote, loteOleoAmendoas19992);
        click(botaoConfirmar);
        tempo();
        click(botaoSalvarAlteracoes);

        String mensagem = getText(mensagemAlerta);
        String mensagemEsperada = "Salvo com sucesso.";
        Assert.assertEquals(mensagem, mensagemEsperada, "Verificar mensagem exibida na tela após alterar as quantidades do produto na retirada de produto");
        click(botaoOkAlerta);
    }

    public void verificarQuantAlteradaRetProduto(int sequenciaAlteracao) {
        //valores encontrados
        String encQuantPrevista = getText(quantPrevistaRetProduto1);
        String encQuantExtra = getText(quantExtraRetProduto1);
        String encQuantDevolvida = getText(quantDevolvidaRetProduto1);
        String encQuantConsumida = getText(quantConsumidaRetProduto1);

        //valores esperados
        String expQuantPrevista = "";
        String expQuantExtra = "";
        String expQuantDevolvida = "";
        String expQuantConsumida = "";

        if (sequenciaAlteracao == 1) {
            expQuantPrevista = "0,00000";
            expQuantExtra = "7,00000";
            expQuantDevolvida = "1,50000";
            expQuantConsumida = "5,50000";
        } else if (sequenciaAlteracao == 2) {
            expQuantPrevista = "0,00000";
            expQuantExtra = "3,00000";
            expQuantDevolvida = "0,00000";
            expQuantConsumida = "3,00000";
        }

        Assert.assertEquals(encQuantPrevista, expQuantPrevista, "Verificar 'qt prevista' após alterar as quantidade na retirada produto");
        Assert.assertEquals(encQuantExtra, expQuantExtra, "Verificar 'qt extra' após alterar as quantidade na retirada produto");
        Assert.assertEquals(encQuantDevolvida, expQuantDevolvida, "Verificar 'qt devolvida' após alterar as quantidade na retirada produto");
        Assert.assertEquals(encQuantConsumida, expQuantConsumida, "Verificar 'qt consumida' após alterar as quantidade na retirada produto");

        float custoTotal = Float.parseFloat(getText(cabecalhoCustoTotal).replace(",", "."));
        float quantConsumida = Float.parseFloat(getText(quantConsumidaRetProduto1).replace(",", "."));
        float valorUnitario = Float.parseFloat(getText(valorUnitarioRetProduto1).replace(",", "."));
        float calculoCustoTotal = quantConsumida * valorUnitario;
        Assert.assertEquals(custoTotal, calculoCustoTotal, "Verificar valor do custo total após a alteração das quantidades dos produtos na retirada produto");
    }

    public void editarQuantDevolvidaRetProdutoComQuantPrevista() {
        tempo();
        tempo();
        alterarValorDoCampo(quantDevolvidaRetProduto2, "45");
        tempo();
        tempo();
        clicarCampoSelecionarValor(campoAlmoxarifado, almoxarifadoProdutoAcabado);
        tempo();
        clicarCampoSelecionarValor(campoLote, loteQuerosene9924);
        click(botaoConfirmar);
        tempo();
        click(botaoSalvarAlteracoes);
        String mensagem = getText(mensagemAlerta);
        String mensagemEsperada = "Salvo com sucesso.";
        Assert.assertEquals(mensagem, mensagemEsperada, "Verificar mensagem exibida na tela após alterar a quantidade em um produto que possuí quantidade prevista");
        click(botaoOkAlerta);
        verificarQuantAposAlteracaoComQuantPrevRetProduto("Valores alterados");

        alterarValorDoCampo(quantDevolvidaRetProduto2, "0");
        tempo();
        tempo();
        clicarCampoSelecionarValor(campoAlmoxarifado, almoxarifadoProdutoAcabado);
        clicarCampoSelecionarValor(campoLote, loteQuerosene9969);
        click(botaoConfirmar);
        tempo();
        click(botaoSalvarAlteracoes);
        mensagem = getText(mensagemAlerta);
        mensagemEsperada = "Salvo com sucesso.";
        Assert.assertEquals(mensagem, mensagemEsperada, "Verificar mensagem exibida na tela após alterar a quantidade em um produto que possuí quantidade prevista");
        click(botaoOkAlerta);
        verificarQuantAposAlteracaoComQuantPrevRetProduto("Valores início teste");
    }

    public void tentarLancarQuantDevolvidaMaiorQueExtraRetProduto() {
        alterarValorDoCampo(quantDevolvidaRetProduto1, "15");

        String mensagem = getText(mensagemAlerta);
        String mensagemEsperada = "Quantidade devolvida não pode ser maior que a quantidade requisitada.";
        Assert.assertEquals(mensagem, mensagemEsperada, "Verificar mensagem exibida na tela após tentar lançar uma quantidade devolvida maior que a quantidade extra em um retirada de produto");
        click(botaoOkAlerta);

        String quantDevolvida = getText(quantDevolvidaRetProduto1);
        Assert.assertEquals(quantDevolvida, "0,00000", "Verificar se o valor da quantidade devolvida não foi alterado após tentar lançar uma quantidade devolvida maior que a extra");
    }

    public void tentarLancarQuantDevolvidaMaiorQueReqRetProduto() {
        alterarValorDoCampo(quantDevolvidaRetProduto1, "15000");

        String mensagem = getText(mensagemAlerta);
        String mensagemEsperada = "Quantidade devolvida não pode ser maior que a quantidade requisitada.";
        Assert.assertEquals(mensagem, mensagemEsperada, "Verificar mensagem exibida na tela após tentar lançar uma quantidade devolvida maior que a requisitada");
        click(botaoOkAlerta);

        String quantDevolvida = getText(quantDevolvidaRetProduto1);
        Assert.assertEquals(quantDevolvida, "0,00000", "Verificar se o valor da quantidade devolvida não foi alterado");
    }

    public void tentarInserirQuantMaiorQueSaldoEstoq() {
        click(botaoCampoProdutoFormProduto);
        sendKeys(campoProcurar, "BISSULFATO DE POTASSIO");
        click(produtoBissulfatoPotassio);
        clearAndSendKeys(campoQuantExtra, "10000");
        click(botaoSalvar);
        tempo();
        tempo();
        clicarCampoSelecionarValor(campoAlmoxarifado, almoxarifadoProdutoAcabado);
        clicarCampoSelecionarValor(campoLote, loteBissulfatoPotassio9999Almox145);
        click(botaoConfirmar);

        String mensagem = getText(mensagemAlerta);
        String mensagemEsperada = "A quantidade consumida informada para o produto é maior do que o saldo disponível no estoque do almoxarifado/localização/lote selecionado!";
        Assert.assertEquals(mensagem, mensagemEsperada, "Verificar mensagem exibida na tela após tentar adiconar um produto com quantidade consumida maior que saldo no estoque, em um retirada de produto");
        click(botaoOkAlerta);
    }

    ///////////////////
    public void camposObrigatoriosFiltroIni() {
        click(botaoCampoUnidadeFiltroIni);
        click(botaoCampoDataRetFiltroIni);
        click(botaoAplicarFiltro);

        String mensagem = "Campo obrigatório";
        String unidade = getText(mensagemObrigatorioUnidadeFiltroIni);
        String servico = getText(mensagemObrigatorioServicoFiltroIni);
        String dataRetirada = getText(mensagemObrigatorioDataRetirada);
        String dataCardapio = getText(mensagemObrigatorioDataCardapio);
        Assert.assertEquals(unidade, mensagem, "Verificar mensagem de campo obrigatório no campo 'unidade' do filtro inicial");
        Assert.assertEquals(servico, mensagem, "Verificar mensagem de campo obrigatório no campo 'serviço' do filtro inicial");
        Assert.assertEquals(dataRetirada, mensagem, "Verificar mensagem de campo obrigatório no campo 'dt retirada' do filtro inicial");
        Assert.assertEquals(dataCardapio, mensagem, "Verificar mensagem de campo obrigatório no campo 'de cardápio' do filtro inicial");
    }

    public void camposObrigatoriosFormRetTipoPrato() {
        Actions actions = new Actions(driver);
        tempo();
        actions.doubleClick(driver.findElement(campoQuantExtra)).build().perform();
        actions.doubleClick(driver.findElement(campoQuantDevolvida)).build().perform();
        actions.doubleClick(driver.findElement(campoQuantConsumida)).build().perform();
        click(botaoCampoTipoRetiradaFormTipoPrato);
        click(botaoSalvar);

        String mensagem = "Campo obrigatório";
        String tipoPrato = getText(mensagemObrigatorioTipoPrato);
        String prato = getText(mensagemObrigatorioPrato);
        String produto = getText(mensagemObrigatorioProduto);
        String quantExtra = getText(mensagemObrigatorioQuantExtra);
        String quantDevolvida = getText(mensagemObrigatorioQuantDevolvida);
        String quantConsumida = getText(mensagemObrigatorioQuantConsumida);
        String tipoRetirada = getText(mensagemObrigatorioTipoPratoRetirada);
        click(botaoSalvar);
        Assert.assertEquals(tipoPrato, mensagem, "Verificar mensagem de campo obrigatório no campo 'tipo de prato' no formulário para adicionar retirada de tipo de prato");
        Assert.assertEquals(prato, mensagem, "Verificar mensagem de campo obrigatório no campo 'prato' no formulário para adicionar retirada de tipo de prato");
        Assert.assertEquals(produto, mensagem, "Verificar mensagem de campo obrigatório no campo 'produto' no formulário para adicionar retirada de tipo de prato");
        Assert.assertEquals(quantExtra, mensagem, "Verificar mensagem de campo obrigatório no campo 'qt extra' no formulário para adicionar retirada de tipo de prato");
        Assert.assertEquals(quantDevolvida, mensagem, "Verificar mensagem de campo obrigatório no campo 'qt devolvida' no formulário para adicionar retirada de tipo de prato");
        Assert.assertEquals(quantConsumida, mensagem, "Verificar mensagem de campo obrigatório no campo 'qt consumida' no formulário para adicionar retirada de tipo de prato");
        Assert.assertEquals(tipoRetirada, mensagem, "Verificar mensagem de campo obrigatório no campo 'tipo retirada' no formulário para adicionar retirada de tipo de prato");
    }

    public void camposObrigatoriosInformacoesProdRetTipoPrato() {
        clicarCampoSelecionarValor(campoTipoPrato, tipoPratoGuarnicao);
        clicarCampoSelecionarValor(campoPrato, pratoStrogonoff);
        clicarCampoSelecionarValor(campoProduto, produtoOleoCopaiba);
        clearAndSendKeys(campoQuantExtra, "8");
        clicarCampoSelecionarValor(campoTipoRetirada, tipoRetiradaConsumoEmpresa);
        click(botaoSalvar);
        tempo();
        tempo();
        click(botaoCampoAlmoxarifado);
        click(botaoConfirmar);

        String mensagem = "Campo obrigatório";
        String almoxarifado = getText(mensagemObrigatorioAlmoxarifado);
        String lote = getText(mensagemObrigatorioLote);
        Assert.assertEquals(almoxarifado, mensagem, "Verificar mensagem de campo obrigatório no campo 'almoxarifado' no formulário de informações completamentare do produto, após preencher o formulário de tipo de prato");
        Assert.assertEquals(lote, mensagem, "Verificar mensagem de campo obrigatório no campo 'lote' no formulário de informações completamentare do produto, após preencher o formulário de tipo de prato");
    }

    public void camposObrigatoriosFormRetProduto() {
        Actions actions = new Actions(driver);
        tempo();
        actions.doubleClick(driver.findElement(campoQuantExtra)).build().perform();
        actions.doubleClick(driver.findElement(campoQuantDevolvida)).build().perform();
        actions.doubleClick(driver.findElement(campoQuantConsumida)).build().perform();
        click(botaoCampoTipoRetiradaFormProduto);
        click(botaoSalvar);

        String mensagem = "Campo obrigatório";
        String produto = getText(mensagemObrigatorioProduto);
        String quantExtra = getText(mensagemObrigatorioQuantExtra);
        String quantDevolvida = getText(mensagemObrigatorioQuantDevolvida);
        String quantConsumida = getText(mensagemObrigatorioQuantConsumida);
        String tipoRetirada = getText(mensagemObrigatorioTipoPratoRetirada);
        Assert.assertEquals(produto, mensagem, "Verificar mensagem de campo obrigatório no campo 'produto' no formulário para adicionar uma retirada de produto");
        Assert.assertEquals(quantExtra, mensagem, "Verificar mensagem de campo obrigatório no campo 'qt extra' no formulário para adicionar uma retirada de produto");
        Assert.assertEquals(quantDevolvida, mensagem, "Verificar mensagem de campo obrigatório no campo 'qt devolvida' no formulário para adicionar uma retirada de produto");
        Assert.assertEquals(quantConsumida, mensagem, "Verificar mensagem de campo obrigatório no campo 'qt consumida' no formulário para adicionar uma retirada de produto");
        Assert.assertEquals(tipoRetirada, mensagem, "Verificar mensagem de campo obrigatório no campo 'tipo retirada' no formulário para adicionar uma retirada de produto");
    }

    public void camposObrigatoriosInformacaoProdRetProduto() {
        click(botaoCampoProdutoFormProduto);
        sendKeys(campoProcurar, "BISSULFATO DE POTASSIO");
        click(produtoBissulfatoPotassio);
        clearAndSendKeys(campoQuantExtra, "11");
        clicarCampoSelecionarValor(campoTipoRetirada, tipoRetiradaConsumoProducao);
        click(botaoSalvar);
        tempo();
        tempo();
        click(botaoCampoAlmoxarifado);
        click(botaoConfirmar);

        String mensagem = "Campo obrigatório";
        String almoxarifado = getText(mensagemObrigatorioAlmoxarifado);
        String lote = getText(mensagemObrigatorioLote);
        Assert.assertEquals(almoxarifado, mensagem, "Verificar mensagem de campo obrigatório no campo 'almoxarifado' no formulário de informações completamentare do produto, após preencher o formulário de produto");
        Assert.assertEquals(lote, mensagem, "Verificar mensagem de campo obrigatório no campo 'lote' no formulário de informações completamentare do produto, após preencher o formulário de produto");
    }

    public void testeAcaoExibirResumo(String tipoRetirada) {
        tempo();
        tempo();
        click(botaoAcoes);
        click(acaoExibirResumo);

        //valores encontrados
        String encCodigo = getText(codigoProdutoExibirResumo1);
        String encNome = getText(nomeExibirResumo1);
        String encUnidade = getText(unidadeExibirResumo1);
        String encQuantPrevista = getText(quantPrevistaExibirResumo1);
        String encQuantExtra = getText(quantExtraExibirResumo1);
        String encQuantDevolvida = getText(quantDevolvidaExibirResumo1);
        String encQuantConsumida = getText(quantConsumidaExibirResumo1);
        String encCusto = getText(custoExibirResumo1);
        String encQuantEstoque = getText(quantEstoqueExibirResumo1);

        //valores esperados
        String expCodigo = "";
        String expNome = "";
        String expUnidade = "";
        String expQuantPrevista = "";
        String expQuantExtra = "";
        String expQuantDevolvida = "";
        String expQuantConsumida = "";
        String expCusto = "";
        String expQuantEstoque = "";


        if (tipoRetirada.equals("Tipo de Prato")) {
            expCodigo = "1.02.3.1.01.001.00";
            expNome = "CREME BASE NAO IONICO";
            expUnidade = "KG";
            expQuantPrevista = "0,00000";
            expQuantExtra = "3,00000";
            expQuantDevolvida = "0,00000";
            expQuantConsumida = "3,00000";
            expCusto = "17,17039";
            expQuantEstoque = "3.015,94000";
        } else if (tipoRetirada.equals("Produto")) {
            expCodigo = "1.01.4.1.02.002.00";
            expNome = "BERBERIS VULGARIS TM";
            expUnidade = "L";
            expQuantPrevista = "0,00000";
            expQuantExtra = "7,00000";
            expQuantDevolvida = "0,00000";
            expQuantConsumida = "7,00000";
            expCusto = "1,11000";
            expQuantEstoque = "9.999.999.993,00000";
        }

        Assert.assertEquals(encCodigo, expCodigo, "Verificar 'código' do produto exibida na ação Exibir Resumo, em uma retirada de " + tipoRetirada);
        Assert.assertEquals(encNome, expNome, "Verificar 'nome' do produto exibida na ação Exibir Resumo, em uma retirada de " + tipoRetirada);
        Assert.assertEquals(encUnidade, expUnidade, "Verificar 'unidade' do produto exibida na ação Exibir Resumo, em uma retirada de " + tipoRetirada);
        Assert.assertEquals(encQuantPrevista, expQuantPrevista, "Verificar 'qt prevista' do produto exibida na ação Exibir Resumo, em uma retirada de " + tipoRetirada);
        Assert.assertEquals(encQuantExtra, expQuantExtra, "Verificar 'qt extra' do produto exibida na ação Exibir Resumo, em uma retirada de " + tipoRetirada);
        Assert.assertEquals(encQuantDevolvida, expQuantDevolvida, "Verificar 'qt devolvida' do produto exibida na ação Exibir Resumo, em uma retirada de " + tipoRetirada);
        Assert.assertEquals(encQuantConsumida, expQuantConsumida, "Verificar 'qt consumida' do produto exibida na ação Exibir Resumo, em uma retirada de " + tipoRetirada);
        Assert.assertEquals(encCusto, expCusto, "Verificar 'custo' do produto exibida na ação Exibir Resumo, em uma retirada de " + tipoRetirada);
        Assert.assertEquals(encQuantEstoque, expQuantEstoque, "Verificar 'qt estoque' do produto exibida na ação Exibir Resumo, em uma retirada de " + tipoRetirada);
        click(botaoVoltar);
    }

    public void testeAcaoAtualizarEstoque() {
        click(botaoAcoes);
        click(acaoAtualizarEstoque);

        String mensagem = "Estoque atualizado com sucesso.";
        String mensagemEsperada = getText(mensagemAlerta);
        Assert.assertEquals(mensagem, mensagemEsperada, "Verificar mensagem exibida na tela após clicar na ação de atualizar estoque");
        click(botaoOkAlerta);
    }

    public void testeAcaoRomaneio(String tipoRetirada) {
        click(botaoAcoes);
        click(acaoExibirRomaneio);

        String dataDe = "01/07/2023";
        String dataAte = "14/07/2023";
        preencherCampoData(botaoCampoDataDeRetirada, campoDataDeRetiradaFiltroRomaneio, dataDe);
        preencherCampoData(botaoCampoDataAteRetirada, campoDataAteRetiradaFiltroRomaneiro, dataAte);
        preencherCampoData(botaoCampoDataDeCardapio, campoDataDeCardapioFiltroRomaneio, dataDe);
        preencherCampoData(botaoCampoDataAteCardapio, campoDataAteCardapioFiltroRomaneio, dataAte);
        click(botaoAplicarFiltro);

        String expCodServico = "";
        String expNomeServico = "";
        String expDataRetirada = "";
        String expDataCardapio = "";
        String expNumeroRequisicao = "";
        String expNumeroLancamento = "";

        String encCodServico = getText(codigoServicoRomaneio1);
        String encNomeServico = getText(nomeServicoRomaneio1);
        String encDataRetirada = getText(dataRetiradaRomaneio1);
        String encDataCardapio = getText(dataCardapioRomaneio1);
        String encNumeroRequisicao = getText(numeroRequisicaoRomaneio1);
        String encNumeroLancamento = getText(numeroLancamentoRomaneio1);

        if (tipoRetirada.equals("Tipo de Prato")) {
            expCodServico = "00002";
            expNomeServico = "ALMOÇO ESPECIAL";
            expDataRetirada = "05/07/2023";
            expDataCardapio = "05/07/2023";
            expNumeroRequisicao = "0000000000";
            expNumeroLancamento = "0000119906";
        } else if (tipoRetirada.equals("Produto")) {
            expCodServico = "00003";
            expNomeServico = "ALMOÇO";
            expDataRetirada = "14/07/2023";
            expDataCardapio = "14/07/2023";
            expNumeroRequisicao = "0000000000";
            expNumeroLancamento = "0000119995";
        }

        Assert.assertEquals(encCodServico, expCodServico, "Verificar código do serviço apresentado no romaneio do tipo de retirada - " + tipoRetirada);
        Assert.assertEquals(encNomeServico, expNomeServico, "Verificar nome do serviço apresentado no romaneio do tipo de retirada - " + tipoRetirada);
        Assert.assertEquals(encDataRetirada, expDataRetirada, "Verificar data da retirada apresentada no romaneio do tipo de retirada - " + tipoRetirada);
        Assert.assertEquals(encDataCardapio, expDataCardapio, "Verificar data do cardápio apresentada no romaneio do tipo de retirada - " + tipoRetirada);
        Assert.assertEquals(encNumeroRequisicao, expNumeroRequisicao, "Verificar número da requisição apresentada no romaneio do tipo de retirada - " + tipoRetirada);
        Assert.assertEquals(encNumeroLancamento, expNumeroLancamento, "Verificar número do lançamento apresentado no romaneio do tipo de retirada - " + tipoRetirada);

        click(botaoVoltar);
        tempo();
        click(botaoCancelarFiltroRomaneio);
    }

    //////////////////

    private void preencherCampoData(By botaoApagarData, By campoData, String data) {
        click(botaoApagarData);
        click(campoData);
        sendKeys(campoData, data);
    }

    private void verificarQuantAposAlteracaoComQuantPrevRetProduto(String faseTeste) {
        //valores encontrados
        String encQuantPrevista = getText(quantPrevistaRetProduto2);
        String encQuantExtra = getText(quantExtraRetProduto2);
        String encQuantDevolvida = getText(quantDevolvidaRetProduto2);
        String encQuantConsumida = getText(quantConsumidaRetProduto2);

        //valores esperados
        String expQuantPrevista = "";
        String expQuantExtra = "";
        String expQuantDevolvida = "";
        String expQuantConsumida = "";

        if (faseTeste.equals("Valores alterados")) {
            expQuantPrevista = "75,00000";
            expQuantExtra = "0,00000";
            expQuantDevolvida = "45,00000";
            expQuantConsumida = "30,00000";
        } else if (faseTeste.equals("Valores início teste")) {
            expQuantPrevista = "75,00000";
            expQuantConsumida = "75,00000";
            expQuantExtra = "0,00000";
            expQuantDevolvida = "0,00000";
        }

        Assert.assertEquals(encQuantPrevista, expQuantPrevista, "Verificar valor da 'quantidade prevista' após alterar a quantidade em um produto que possuí quantidade prevista");
        Assert.assertEquals(encQuantExtra, expQuantExtra, "Verificar valor da 'quantidade extra' após alterar a quantidade em um produto que possuí quantidade prevista");
        Assert.assertEquals(encQuantDevolvida, expQuantDevolvida, "Verificar valor da 'quantidade devolvida' após alterar a quantidade em um produto que possuí quantidade prevista");
        Assert.assertEquals(encQuantConsumida, expQuantConsumida, "Verificar valor da 'quantidade consumida' após alterar a quantidade em um produto que possuí quantidade prevista");

    }

    private void verificarQuantAposAlteracaoComQuantPrevRetTipoPrato(String faseTeste) {
        //valores encontrados
        String encQuantPrevista = getText(quantPrevistaProdutoRetTipoPrato2);
        String encQuantExtra = getText(quantExtraProdutoRetTipoPrato2);
        String encQuantDevolvida = getText(quantDevolvidaProdutoRetTipoPrato2);
        String encQuantConsumida = getText(quantConsumidaProdutoRetTipoPrato2);
        String encValorUnitario = getText(valorUnitarioProdutoRetTipoPrato2);

        //valores encontrados
        String expQuantPrevista = "";
        String expQuantExtra = "";
        String expQuantDevolvida = "";
        String expQuantConsumida = "";
        String expValorUnitario = "0,08306";

        if (faseTeste.equals("Valores Alterados")) {
            expQuantPrevista = "120,00000";
            expQuantExtra = "0,00000";
            expQuantDevolvida = "111,00000";
            expQuantConsumida = "9,00000";
        } else if (faseTeste.equals("Valores início teste")) {
            expQuantPrevista = "120,00000";
            expQuantExtra = "0,00000";
            expQuantDevolvida = "0,00000";
            expQuantConsumida = "120,00000";
        }

        Assert.assertEquals(encQuantPrevista, expQuantPrevista, "Verificar valor da 'quantidade prevista' após alterar a quantidade em um produto que possuí quantidade prevista");
        Assert.assertEquals(encQuantExtra, expQuantExtra, "Verificar valor da 'quantidade extra' após alterar a quantidade em um produto que possuí quantidade prevista");
        Assert.assertEquals(encQuantDevolvida, expQuantDevolvida, "Verificar valor da 'quantidade devolvida' após alterar a quantidade em um produto que possuí quantidade prevista");
        Assert.assertEquals(encQuantConsumida, expQuantConsumida, "Verificar valor da 'quantidade consumida' após alterar a quantidade em um produto que possuí quantidade prevista");
        Assert.assertEquals(encValorUnitario, expValorUnitario, "Verificar o 'valor unitário' após alterar a quantidade em um produto que possuí quantidade prevista");
    }

    private boolean verificarCustoTotalRetTipoPratoApenas1Prod() {
        float custoTotal = Float.parseFloat(getText(cabecalhoCustoTotal).replace(",", "."));
        click(nomePratoRetTipoPrato1);

        float quantConsumida = Float.parseFloat(getText(quantConsumidaProdutoRetTipoPrato1).replace(",", "."));
        float valorUnitario = Float.parseFloat(getText(valorUnitarioProdutoRetTipoPrato1).replace(",", "."));

        click(botaoVoltar);
        return custoTotal == quantConsumida * valorUnitario;
    }

    private float verificarCustoTotalRetTipoPratoPara2Prod() {
        click(nomePratoRetTipoPrato1);
        tempo();
        javaScriptExecutor.executeScript("document.querySelector(\"#grid-24939959122776413062891 > div.body-scroll-control\").scrollBy(2000, 0)");
        float quantConsumidaProd1 = Float.parseFloat(getText(quantConsumidaProdutoRetTipoPrato1).replace(",", "."));
        float valorUnitarioProd1 = Float.parseFloat(getText(valorUnitarioProdutoRetTipoPrato1).replace(",", "."));
        float custoProd1 = quantConsumidaProd1 * valorUnitarioProd1;

        float quantConsumidaProd2 = Float.parseFloat(getText(quantConsumidaProdutoRetTipoPrato2).replace(",", "."));
        float valorUnitarioProd2 = Float.parseFloat(getText(valorUnitarioProdutoRetTipoPrato2).replace(",", "."));
        float custoProd2 = quantConsumidaProd2 * valorUnitarioProd2;

        return custoProd1 + custoProd2;
    }

    private void alterarValorDoCampo(By campo, String valor) {
        tempo();
        Actions actions = new Actions(driver);
        actions.moveToElement(driver.findElement(campo)).click().build().perform();
        tempo();
        actions.sendKeys(Keys.BACK_SPACE).build().perform();
        tempo();
        actions.sendKeys(valor).build().perform();
        tempo();
        actions.sendKeys(Keys.ENTER).build().perform();
        tempo();
    }

}