package com.javaseleniumtemplate.pages;

import com.javaseleniumtemplate.bases.PageBase;
import org.openqa.selenium.By;
import org.testng.Assert;

public class UnidadeAdicionalProdutoPage extends PageBase {

    By botaoMenu = By.xpath("//div[@class='bars']");
    By campoPesquisar = By.xpath("//section[@class='zh-container-search-menu']//input[@type='text']");
    By telaUnidadeAdicionalProduto = By.xpath("//span[text() = 'Unidade Adicional do Produto']");

    By botaoAdicionarTelaInicial = By.xpath("//li[@data-zh-id=\"18945071144253883066836\"]");
    By botaoExcluirTelaInicial = By.xpath("//li[@data-zh-id=\"18945071143694378994838\"]");
    By botaoSalvar = By.xpath("//div[@class=\"zh-footer-right\"]");
    By botaoCancelar = By.xpath("//div[@class=\"zh-footer-left\"]");
    By botaoVoltar = By.xpath("//div[@class=\"zh-footer-left\"]");
    By botaoEditarConversao = By.xpath("//li[@data-zh-id=\"18945071141755128836779\"]");
    By botaoExcluirConversao = By.xpath("//li[@data-zh-id=\"18945071144129244251781\"]");
    By botaoAdicionarConversao = By.xpath("//li[@data-zh-id=\"18945071144231460928777\"]");
    By botaoSimMensagemAlerta = By.xpath("//section[@class=\"zh-container-alert\"]//footer[@class=\"zh-footer-alert\"]/button[1]");
    By botaoOk = By.xpath("//section[@class=\"zh-container-alert\"]//button[@data-ng-repeat=\"button in buttons\"]");
    By botaoDeOpcoesDaTela = By.xpath("//div[@data-ng-if=\"widget.isFloatingControlVisible()\"]//div[@data-zh-floating-control]");
    By botaoPesquisar = By.xpath("//div[@class=\"control-menu\"]//li[@data-zh-id=\"zh-floating-control-custom-action-1\"]");
    By campoProcurarTelaInicial = By.xpath("//li[@class=\"float-action expandable fix-position-bottom opened\"]//div[@class=\"floating-card-input\"]//input");
    By campoProcurar = By.xpath("//li[@class=\"float-action expandable fix-position-bottom opened\"]//input");

    By botaoCampoProduto = By.xpath("//div[@id=\"NMPRODUTO\"]//span[@style=\"background-image: none; display: block;\"]");
    By produtoIodetoArsenio = By.xpath("//div[@data-zh-field-name=\"NMPRODUTO\"]//span[text() = 'IODETO DE ARSENIO']");
    By produtoIodetoDeCalcio = By.xpath("//div[@id=\"grid-9000\"]//div[@data-zh-field-name=\"NMPRODUTO\"]//span[text() = 'IODETO DE CALCIO']");
    By botaoCampoUnidadeSecundaria = By.xpath("//div[@id=\"DSUNIDADE\"]//span[@style=\"background-image: none; display: block;\"]");
    By unidadeSecundariaLata = By.xpath("//div[@data-zh-field-name=\"DSUNIDADE\"]//span[text() = 'LATA']");
    By unidadeSecundariaCopo = By.xpath("//div[@data-zh-field-name=\"DSUNIDADE\"]//span[text() = 'COPO']");
    By unidadeSecundariaBalde = By.xpath("//div[@data-zh-field-name=\"DSUNIDADE\"]//span[text() = 'BALDE']");
    By primeiraOpcaoRelacao = By.xpath("//div[@class=\"zh-radio-group zh-radio-group-OPCOES_RELACAO\"]//div[@class=\"zh-radio zh-radio-columns-1\"]//label[@for=\"radio-OPCOES_RELACAO-0\"]//span");
    By segundaOpcaoRelacao = By.xpath("//div[@class=\"zh-radio-group zh-radio-group-OPCOES_RELACAO\"]//div[@class=\"zh-radio zh-radio-columns-1\"]//label[@for=\"radio-OPCOES_RELACAO-1\"]//span");
    By inputRadioButtonPrimeiraOpcRel = By.id("radio-OPCOES_RELACAO-0");
    By inputRadioButtonSegundaOpcRel = By.id("radio-OPCOES_RELACAO-1");

    By produtoTelaConversaoUnidades = By.xpath("//div[@id=\"NMPRODUTO\"]/span[1]");
    By unidadeSecundTelaConversaoUnidades = By.xpath("//div[@id=\"DSUNIDADE\"]/span[1]");
    By campoRelacao = By.id("VRFATOCONVES");

    By codigoTelaInicialProduto1 = By.xpath("//div[@id=\"grid-18945071142751037915754\"]//div[@class=\"body-content\"]/div[1]//div[@data-zh-field-name=\"CDARVPROD\"]/span");
    By nomeProdutoTelaInicialProduto1 = By.xpath("//div[@id=\"grid-18945071142751037915754\"]//div[@class=\"body-content\"]/div[1]//div[@data-zh-field-name=\"NMPRODUTO\"]/span");
    By unidadeTelaInicialProduto1 = By.xpath("//div[@id=\"grid-18945071142751037915754\"]//div[@class=\"body-content\"]/div[1]//div[@data-zh-field-name=\"SGUNIDADE\"]/span");

    By descricaoConversaoUnidade1 = By.xpath("//div[@id=\"grid-1894507114884518294756\"]//div[@class=\"body-content\"]/div[1]//div[@data-zh-field-name=\"NAME\"]/span");
    By descricaoConversaoUnidade2 = By.xpath("//div[@id=\"grid-1894507114884518294756\"]//div[@class=\"body-content\"]/div[2]//div[@data-zh-field-name=\"NAME\"]/span");

    By mensagemCantoSuperiorDireito = By.xpath("//*[@class=\"zh-notification-messages\"]//span[@class=\"notification-message-text\"]");
    By mensagemAlerta = By.xpath("//section[@class=\"zh-container-alert\"]//p[@class=\"zh-text-alert\"]");
    By mensagemNenhumRegistroEncontrado = By.xpath("//div[@id=\"grid-18945071142751037915754\"]//div[@class=\"body-content\"]//p");
    By mensagemObrigatorioProduto = By.xpath("//div[@data-zh-id=\"1894507114369353165793\"]//div[@class=\"zh-validation\"]/span");
    By mensagemObrigatorioUnidadeSecundaria = By.xpath("//div[@data-zh-id=\"18945071143976275161799\"]//div[@class=\"zh-validation\"]/span");
    By mensagemObrigatorioRelacao = By.xpath("//div[@data-zh-id=\"1894507114568765171805\"]//div[@class=\"zh-validation\"]/span");



    public void acessarTela() {
        tempoParaAguardarTelaInicial();
        waitForElement(botaoMenu);
        click(botaoMenu);
        sendKeys(campoPesquisar, "Unidade Adicional do Produto");
        click(telaUnidadeAdicionalProduto);
        tempoParaAguardarTelaInicial();
    }

    public void adicionarUnidadeAdicional() {
        tempo();
        tempo();
        tempo();
        click(botaoAdicionarTelaInicial);
        click(botaoCampoProduto);
        sendKeys(campoProcurar, "IODETO DE ARSENIO");
        tempo();
        tempo();
        click(produtoIodetoArsenio);
        tempo();
        click(botaoCampoUnidadeSecundaria);
        sendKeys(campoProcurar, "LATA");
        click(unidadeSecundariaLata);

        click(primeiraOpcaoRelacao);
        sendKeys(campoRelacao, "0,5");
        click(botaoSalvar);

        String mensagem = getText(mensagemCantoSuperiorDireito);
        String mensagemEsperada = "Salvo com sucesso";
        Assert.assertEquals(mensagem, mensagemEsperada, "Verificar mensagem de salvo com sucesso após adicionar uma unidade adicional do produto");
    }

    public void verificarUnidadeAdicionalProdTelaInicial() {
        preencherCampoProcurarTelaInicial("101110201400");
        //valores encontrados
        String encCodigo = getText(codigoTelaInicialProduto1);
        String encProduto = getText(nomeProdutoTelaInicialProduto1);
        String encUnidade = getText(unidadeTelaInicialProduto1);

        //valores esperados
        String expCodigo = "1.01.1.1.02.014.00";
        String expProduto = "IODETO DE ARSENIO";
        String expUnidade = "KG";
        Assert.assertEquals(encCodigo, expCodigo, "Verificar código do produto adicionado");
        Assert.assertEquals(encProduto, expProduto, "Verificar nome do produto adicionado");
        Assert.assertEquals(encUnidade, expUnidade, "Verificar unidade do produto adicionado");
    }

    public void verificarUnidadeAdicionalProdTelaConversao() {
        click(nomeProdutoTelaInicialProduto1);
        String encDescricaoConversao = getText(descricaoConversaoUnidade1);
        String expDescricaoConversao = "1 LATA equivale a 2 QUILOGRAMA(s).";
        Assert.assertEquals(encDescricaoConversao, expDescricaoConversao, "Verificar se relacao da unidade adicional do produto que foi adicionar, foi salva corretamente");

        click(descricaoConversaoUnidade1);
        click(botaoEditarConversao);

        tempo();
        //valores encontrado para a conversão
        String encCodigo = javaScriptExecutor.executeScript("return document.querySelector(\"#CDARVPROD\").value").toString();
        String encProduto = getText(produtoTelaConversaoUnidades);
        String encUnidadePrincipal = javaScriptExecutor.executeScript("return document.querySelector(\"#DSUNIDADEPRIN\").value").toString();
        String encUnidadeSecundaria = getText(unidadeSecundTelaConversaoUnidades);
        boolean encPrimeiraOpRelSelected = returnIfElementIsSelected(inputRadioButtonPrimeiraOpcRel);
        String encDescPrimeiraOpRelacao = getText(primeiraOpcaoRelacao);
        String encRelacaoValor = javaScriptExecutor.executeScript("return document.querySelector(\"#VRFATOCONVES\").value").toString();

        //valores esperados para a conversao
        String expCodigo = "1.01.1.1.02.014.00";
        String expProduto = "IODETO DE ARSENIO";
        String expUnidadePrincipal = "QUILOGRAMA";
        String expUnidadeSecundaria = "LATA";
        boolean expPrimeiraOpRelSelected = true;
        String expDescPrimeiraOpRelacao = "1 QUILOGRAMA (equivale a X LATA).";
        String expRelacaoValor = "0,500";

        Assert.assertEquals(encCodigo, expCodigo, "Verificar 'código' encontrado na tela Conversão de Unidade(s) após acessar uma conversão");
        Assert.assertEquals(encProduto, expProduto, "Verificar 'produto' encontrado na tela Conversão de Unidade(s) após acessar uma conversão");
        Assert.assertEquals(encUnidadePrincipal, expUnidadePrincipal, "Verificar 'unidade principal' encontrado na tela Conversão de Unidade(s) após acessar uma conversão");
        Assert.assertEquals(encUnidadeSecundaria, expUnidadeSecundaria, "Verificar 'unidade secundária' encontrado na tela Conversão de Unidade(s) após acessar uma conversão");
        Assert.assertEquals(encPrimeiraOpRelSelected, expPrimeiraOpRelSelected, "Verificar se a primeira opção de relação está selecionada na tela Conversão de Unidade(s) após acessar uma conversão");
        Assert.assertEquals(encDescPrimeiraOpRelacao, expDescPrimeiraOpRelacao, "Verificar a descrição da primeira opção (que está selecionada) de relação na tela Conversão de Unidade(s) após acessar uma conversão");
        Assert.assertEquals(encRelacaoValor, expRelacaoValor, "Verificar 'relação (valor de x)' encontrado na tela Conversão de Unidade(s) após acessar uma conversão");

        click(botaoCancelar);
        tempo();
        click(botaoVoltar);
    }

    public void excluirUnidadeAdicionalAdd() {
        preencherCampoProcurarTelaInicial("101110201400");
        click(nomeProdutoTelaInicialProduto1);
        click(botaoExcluirConversao);

        String mensagem = getText(mensagemAlerta);
        String mensagemEsperada = "Remover registro?";
        Assert.assertEquals(mensagem, mensagemEsperada, "Verificar mensagem exibida na tela após acessar o produto e clicar para excluir");
        click(botaoSimMensagemAlerta);

        mensagem = getText(mensagemAlerta);
        mensagemEsperada = "Removido com sucesso";
        Assert.assertEquals(mensagem, mensagemEsperada, "Verificar mensagem exibida após excluir a unidade adicionar com sucesso");
        click(botaoOk);

        mensagem = getText(mensagemNenhumRegistroEncontrado);
        mensagemEsperada = "Nenhum registro foi encontrado";
        Assert.assertEquals(mensagem, mensagemEsperada, "Verificar mensagem de nenhum registro encontrado no grid da lista de produto, após a exclusão");
    }

    public void excluirUnidadeAdicionalPelaTelaIni() {
        preencherCampoProcurarTelaInicial("101110201400");
        click(nomeProdutoTelaInicialProduto1);
        tempo();
        click(botaoVoltar);
        tempo();
        click(botaoExcluirTelaInicial);

        String mensagem = getText(mensagemAlerta);
        String mensagemEsperada = "Deseja excluir o produto IODETO DE ARSENIO e todas as suas conversões?";
        Assert.assertEquals(mensagem, mensagemEsperada, "Verificar mensagem exibida na tela após excluir a unidade pela tela inicial");
        click(botaoSimMensagemAlerta);

        mensagem = getText(mensagemAlerta);
        mensagemEsperada = "Removido com sucesso";
        Assert.assertEquals(mensagem, mensagemEsperada, "Verificar mensagem exibida na tela após a exclusão da unidade");
        click(botaoOk);

        preencherCampoProcurarTelaInicial("101110201400");
        mensagem = getText(mensagemNenhumRegistroEncontrado);
        mensagemEsperada = "Nenhum registro foi encontrado";
        Assert.assertEquals(mensagem, mensagemEsperada, "Verificar mensagem no grid da lista de produtos, com o filtro aplicado, informando que nenhum registro foi encontrado");
    }

    public void editarConversao() {
        preencherCampoProcurarTelaInicial("101210100201");
        click(nomeProdutoTelaInicialProduto1);
        tempo();
        click(botaoEditarConversao);

        tempo();
        click(primeiraOpcaoRelacao);
        String relacaoValor = javaScriptExecutor.executeScript("return document.querySelector(\"#VRFATOCONVES\").value").toString();
        Assert.assertEquals(relacaoValor, "0,250", "Verificar valor da relação, quando a primeira opção está selecionada");

        click(segundaOpcaoRelacao);
        tempo();
        boolean segundaOpSelect = returnIfElementIsSelected(inputRadioButtonSegundaOpcRel);
        relacaoValor = javaScriptExecutor.executeScript("return document.querySelector(\"#VRFATOCONVES\").value").toString();
        Assert.assertEquals(segundaOpSelect, true, "Verificar se após clicar na segunda opção, o radio-button da mesma passa a estar selecionado");
        Assert.assertEquals(relacaoValor, "4,000", "Verificar valor da relação após clicar na segunda opção da relação");

        clearAndSendKeys(campoRelacao, "5");
        click(primeiraOpcaoRelacao);
        tempo();
        relacaoValor = javaScriptExecutor.executeScript("return document.querySelector(\"#VRFATOCONVES\").value").toString();
        Assert.assertEquals(relacaoValor, "0,200", "Verificar valor da relação após clicar na segunda opção da relações");
        click(botaoSalvar);

        String mensagem = getText(mensagemCantoSuperiorDireito);
        String mensagemEsperada = "Editado com sucesso.";
        Assert.assertEquals(mensagem, mensagemEsperada, "Verificar mensagem de editado com sucesso após alterar o valor da conversão da unidade");

        String encDescConversao = getText(descricaoConversaoUnidade1);
        String expDescConversao = "1 BARRA equivale a 5 QUILOGRAMA(s).";
        Assert.assertEquals(encDescConversao, expDescConversao, "Verificar se a alteração do valor da conversão foi realizado com sucesso");
    }

    public void reeditarConversao() {
        click(descricaoConversaoUnidade1);
        click(botaoEditarConversao);

        click(primeiraOpcaoRelacao);
        String encDescOpcao = getText(primeiraOpcaoRelacao);
        String expDescOpcao = "1 QUILOGRAMA (equivale a X BARRA).";
        String relacaoValor = javaScriptExecutor.executeScript("return document.querySelector(\"#VRFATOCONVES\").value").toString();
        Assert.assertEquals(encDescOpcao, expDescOpcao, "Verificar opção de relação selecionada");
        Assert.assertEquals(relacaoValor, "0,200", "Verificar valor da relação, com a primeira opção selecionada");

        click(segundaOpcaoRelacao);
        encDescOpcao = getText(segundaOpcaoRelacao);
        expDescOpcao = "1 BARRA (equivale a X QUILOGRAMA).";
        relacaoValor = javaScriptExecutor.executeScript("return document.querySelector(\"#VRFATOCONVES\").value").toString();
        Assert.assertEquals(encDescOpcao, expDescOpcao, "Verificao opção de relacao selecionada");
        Assert.assertEquals(relacaoValor, "5,000", "Verificao valor da relação, com a segunda opção selecionada");

        click(primeiraOpcaoRelacao);
        clearAndSendKeys(campoRelacao, "0,25");
        click(botaoSalvar);
        tempo();
        tempo();

        String encDescricaoConversao = getText(descricaoConversaoUnidade1);
        String expDescricaoConversao = "1 BARRA equivale a 4 QUILOGRAMA(s).";
        Assert.assertEquals(encDescricaoConversao, expDescricaoConversao, "Verificar descrição da conversão após a descrição alteração do valor da conversão");
        click(botaoVoltar);
    }

    public void adicionarSegundaConversaoPelaTelaDeConversao() {
        preencherCampoProcurarTelaInicial("101110201500");
        click(nomeProdutoTelaInicialProduto1);
        click(botaoAdicionarConversao);
        click(botaoCampoUnidadeSecundaria);
        sendKeys(campoProcurar, "COPO");
        click(unidadeSecundariaCopo);
        sendKeys(campoRelacao, "4");
        click(botaoSalvar);

        String mensagem = getText(mensagemCantoSuperiorDireito);
        String mensagemEsperada = "Salvo com sucesso";
        Assert.assertEquals(mensagem, mensagemEsperada, "Verificar mensagem de salvo com sucesso exibida no canto da tela após adicionar uma segunda conversão");
    }

    public void adicionarSegundaConversaPelaTelaInicial() {
        click(botaoAdicionarTelaInicial);
        tempo();
        click(botaoCampoProduto);
        sendKeys(campoProcurar, "IODETO DE CALCIO");
        click(produtoIodetoDeCalcio);
        click(botaoCampoUnidadeSecundaria);
        sendKeys(campoProcurar, "COPO");
        click(unidadeSecundariaCopo);
        sendKeys(campoRelacao, "8");
        click(botaoSalvar);

        String mensagem = getText(mensagemCantoSuperiorDireito);
        String mensagemEsperada = "Salvo com sucesso";
        Assert.assertEquals(mensagem, mensagemEsperada, "Verificar mensagem de sucesso exibida após adicionar uma segunda conversão à um produto. Iniciando a adição pela tela inicial");
        preencherCampoProcurarTelaInicial("101110201500");
        click(nomeProdutoTelaInicialProduto1);

        String encDescSegundaConversao = getText(descricaoConversaoUnidade2);
        String expDescSegundaConversao = "1 COPO equivale a 0.125 QUILOGRAMA(s).";
        String quantConversoes = javaScriptExecutor.executeScript("return document.querySelector(\"#grid-1894507114884518294756 > div.body > div\").childElementCount").toString();
        Assert.assertEquals(quantConversoes, "2", "Verificar se a unidade possui duas conversões");
        Assert.assertEquals(encDescSegundaConversao, expDescSegundaConversao, "Verificar a descrição da segunda conversão adicionada");
    }

    public void verificarSegundaConversaoAdicionada() {
        String encDescConversao = getText(descricaoConversaoUnidade2);
        String expDescConversao = "1 COPO equivale a 0.25 QUILOGRAMA(s).";
        String quantConversoes = javaScriptExecutor.executeScript("return document.querySelector(\"#grid-1894507114884518294756 > div.body > div\").childElementCount").toString();
        Assert.assertEquals(quantConversoes, "2", "Verificar se a unidade possui 2 conversões");
        Assert.assertEquals(encDescConversao, expDescConversao, "Verificar descrição da segundo conversão adicionada");

        click(descricaoConversaoUnidade2);
        click(botaoEditarConversao);
        click(primeiraOpcaoRelacao);
        String encPrimeiraOp = getText(primeiraOpcaoRelacao);
        String expPrimeiraOp = "1 QUILOGRAMA (equivale a X COPO).";
        String relacaoValor = javaScriptExecutor.executeScript("return document.querySelector(\"#VRFATOCONVES\").value").toString();
        Assert.assertEquals(encPrimeiraOp, expPrimeiraOp, "Verificar primeira opção da relação, da segunda conversão adicionada");
        Assert.assertEquals(relacaoValor, "4,000", "Verificar relação valor da primeira opção da relação, da segunda conversão adicionada");

        click(segundaOpcaoRelacao);
        String encSegundaOp = getText(segundaOpcaoRelacao);
        String expSegundaOp = "1 COPO (equivale a X QUILOGRAMA).";
        relacaoValor = javaScriptExecutor.executeScript("return document.querySelector(\"#VRFATOCONVES\").value").toString();
        Assert.assertEquals(encSegundaOp, expSegundaOp, "Verificar primeira opção da relação, da segunda conversão adicionada");
        Assert.assertEquals(relacaoValor, "0,250", "Verificar relação valor da primeira opção da relação, da segunda conversão adicionada");
        click(botaoCancelar);
    }

    public void excluirSegundaConversao() {
        tempo();
        click(descricaoConversaoUnidade2);
        tempo();
        click(botaoExcluirConversao);

        String mensagem = getText(mensagemAlerta);
        String mensagemEsperada = "Remover registro?";
        Assert.assertEquals(mensagem, mensagemEsperada, "Verificar mensagem exibida na tela após clicar para excluir uma conversão");
        click(botaoSimMensagemAlerta);

        mensagem = getText(mensagemAlerta);
        mensagemEsperada = "Removido com sucesso";
        Assert.assertEquals(mensagem, mensagemEsperada, "Verificar mesagem exibida na tela após excluir uma conversão");
        click(botaoOk);

        preencherCampoProcurarTelaInicial("101110201500");
        click(nomeProdutoTelaInicialProduto1);
        tempo();
        String quantConversoes = javaScriptExecutor.executeScript("return document.querySelector(\"#grid-1894507114884518294756 > div.body > div\").childElementCount").toString();
        Assert.assertEquals(quantConversoes, "1", "Verificar se após a exclusão da segunda conversão, o produto passa a ter apenas uma conversão");
    }

    public void tentarAdicionarConversaoJaExistente() {
        preencherCampoProcurarTelaInicial("101110201500");
        tempo();
        click(nomeProdutoTelaInicialProduto1);
        String valorDescConversaoIniTeste = getText(descricaoConversaoUnidade1);
        click(botaoVoltar);
        tempo();

        //iniciando a adicionar da unidade, por meio da tela inicial
        click(botaoAdicionarTelaInicial);
        click(botaoCampoProduto);
        sendKeys(campoProcurar, "IODETO DE CALCIO");
        click(produtoIodetoDeCalcio);
        adicionarUniBalde();

        String mensagem = getText(mensagemAlerta);
        String mensagemEsperada = "Impossível adicionar. Registro já existe.";
        Assert.assertEquals(mensagem, mensagemEsperada, "Verificar mensagem exibida na tela após tentar adicionar uma conversão que já existe");
        click(botaoOk);
        tempo();
        click(botaoCancelar);

        preencherCampoProcurarTelaInicial("101110201500");
        click(nomeProdutoTelaInicialProduto1);
        Assert.assertEquals(getText(descricaoConversaoUnidade1), valorDescConversaoIniTeste, "Verificar se o valor da conversão já existia não teve seu valor alterado ao tentar adicionar iniciando pela tela inicial");

        tempo();
        String quantConversoes = javaScriptExecutor.executeScript("return document.querySelector(\"#grid-1894507114884518294756 > div.body > div\").childElementCount").toString();
        Assert.assertEquals(quantConversoes, "1", "Verificar se após tentar adicionar uma conversão que já existente, o produto continua tendo apenas uma conversão. Iniciando a adição conversão pela tela inicial");

        //iniciando a adição da unidade, já tendo acessado o produto que já possui conversão
        click(botaoAdicionarConversao);
        adicionarUniBalde();
        mensagem = getText(mensagemAlerta);
        mensagemEsperada = "Impossível adicionar. Registro já existe.";
        Assert.assertEquals(mensagem, mensagemEsperada, "Verificar mensagem exibida na tela após tentar adicionar uma conversão que já existe");
        click(botaoOk);
        tempo();
        click(botaoCancelar);

        tempo();
        quantConversoes = javaScriptExecutor.executeScript("return document.querySelector(\"#grid-1894507114884518294756 > div.body > div\").childElementCount").toString();
        Assert.assertEquals(quantConversoes, "1", "Verificar se após tentar adicionar uma conversão já existente, o produto continua tendo apenas uma conversão. Iniciando a adição pela tela Conversão de Unidade(s)");
        Assert.assertEquals(getText(descricaoConversaoUnidade1), valorDescConversaoIniTeste, "Verificar se o valor da conversão que já existia não teve seu valor alterado ao tentar adicionar, iniciando a adição pela tela de conversão");
    }

    public void mensagemXDeveSerMaiorQueZero() {
        click(botaoAdicionarTelaInicial);
        click(botaoCampoProduto);
        sendKeys(campoProcurar, "IODETO DE ARSENIO");
        click(produtoIodetoArsenio);
        click(botaoCampoUnidadeSecundaria);
        sendKeys(campoProcurar, "COPO");
        click(unidadeSecundariaCopo);
        sendKeys(campoRelacao, "0");
        click(botaoSalvar);

        String mensagem = getText(mensagemAlerta);
        String mensagemEsperada = "Relação (Valor de X) deve ser maior que zero.";
        Assert.assertEquals(mensagem, mensagemEsperada, "Verificar mensagem exibida na tela, após tentar adicionar uma conversão com o valor de x igual a 0");
        click(botaoOk);
        tempo();
        click(botaoCancelar);

        preencherCampoProcurarTelaInicial("101150200100");
        click(nomeProdutoTelaInicialProduto1);
        click(descricaoConversaoUnidade1);
        click(botaoEditarConversao);
        clearAndSendKeys(campoRelacao, "0");
        click(botaoSalvar);

        mensagem = getText(mensagemAlerta);
        mensagemEsperada = "Relação (Valor de X) deve ser maior que zero.";
        Assert.assertEquals(mensagem, mensagemEsperada, "Verificar mensagem exibida na tela, após tentar editar uma conversão com o valor de x igual a 0");
        click(botaoOk);
        tempo();
        click(botaoCancelar);
    }

    public void camposObrigatorios() {
        click(botaoAdicionarTelaInicial);
        click(botaoSalvar);

        String produto = getText(mensagemObrigatorioProduto);
        String unidadeSecundaria = getText(mensagemObrigatorioUnidadeSecundaria);
        String relacaoValor = getText(mensagemObrigatorioRelacao);
        String mensagemEsperada = "Campo obrigatório";

        Assert.assertEquals(produto, mensagemEsperada, "Verificar mensagem de campo obrigatório no campo 'produto' para adicionar uma unidade adicional do produto");
        Assert.assertEquals(unidadeSecundaria, mensagemEsperada, "Verificar mensagem de campo obrigatório no campo 'unidade secundária' para adicionar uma unidade adicional do produto");
        Assert.assertEquals(relacaoValor, mensagemEsperada, "Verificar mensagem de campo obrigatório no campo 'relação (valor de x)' para adicionar uma unidade adicional do produto");
    }

    private void adicionarUniBalde() {
        click(botaoCampoUnidadeSecundaria);
        sendKeys(campoProcurar, "BALDE");
        click(unidadeSecundariaBalde);
        sendKeys(campoRelacao, "2,5");
        click(botaoSalvar);
    }

    private void preencherCampoProcurarTelaInicial(String texto) {
        tempo();
        tempo();
        tempo();
        if (returnClassOpened(botaoDeOpcoesDaTela) && !returnClassOpened(botaoPesquisar)) {
            click(botaoPesquisar);
        } else if (!returnClassOpened(botaoDeOpcoesDaTela)){
            click(botaoDeOpcoesDaTela);
            click(botaoPesquisar);
        }
        tempo();
        tempo();
        clearAndSendKeys(campoProcurarTelaInicial, texto);
        tempo();
    }

    private boolean returnClassOpened(By locator) {
        return driver.findElement(locator).getAttribute("className").contains("opened");
    }

}