package com.javaseleniumtemplate.tests;

import com.javaseleniumtemplate.bases.TestBase;
import com.javaseleniumtemplate.flows.AprovacaoCardapioMatrizFlows;
import com.javaseleniumtemplate.flows.LoginFlows;
import net.bytebuddy.asm.Advice;
import org.apache.log4j.helpers.DateTimeDateFormat;
import org.testng.Assert;
import org.testng.annotations.Test;

import java.sql.DataTruncation;
import java.text.SimpleDateFormat;
import java.time.format.DateTimeFormatter;
import java.util.Date;

public class AprovacaoCardapioMatrizTests extends TestBase {

    LoginFlows loginFlows;
    AprovacaoCardapioMatrizFlows aprovacaoCardapioMatrizFlows;

    public void acessarTelaAprovacao(String filtraAgrupamento, String tipoAcao,String tipoFiltro){
        loginFlows = new LoginFlows();
        aprovacaoCardapioMatrizFlows = new AprovacaoCardapioMatrizFlows();

        loginFlows.efetuarLogin();
        aprovacaoCardapioMatrizFlows.acessarTela();
        if (tipoAcao != "validar"){
            aprovacaoCardapioMatrizFlows.realizaFiltros(filtraAgrupamento,tipoFiltro);
        }
    }

    @Test
    public void aprovaCardapioMatriz() {
        Date dt = new Date();
        String dataAprovacao = new SimpleDateFormat("dd/MM/yyyy").format(dt);
        String filtraAgrupamento = "S";
        String tipoAcao = "Aprovar";
        String tipoFiltro = "Filtrar";
        acessarTelaAprovacao(filtraAgrupamento,tipoAcao,tipoFiltro);
        aprovacaoCardapioMatrizFlows.aprovaCardapio();
        Assert.assertEquals(aprovacaoCardapioMatrizFlows.validaDataAprovacao(),dataAprovacao,"Data aprovação cardápio: ");

    }

    @Test
    public void cancelarAprovacaoCardapio(){
        String filtraAgrupamento = "N";
        String tipoAcao = "Cancelar";
        String tipoFiltro = "Filtrar";
        acessarTelaAprovacao(filtraAgrupamento,tipoAcao,tipoFiltro);
        aprovacaoCardapioMatrizFlows.cancelarAprovacao();
    }

    @Test
    public void validarCamposObrigatorios(){
        String filtraAgrupamento = "N";
        String tipoAcao = "validar";
        String tipoFiltro = "Filtrar";
        String MSGESPERADA = "Campo obrigatório";
        acessarTelaAprovacao(filtraAgrupamento,tipoAcao,tipoFiltro);
        aprovacaoCardapioMatrizFlows.validaCamposObrigatorios();
        Assert.assertEquals(aprovacaoCardapioMatrizFlows.campoObrigatorioUnidade(),MSGESPERADA,"Campo Unidade: ");
        Assert.assertEquals(aprovacaoCardapioMatrizFlows.campoObrigatorioServico(),MSGESPERADA,"Campo Serviço: ");
        Assert.assertEquals(aprovacaoCardapioMatrizFlows.campoObrigatorioUCusto(),MSGESPERADA,"Campo Tipo Custo: ");
        Assert.assertEquals(aprovacaoCardapioMatrizFlows.campoObrigatorioCardapio(),MSGESPERADA,"Campo Cardápio de: ");

    }

    @Test
    public void aprovarCardapioTodos(){
        Date dt = new Date();
        String dataAprovacao = new SimpleDateFormat("dd/MM/yyyy").format(dt);
        String filtraAgrupamento = "N";
        String tipoAcao = "Aprovar";
        String tipoFiltro = "Todos";
        acessarTelaAprovacao(filtraAgrupamento,tipoAcao,tipoFiltro);
        aprovacaoCardapioMatrizFlows.aprovarTodos();
        Assert.assertEquals(aprovacaoCardapioMatrizFlows.validaDataAprovacao(),dataAprovacao,"Data aprovação Serviço 1: ");
        Assert.assertEquals(aprovacaoCardapioMatrizFlows.validaDataAprovacaoCard(),dataAprovacao,"Data aprovação Servico 2: ");

    }


}
