package com.javaseleniumtemplate.tests;

import com.javaseleniumtemplate.bases.TestBase;
import com.javaseleniumtemplate.flows.EmissaoRetiradasFlows;
import com.javaseleniumtemplate.flows.LoginFlows;
import com.javaseleniumtemplate.pages.EmissaoRetiradasPage;
import org.testng.annotations.Test;

public class EmissaoRetiradasTests extends TestBase {

    EmissaoRetiradasPage emissaoRetiradasPage;
    EmissaoRetiradasFlows emissaoRetiradasFlows;
    LoginFlows loginFlows;

    @Test
    public void relatorioOrdenadoPorData() {
        gerarRelatorio("Retirada Planejamento (Ordenado por Data)");
    }

    @Test
    public void relatorioOrdenadoPorServico() {
        gerarRelatorio("Retirada Planejamento (Ordenado por Serviço)");
    }

    @Test
    public void relatorioAcumuladoAnalitico() {
        gerarRelatorio("Retirada Planejamento (Acumulado Analítico)");
    }

    @Test
    public void relatorioAcumuladoSintetico() {
        gerarRelatorio("Retirada Planejamento (Acumulado Sintético)");
    }

    @Test
    public void relatorioProdRetNaoAtualizadosEstoque() {
        gerarRelatorio("Produtos Retirados não atualizados no Estoque");
    }


    //acessar a tela 'Emissão das Retiradas'
    //selecionar o relatório que foi passado como parâmetro
    //selecionar a unidade Deposito Jabaquara, preencher as datas inicial e final
    //gerar o relatório, fechar a guia do relatório gerado
    //clicar no campo almoxarifado, selecionar o almoxarifado MATERIA PRIMA QUARENTENA
    //clicar no check-box 'todos' serviços, clicar no campo serviço, selecionar os serviços Almoço Especial e Jantar, clicar em ok
    //selecionar o check-box 'Imprimir Quantidade Zero', gerar o relatório e fechar a guia do relatório gerado
    public void gerarRelatorio(String nomeRelatorio) {
        emissaoRetiradasPage = new EmissaoRetiradasPage();
        emissaoRetiradasFlows = new EmissaoRetiradasFlows();
        loginFlows = new LoginFlows();

        String dataInicial = "01/03/2023";
        String dataFinal = "31/03/2023";

        loginFlows.efetuarLogin();
        emissaoRetiradasFlows.navegateEmissaoDasRetiradas();
        emissaoRetiradasPage.selecionarRelatorio(nomeRelatorio);
        emissaoRetiradasPage.selecionarUnidade();
        emissaoRetiradasPage.preencherDatas(dataInicial, dataFinal);
        emissaoRetiradasPage.geraRelatorio();
        emissaoRetiradasPage.selecionarAlmoxarifado();
        emissaoRetiradasPage.selecionarServicos();
        emissaoRetiradasPage.selecionarImprimirQuantZero();
        emissaoRetiradasPage.geraRelatorio();
    }



    //acessar a tela 'Emissão das Retiradas'
    //clicar no botão do campo relatório, clicar no botão do campo unidade, clicar no botão do campo intervalo de data
    //clicar no check-box 'Todos' do campo serviço, clicar no botão do campo nível para totalização, clicar no botão relatório
    //verificar a mensagem de campo obrigatório nos campos: relatório, unidade, intervalo de data, serviço e nível para totalização
    //atualizar página, verificar se a opção de ordenação de código está selecionada e a alfabética não
    //clicar na opção alfabética e verificar se a mesma passar a estar selecionada e a opção código não
    //clicar no campo nível para totalização, verificar se possui 6 opção de níveis, clicar no nível 3 e verificar se o mesmo passa a estar selecionado
    @Test
    public void camposObrigatoriosOrdenacaoNiveis() {
        emissaoRetiradasPage = new EmissaoRetiradasPage();
        emissaoRetiradasFlows = new EmissaoRetiradasFlows();
        loginFlows = new LoginFlows();

        loginFlows.efetuarLogin();
        emissaoRetiradasFlows.navegateEmissaoDasRetiradas();
        emissaoRetiradasPage.campoObrigatorios();
        emissaoRetiradasPage.refresh();
        emissaoRetiradasPage.verificarOpcoesDeOrdenacao();
        emissaoRetiradasPage.verificarNiveisDeTotalizacao();
    }



}
