package com.javaseleniumtemplate.tests;

import com.javaseleniumtemplate.bases.TestBase;
import com.javaseleniumtemplate.flows.FrequenciaPratoMesSemanaFlows;
import com.javaseleniumtemplate.flows.LoginFlows;
import org.testng.Assert;
import org.testng.annotations.Test;

public class FrequenciaPratoMesSemanaTests extends TestBase {

    LoginFlows loginFlows;
    FrequenciaPratoMesSemanaFlows frequenciaPratoMesSemanaFlows;

    public void acessarTelaFrequencia(String nomeOpcao, String CDFILIAl){
        loginFlows = new LoginFlows();
        frequenciaPratoMesSemanaFlows = new FrequenciaPratoMesSemanaFlows();

        loginFlows.efetuarLogin();
        frequenciaPratoMesSemanaFlows.acessarTelaFrequencia();
        if (CDFILIAl == " ") {
            frequenciaPratoMesSemanaFlows.realizarFiltroContrato(nomeOpcao, "0002");
        }else {
            frequenciaPratoMesSemanaFlows.realizarFiltroContrato(nomeOpcao, "0003");
        }
    }

    public void cadastraFrequencia(){
        String MSGENCONTRADA = "00.00.00.000";
        String MSGLOCALIZADA = "00.01.00.000";

        frequenciaPratoMesSemanaFlows.validarCamposObrigatorios();
        frequenciaPratoMesSemanaFlows.realizarCadastro();
        frequenciaPratoMesSemanaFlows.relacionarServico();
        Assert.assertEquals(frequenciaPratoMesSemanaFlows.retornaCadastroArroz(),MSGENCONTRADA,"Valida Cadastro Prato Arroz");
        Assert.assertEquals(frequenciaPratoMesSemanaFlows.retornaCadastroStrogonoff(),MSGLOCALIZADA,"Valida Cadastro Prato Strogonoff");
        frequenciaPratoMesSemanaFlows.validarRegistroIgual();
    }

    public void editarFrequencia(){
        String QTDMINMESPRATARROZ = "5";
        String QTDMAXMESPRATARROZ = "5";
        String QTDMAXSEMANAPRATARROZ = "5";
        String QTDMINMESPRATSTROG = "2";
        String QTDMAXMESPRATSTROG = "3";
        String QTDMAXSEMANAPRATSTROG = "2";
        String MSGESPERADA = "VIGENCIA AUTOMAÇÃO";
        frequenciaPratoMesSemanaFlows.editarServicoFrequencia();
        Assert.assertEquals(frequenciaPratoMesSemanaFlows.retornaMinInsercaoArroz(),QTDMINMESPRATARROZ,"Mín. Inserções/ Mês Arroz: ");
        Assert.assertEquals(frequenciaPratoMesSemanaFlows.retornaMaxInsercaoArroz(),QTDMAXMESPRATARROZ,"Max. Inserções/ Mês Arroz: ");
        Assert.assertEquals(frequenciaPratoMesSemanaFlows.retornaMaxInsercaoSemanaArroz(),QTDMAXSEMANAPRATARROZ,"Maz. Inserções/ Semana Arroz: ");
        Assert.assertEquals(frequenciaPratoMesSemanaFlows.retornaMinInsercaoStrogonoff(),QTDMINMESPRATSTROG,"Mín. Inserções/ Mês Strogonoff: ");
        Assert.assertEquals(frequenciaPratoMesSemanaFlows.retornaMaxInsercaoStrogonoff(),QTDMAXMESPRATSTROG,"Max. Inserções/ Mês Strogonoff: ");
        Assert.assertEquals(frequenciaPratoMesSemanaFlows.retornaMaxInsercaoSemanaStrogonoff(),QTDMAXSEMANAPRATSTROG,"Max. Inserções/ Semana Strogonoff: ");
        frequenciaPratoMesSemanaFlows.editarVigenciaFrequencia();
        Assert.assertEquals(frequenciaPratoMesSemanaFlows.validaAlteracaoDescricao(),MSGESPERADA,"Falha ao alterar descrição : ");

    }

    public void importarServicoVigencia(String opcao) {
        String CDJANTA = "00002";
        String CDALMOÇO  = "00003";
        frequenciaPratoMesSemanaFlows.importarServicoVigencia(opcao);
        if (opcao == "Acrescentar"){
        Assert.assertEquals(frequenciaPratoMesSemanaFlows.retornarServicoJanta(), CDJANTA, "Falha ao acrescentar  na importação do  serviço Janta: ");
        Assert.assertEquals(frequenciaPratoMesSemanaFlows.retornarServicoAlmoco(), CDALMOÇO, "Falha ao acrescentar  na importação do serviço Almoço: ");
        }else {
            Assert.assertEquals(frequenciaPratoMesSemanaFlows.retornarServicoAlmoco(), CDALMOÇO, "Falha encontrada no serviço Almoço: ");
        }

    }

    public void exportarVigencia(){

        frequenciaPratoMesSemanaFlows.exportarVigenciaServico();
    }

    public void exportarVigenciaUnidades(String tipoExportacao){
        frequenciaPratoMesSemanaFlows.exportarVigenciaUnidades(tipoExportacao);
    }

    public void excluirServicoVigencia(String abaExclusao){
        String MSGESPERADA = "Não há registros";
        frequenciaPratoMesSemanaFlows.excluirServicoVigencia();
        Assert.assertEquals(frequenciaPratoMesSemanaFlows.validarExclusao(abaExclusao),MSGESPERADA,"Falha ao excluir os serviços: ");
    }

    public void excluirVigenciaContrato(String abaExclusao){
        String MSGESPERADA = "Excluído com sucesso.";
        frequenciaPratoMesSemanaFlows.excluirVigencia();
        Assert.assertEquals(frequenciaPratoMesSemanaFlows.validarExclusao(abaExclusao),MSGESPERADA,"Falha ao excluir vigência: ");
    }

    public void emitirRelatorio(){
        frequenciaPratoMesSemanaFlows.emitirRelatorioVigencia();

    }


    @Test
    public void cadastraFrequenciaPlanejado(){
        String nomeOpcao = "Planejado";
        String CDFILIAl = " ";
        acessarTelaFrequencia(nomeOpcao,CDFILIAl);
        cadastraFrequencia();

    }

    @Test
    public void editarFrequenciaPlanejado(){
        String nomeOpcao = "Planejado";
        String CDFILIAl = " ";
        acessarTelaFrequencia(nomeOpcao, CDFILIAl);
        editarFrequencia();
    }

    @Test
    public void importarServicoPlanejadoAcrescentar(){
        String nomeOpcao = "Planejado";
        String radioTipo = "Acrescentar";
        String CDFILIAl = "0003";
        acessarTelaFrequencia(nomeOpcao,CDFILIAl);
        importarServicoVigencia(radioTipo);

    }

    @Test
    public void importarServicoPlanejadoSobrepor(){
        String nomeOpcao = "Planejado";
        String radioTipo = "Sobrepor";
        String CDFILIAl = "0003";
        acessarTelaFrequencia(nomeOpcao,CDFILIAl);
        importarServicoVigencia(radioTipo);
    }

    @Test
    public void exportarVigenciaPlanejado(){
        String nomeOpcao = "Planejado";
        String CDFILIAl = "0003";
        acessarTelaFrequencia(nomeOpcao,CDFILIAl);
        exportarVigencia();

    }

    @Test
    public void exportarVigenciaUnidadePla(){
        String nomeOpcao = "Planejado";
        String CDFILIAl = "0003";
        String tipoExportacao = "Acrescentar";
        acessarTelaFrequencia(nomeOpcao, CDFILIAl);
        exportarVigenciaUnidades(tipoExportacao);
    }

    @Test
    public void sobreporExportarVigenciaUnidadePla(){
        String nomeOpcao = "Planejado";
        String CDFILIAl = "0003";
        String tipoExportacao = "Sobrepor";
        acessarTelaFrequencia(nomeOpcao, CDFILIAl);
        exportarVigenciaUnidades(tipoExportacao);
    }

    @Test
    public void excluirServicoVigênciaPlanejado(){
        String nomeOpcao = "Planejado";
        String abaExclusao = "Serviço";
        String CDFILIAl = " ";
        acessarTelaFrequencia(nomeOpcao,CDFILIAl);
        excluirServicoVigencia(abaExclusao);

    }

    @Test
    public void excluirVigênciaPlanejado(){
        String nomeOpcao = "Planejado";
        String abaExclusao = "Vigência Contrato";
        String CDFILIAl = " ";
        acessarTelaFrequencia(nomeOpcao,CDFILIAl);
        excluirVigenciaContrato(abaExclusao);

    }

    @Test
    public void emitirRelatorioVigenciaPlanejado(){
        String nomeOpcao = "Planejado";
        String CDFILIAl = " ";
        acessarTelaFrequencia(nomeOpcao,CDFILIAl);
        emitirRelatorio();
    }

    @Test
    public void cadastraFrequenciaContrato(){
        String nomeOpcao = "Contrato";
        String CDFILIAl = " ";
        acessarTelaFrequencia(nomeOpcao,CDFILIAl);
        cadastraFrequencia();

    }

    @Test
    public void editarFrequenciaContrato(){
        String nomeOpcao = "Contrato";
        String CDFILIAl = " ";
        acessarTelaFrequencia(nomeOpcao, CDFILIAl);
        editarFrequencia();
    }

    @Test
    public void importarServicoContratoAcrescentar(){
        String nomeOpcao = "Contrato";
        String radioTipo = "Acrescentar";
        String CDFILIAl = "0003";
        acessarTelaFrequencia(nomeOpcao,CDFILIAl);
        importarServicoVigencia(radioTipo);

    }

    @Test
    public void importarServicoContratoSobrepor(){
        String nomeOpcao = "Contrato";
        String radioTipo = "Sobrepor";
        String CDFILIAl = "0003";
        acessarTelaFrequencia(nomeOpcao,CDFILIAl);
        importarServicoVigencia(radioTipo);
    }

    @Test
    public void exportarVigenciaContrato(){
        String nomeOpcao = "Contrato";
        String CDFILIAl = "0003";
        acessarTelaFrequencia(nomeOpcao,CDFILIAl);
        exportarVigencia();

    }

    @Test
    public void exportarVigenciaUnidadeContrato(){
        String nomeOpcao = "Contrato";
        String CDFILIAl = "0003";
        String tipoExportacao = "Acrescentar";
        acessarTelaFrequencia(nomeOpcao, CDFILIAl);
        exportarVigenciaUnidades(tipoExportacao);
    }

    @Test
    public void sobreporExportarVigenciaUnidadeContrato(){
        String nomeOpcao = "Contrato";
        String CDFILIAl = "0003";
        String tipoExportacao = "Sobrepor";
        acessarTelaFrequencia(nomeOpcao, CDFILIAl);
        exportarVigenciaUnidades(tipoExportacao);
    }

    @Test
    public void excluirServicoVigênciaContrato(){
        String nomeOpcao = "Contrato";
        String abaExclusao = "Serviço";
        String CDFILIAl = " ";
        acessarTelaFrequencia(nomeOpcao,CDFILIAl);
        excluirServicoVigencia(abaExclusao);

    }

    @Test
    public void excluirVigênciaContrato(){
        String nomeOpcao = "Contrato";
        String abaExclusao = "Vigência Contrato";
        String CDFILIAl = " ";
        acessarTelaFrequencia(nomeOpcao,CDFILIAl);
        excluirVigenciaContrato(abaExclusao);

    }

    @Test
    public void emitirRelatorioVigenciaContrato(){
        String nomeOpcao = "Contrato";
        String CDFILIAl = " ";
        acessarTelaFrequencia(nomeOpcao,CDFILIAl);
        emitirRelatorio();
    }


    }
