package com.javaseleniumtemplate.tests;

import com.javaseleniumtemplate.bases.TestBase;
import com.javaseleniumtemplate.flows.GrupoDePratoFlows;
import com.javaseleniumtemplate.flows.LoginFlows;
import org.testng.Assert;
import org.testng.annotations.Test;

public class GrupoDePratoTests extends TestBase {
    GrupoDePratoFlows grupoDePratoFlows;

    public void acessarTela(){
        LoginFlows loginFlows = new LoginFlows();
        grupoDePratoFlows = new GrupoDePratoFlows();
        GrupoDePratoFlows grupoDePratoFlows = new GrupoDePratoFlows();
        loginFlows.efetuarLogin();
        grupoDePratoFlows.acessarTelaGrupoDePrato();


    }

    @Test
    public void cadastrarGrupoDePrato(){
        String tipoContrato = "Planejado";
        String cdFilial = "0002";
        String cdGrupo = "0000000003";
        String cdServico = "00002";
        acessarTela();
        grupoDePratoFlows.realizarFiltro(tipoContrato,cdFilial);
        grupoDePratoFlows.cadastrarGrupo(cdGrupo,cdServico);
    }

    @Test
    public void editarGrupoPrato(){
        String tipoContrato = "Planejado";
        String cdFilial = "0002";
        String nmServico = "JANTAR";
        String nmAgrupamento = "ESTOCADOS";
        String cdServico = "00003";
        acessarTela();
        grupoDePratoFlows.realizarFiltro(tipoContrato,cdFilial);
        grupoDePratoFlows.alterarGrupo(cdServico);
        Assert.assertEquals(grupoDePratoFlows.retornaCodigoServico(),cdServico,"Código Ssrviço cadastrado: ");
        Assert.assertEquals(grupoDePratoFlows.retornaNomeServico(),nmServico,"Nome serviço cadastrado: ");
        Assert.assertEquals(grupoDePratoFlows.retornaNomeAgrupamento(),nmAgrupamento,"Agrupamento serviço cadastrado: ");
    }

    @Test
    public void excluirServicoRelacionado(){
        String tipoContrato = "Planejado";
        String cdFilial = "0002";
        acessarTela();
        grupoDePratoFlows.realizarFiltro(tipoContrato,cdFilial);
        grupoDePratoFlows.excluirServicoAgrupamento();
    }

    @Test
    public void excluirGrupoDeprato(){
        String tipoContrato = "Planejado";
        String cdFilial = "9999";
        acessarTela();
        grupoDePratoFlows.realizarFiltro(tipoContrato,cdFilial);
        grupoDePratoFlows.excluirGrupoDePrato();
    }

    @Test
    public void validarRegistroIgual(){
        String tipoContrato = "Planejado";
        String cdFilial = "9999";
        acessarTela();
        grupoDePratoFlows.realizarFiltro(tipoContrato,cdFilial);
        grupoDePratoFlows.validarCadastroRegistroIgual();

    
    }

    @Test
    public void cadastrarGrupoDePratoContrato(){
        String tipoContrato = "Contrato";
        String cdFilial = "0002";
        String cdGrupo = "0000000003";
        String cdServico = "00002";
        acessarTela();
        grupoDePratoFlows.realizarFiltro(tipoContrato,cdFilial);
        grupoDePratoFlows.cadastrarGrupo(cdGrupo,cdServico);
    }

    @Test
    public void editarGrupoPratoContrato(){
        String tipoContrato = "Contrato";
        String cdFilial = "0002";
        String nmServico = "JANTAR";
        String nmAgrupamento = "ESTOCADOS";
        String cdServico = "00003";
        acessarTela();
        grupoDePratoFlows.realizarFiltro(tipoContrato,cdFilial);
        grupoDePratoFlows.alterarGrupo(cdServico);
        Assert.assertEquals(grupoDePratoFlows.retornaCodigoServico(),cdServico,"Código Ssrviço cadastrado: ");
        Assert.assertEquals(grupoDePratoFlows.retornaNomeServico(),nmServico,"Nome serviço cadastrado: ");
        Assert.assertEquals(grupoDePratoFlows.retornaNomeAgrupamento(),nmAgrupamento,"Agrupamento serviço cadastrado: ");
    }

    @Test
    public void excluirServicoRelacionadoContrato(){
        String tipoContrato = "Contrato";
        String cdFilial = "0002";
        acessarTela();
        grupoDePratoFlows.realizarFiltro(tipoContrato,cdFilial);
        grupoDePratoFlows.excluirServicoAgrupamento();
    }

    @Test
    public void excluirGrupoDepratoContrato(){
        String tipoContrato = "Contrato";
        String cdFilial = "9999";
        acessarTela();
        grupoDePratoFlows.realizarFiltro(tipoContrato,cdFilial);
        grupoDePratoFlows.excluirGrupoDePrato();
    }

    @Test
    public void validarRegistroIgualContrato(){
        String tipoContrato = "Contrato";
        String cdFilial = "9999";
        acessarTela();
        grupoDePratoFlows.realizarFiltro(tipoContrato,cdFilial);
        grupoDePratoFlows.validarCadastroRegistroIgual();


    }

}
