package com.javaseleniumtemplate.tests;

import com.javaseleniumtemplate.bases.TestBase;
import com.javaseleniumtemplate.flows.LoginFlows;
import com.javaseleniumtemplate.flows.ServicoXCicloFlows;
import com.javaseleniumtemplate.pages.ServicoXCicloPage;
import org.testng.annotations.Test;

public class ServicoXCicloTests extends TestBase {

    ServicoXCicloPage servicoXCicloPage;
    ServicoXCicloFlows servicoXCicloFlows;
    LoginFlows loginFlows;


    //acessar a tela 'Serviço x Ciclo'
    //clicar no campo ciclo, selecionar o ciclo de 'produção', clicar no botão 'aplicar filtro'
    //clicar no botão adicionar, clicar no campo unidade, selecionar a unidade '0004 | FARMACIA BC 121', clicar no campo serviço e selecionar o serviço '00002 | JANTA'
    //clicar no campo padrão de ciclo, selecionar padrão de 'compras'
    //clicar no campo mês inicial e selecionar 01/2030, clicar no campo número do ciclo e selecionar a opção '3 | 01/2030'
    //clicar no botão salvar, verificar a mensagem de registro adicionado com sucesso exibida no canto da tela
    //verificar na tela inicial se as informações (unidade, serviço, padrão de ciclo, mês inicial e Nº do ciclo) foram salvos corretamente
    //clicar no nome da unidade, verificar na aba histórico se as informações (ciclo, padrão de ciclo, mês inicial e Nº ciclo) foram salvos corretamente
    //clicar no botão voltar, clicar no check-box do serviço x ciclo adicionado, clicar no botão excluir
    //verificar a mensagem exibida na tela, clicar em sim e verificar a mensagem de excluído com sucesso exibida no canto da tela
    @Test
    public void adicionarExcluirServicoXCiclo() {
        servicoXCicloPage = new ServicoXCicloPage();
        servicoXCicloFlows = new ServicoXCicloFlows();
        loginFlows = new LoginFlows();

        loginFlows.efetuarLogin();
        servicoXCicloFlows.navegateTelaServicoXCiclo();
        servicoXCicloPage.preencherFiltroCicloProducao();
        servicoXCicloPage.adicionarServicoXCiclo();
        servicoXCicloPage.verificarServicoXCicloAdd();
        servicoXCicloPage.verificarHistoricoSerXCicloAdicionado();
        servicoXCicloPage.excluirServicoXCicloAdicionado();
    }


    //acessar a tela 'Serviço x Ciclo'
    //clicar no campo ciclo, selecionar o ciclo de 'retirada', clicar no botão 'aplicar filtro'
    //clicar no botão adicionar, clicar no campo unidade, selecionar a unidade '0002 | DEPOSITO JABAQUARA', clicar no campo serviço e selecionar o serviço '00002 | ALMOÇO ESPECIAL'
    //clicar no campo padrão de ciclo, selecionar padrão de 'vendas'
    //clicar no campo mês inicial e selecionar 07/2031, clicar no campo número do ciclo e selecionar a opção '3 | 07/2031', clicar no botão salvar
    //verificar se na segunda linha do grid da lista de serviço x ciclo as informações (unidade, serviço, padrão de ciclo, mês inicial e Nº do ciclo) foram salvos corretamente
    //clicar no nome da unidade da primeira linha do grid da lista de serviço x ciclo
    //verificar se na aba histórico pois 2 registros, pois a unidade e o serviço adicionados são iguais a unidade e serviço que já haviam sido adicionados no ciclo de 'retirada'
    //verificar se as informações (ciclo, padrão de ciclo, mês inicial e Nº do ciclo) da primeiro linha correspondem as informações do registro que já havia no ciclo de 'retirada'
    //verificar se as informações (ciclo, padrão de ciclo, mês inicial e Nº do ciclo) da segunda linhas correspondem as informações do serviço x ciclo adicionado no início do teste
    //clicar no botão voltar, clicar no check-box da segunda linha do grid de serviço x ciclo, que corresponde ao registro adicionado no início do teste
    //clicar no botão excluir, clicar em sim, clicar no nome da unidade da primeira linha
    //verificar se após a exclusão do segundo serviço x ciclo o histórico do primeiro passa a ter apenas 1 registro
    @Test
    public void doisRegistrosMesmaUnidadeServico() {
        servicoXCicloPage = new ServicoXCicloPage();
        servicoXCicloFlows = new ServicoXCicloFlows();
        loginFlows = new LoginFlows();

        loginFlows.efetuarLogin();
        servicoXCicloFlows.navegateTelaServicoXCiclo();
        servicoXCicloPage.preencherFiltroCicloRetirada();
        servicoXCicloPage.addSegundoServicoXCiclo();
        servicoXCicloPage.verificarSegundoServicoXCiclo();
        servicoXCicloPage.verificarDoisHistoricos();
        servicoXCicloPage.excluirSegundoServicoXCiclo();
    }


    //acessar a tela 'Serviço x Ciclo'
    //clicar no campo ciclo, selecionar o ciclo de 'retirada', clicar no botão 'aplicar filtro'
    //clicar no botão adicionar, verificar se os campos (unidade, padrão de ciclo e mês inicial) estão habilitados e se por padrão os campos (serviço e Nº de ciclo) estão desabilitados
    //selecionar uma unidade e verificar se o campo serviço passa a estar habilitado
    //selecionar um mês inicial e verificar se o campo Nº do ciclo passa a estar habilitado
    @Test
    public void camposHabilitadosFormAddServXCiclo() {
        servicoXCicloPage = new ServicoXCicloPage();
        servicoXCicloFlows = new ServicoXCicloFlows();
        loginFlows = new LoginFlows();

        loginFlows.efetuarLogin();
        servicoXCicloFlows.navegateTelaServicoXCiclo();
        servicoXCicloPage.preencherFiltroCicloRetirada();
        servicoXCicloPage.camposHabilitadosAddServXCiclo();
    }


    //acessar a tela 'Serviço x Ciclo'
    //clicar no botão aplicar filtro e verificar a mensagem campo obrigatório no campo 'ciclo'
    //recarregar a página, clicar no campo ciclo, selecionar o ciclo de 'retirada', clicar no botão 'aplicar filtro'
    //clicar no botão adicionar, clicar em salvar, verificar a mensagem de campo obrigatório nos campos: unidade, serviço, padrão de ciclo, mês inicial e Nº do ciclo
    //clicar no botão cancelar
    @Test
    public void camposObrigatorios() {
        servicoXCicloPage = new ServicoXCicloPage();
        servicoXCicloFlows = new ServicoXCicloFlows();
        loginFlows = new LoginFlows();

        loginFlows.efetuarLogin();
        servicoXCicloFlows.navegateTelaServicoXCiclo();
        servicoXCicloPage.campoObrigatorioCiclo();
        servicoXCicloPage.refresh();
        servicoXCicloPage.preencherFiltroCicloRetirada();
        servicoXCicloPage.camposObrigatoriosAddServXCiclo();
    }


    //acessar a tela 'Serviço x Ciclo'
    //clicar no campo ciclo, selecionar o ciclo de 'deposito', clicar no botão 'aplicar filtro'
    //adicionar um serviço x ciclo com unidade '0004 - FARMACIA BC 121', serviço '00002 - JANTA', padrão de ciclo '00002 - COMPRAS'
    //mês inicial '01/2030 - TER' e Nº do ciclo '3'
    //preencher o formulário para adicionar um novo serviço x ciclo com as mesmas informações, clicar em salvar
    //verificar a mensagem exibida na tela informando que o mês inicial já foi cadastrado para o ciclo
    //clicar em ok, clicar em cancelar, clicar no check-box do serviço x ciclo que foi adicionado com sucesso início do teste
    //clicar em excluir, verificar a mensagem exibida na tela, clicar em sim e verificar a mensagem de excluído com sucesso exibida no canto da tela
    @Test
    public void tentarAdicionarRegistroJaCadastrado() {
        servicoXCicloPage = new ServicoXCicloPage();
        servicoXCicloFlows = new ServicoXCicloFlows();
        loginFlows = new LoginFlows();

        loginFlows.efetuarLogin();
        servicoXCicloFlows.navegateTelaServicoXCiclo();
        servicoXCicloPage.preencherFiltroCicloDeposito();
        servicoXCicloPage.tentarAdicionarRegistroJaCadastrado();
    }


    //acessar a tela 'Serviço x Ciclo'
    //clicar no campo ciclo, selecionar o ciclo de 'retirada', clicar no botão 'aplicar filtro'
    //adicionar um serviço x ciclo com as informações: unidade '0002 - DEPOSITO JABAQUARA', serviço '00001 - RETIRADAS', padrão de ciclo '00001 - VENDAS'
    //mês inicial '06/2033 - QUA' e Nº do ciclo '4'
    //verificar se a quantidade de serviço x ciclo adicionado para o ciclo 'retirada' é igual a 2
    //verificar se a unidade do primeiro registro é igual a unidade do segundo registro
    //verificar se apenas das unidades serem as mesmas, os serviços são diferente. Dessa forma o histórico de cada serviço x ciclo, deve tem apenas 1 registro
    //clicar na unidade do primeiro registro e verificar se possuí apenas 1 histórico, clicar em voltar
    //clicar na unidade do segunda registro e verificar se possuí apenas 1 histórico, clicar em voltar
    //clicar no check-box do segundo serviço x ciclo, que foi adicionado durante o teste, clicar em excluir, clicar em sim
    //clicar no nome da unidade do primeiro registro e verificar se o mesmo possuí apenas 1 histórico
    @Test
    public void historicoMesmaUnidadeSevDiferentes() {
        servicoXCicloPage = new ServicoXCicloPage();
        servicoXCicloFlows = new ServicoXCicloFlows();
        loginFlows = new LoginFlows();

        loginFlows.efetuarLogin();
        servicoXCicloFlows.navegateTelaServicoXCiclo();
        servicoXCicloPage.preencherFiltroCicloRetirada();
        servicoXCicloPage.adicionarServicoPalestraJabaquara();
        servicoXCicloPage.verificarSegundoRegistroComServDiferente();
        servicoXCicloPage.excluirSegundoServicoXCiclo();
    }


    //acessar a tela 'Serviço x Ciclo'
    //clicar no campo ciclo, selecionar o ciclo de 'produção', clicar no botão 'aplicar filtro'
    //pegar a data de processamento da unidade logada, que é apresentada no canto superior esquerdo da tela
    //formatar a data para que a mesma sempre inicie com o dia 01, clicar no botão adicionar
    //caso o mês da data de processamento seja Janeiro, o mês inicial a ser selecionado será Janeiro do ano anterior ao apresentado na data de processamento
    //caso seja um mês diferente de Janeiro o mês selecionado será o mês anterior ao apresentado na data de processamento, mantendo o ano apresentado na data
    //após selecionar o mês inicial será verificada a mensagem exibida na tela informando que o mês inicial não pode ser menor que a data de processamento da unidade
    //clicar em ok, verificar se caso selecionar um mês inicial inválido, o campo mês inicial fica vazio
    //selecionar o mês e ano iguais aos apresentados na data de processamento da unidade e verificar se os mesmos são apresentados no campo mês inicial
    @Test
    public void tentarAddMesInicialMenorQueDataProcessamento() {
        servicoXCicloPage = new ServicoXCicloPage();
        servicoXCicloFlows = new ServicoXCicloFlows();
        loginFlows = new LoginFlows();

        loginFlows.efetuarLogin();
        servicoXCicloFlows.navegateTelaServicoXCiclo();
        servicoXCicloPage.preencherFiltroCicloProducao();
        servicoXCicloPage.validarDataProcessamento();
    }



}
