package com.javaseleniumtemplate.tests;

import com.javaseleniumtemplate.bases.TestBase;
import com.javaseleniumtemplate.flows.LoginFlows;
import com.javaseleniumtemplate.flows.ServicoXDietaPadraoFlows;
import com.javaseleniumtemplate.pages.ServicoXDietaPadraoPage;
import org.testng.annotations.Test;

public class ServicoXDietaPadraoTests extends TestBase {

    ServicoXDietaPadraoPage servicoXDietaPadraoPage;
    ServicoXDietaPadraoFlows servicoXDietaPadraoFlows;
    LoginFlows loginFlows;


    //acessar a tela 'Serviço x Dieta Padrão'
    //preencher o filtro inicial selecionando a unidade Deposito Jabaquara e o serviço Jantar
    //clicar no botão 'aplicar filtro', clicar no botão adicionar, clicar no campo nome e selecionar a dieta Low Carb
    //clicar no botão salvar, verificar a mensagem de salvo com sucesso exibida no canto superior direito da tela
    //no filtro procurar pelo código 0003, verificar no inline se o código e nome da dieta padrão foram salvos corretamente
    //clicar no nome da dieta padrão e verificar se o código e nome também foram salvos corretamente
    //clicar no botão voltar, no filtro procurar pelo código 0003, clicar no check-box da dieta padrão, clicar no botão excluir
    //verificar a mensagem exibida na tela, clicar em sim, verificar a mensagem excluído com sucesso exibida no canto da tela
    //verificar se no grid da lista de dietas é apresentada a mensagem 'Nenhum registro foi encontrado'
    @Test
    public void adicionarExcluirDietaPadrao() {
        servicoXDietaPadraoPage = new ServicoXDietaPadraoPage();
        servicoXDietaPadraoFlows = new ServicoXDietaPadraoFlows();
        loginFlows = new LoginFlows();

        loginFlows.efetuarLogin();
        servicoXDietaPadraoFlows.navegateTelaServicoXDietaPadrao();
        servicoXDietaPadraoPage.preencherFiltroInicial();
        servicoXDietaPadraoPage.adicionarDieta();
        servicoXDietaPadraoPage.verificarDietaPadraoAdd();
        servicoXDietaPadraoPage.excluirDietaPadrao();
    }


    //acessar a tela 'Serviço x Dieta Padrão'
    //preencher o filtro inicial selecionando a unidade Deposito Jabaquara e o serviço Jantar
    //clicar no botão 'aplicar filtro', no filtro procurar pelo código 0002, clicar no nome da dieta encontrada, clicar na aba clientes
    //clicar no botão adicionar, clicar no campo 'razão social' e selecionar o cliente AGUIA FARMA FARMACEUTICA LTDA, preencher o preço da dieta com 35,5
    //clicar no botão salvar, verificar a mensagem de salvo com sucesso exibida no canto superior direito da tela
    //clicar no botão adicionar, selecionar um segundo cliente BIG FARMA LTDA, preencher o preço da dieta com 40
    //clicar em salvar e verificar a mensagem de salvo com sucesso exibida no canto da tela
    //verificar no grid da lista de clientes se as informações (inscrição, razão social e preço da dieta) dos 2 clientes AGUIA FARMA FARMACEUTICA LTDA e BIG FARMA LTDA foram salvos corretamente
    //clicar no check-box para selecionar o 2 clientes da lista, clicar em excluir, verificar a mensagem exibida na tela
    //clicar em sim, verificar a mensagem de excluído com sucesso exibida no canto superior direito da tela
    //verificar se no grid da lista de cliente é apresentada a mensagem 'Não há registros', clicar em voltar
    @Test
    public void addClientesExclTodosDeUmaVez() {
        servicoXDietaPadraoPage = new ServicoXDietaPadraoPage();
        servicoXDietaPadraoFlows = new ServicoXDietaPadraoFlows();
        loginFlows = new LoginFlows();

        loginFlows.efetuarLogin();
        servicoXDietaPadraoFlows.navegateTelaServicoXDietaPadrao();
        servicoXDietaPadraoPage.preencherFiltroInicial();
        servicoXDietaPadraoPage.adicionarClientes();
        servicoXDietaPadraoPage.verificarClientesAdicionados();
        servicoXDietaPadraoPage.excluirTodosClientes();
    }


    //acessar a tela 'Serviço x Dieta Padrão'
    //preencher o filtro inicial selecionando a unidade Deposito Jabaquara e o serviço Jantar
    //clicar no botão 'aplicar filtro', no filtro procurar pelo código 0001, clicar no nome da dieta padrão encontrada
    //clicar na aba clientes, clicar no campo 'preço da dieta' e alterar o valor para 33,50
    //verificar a mensagem de salvo com sucesso exibida no canto da tela, e verificar também se o valor alterado foi salvo corretamente
    //clicar no campo 'preço da dieta' e alterar o valor para 40, valor este que estava no início do teste
    //verificar se o valor alterado foi salvo corretamente
    @Test
    public void alterarPrecoDaDieta() {
        servicoXDietaPadraoPage = new ServicoXDietaPadraoPage();
        servicoXDietaPadraoFlows = new ServicoXDietaPadraoFlows();
        loginFlows = new LoginFlows();

        loginFlows.efetuarLogin();
        servicoXDietaPadraoFlows.navegateTelaServicoXDietaPadrao();
        servicoXDietaPadraoPage.preencherFiltroInicial();
        servicoXDietaPadraoPage.alterarPrecoDieta();
    }


    //acessar a tela 'Serviço x Dieta Padrão'
    //preencher o filtro inicial selecionando a unidade Deposito Jabaquara e o serviço Jantar
    //clicar no botão 'aplicar filtro', no filtro procurar pelo código 0001, clicar no check-box da dieta padrão encontrada
    //clicar em excluir, verificar mensagem exibida na tela, clicar em sim, verificar a mensagem exibida na tela informando que a exclusão não é permitida pois possuí registros filhos
    //clicar no botão ok e no check-box da dieta padrão que havia sido selecionada
    @Test
    public void tentarExcluirDietaPadraoRegFilho() {
        servicoXDietaPadraoPage = new ServicoXDietaPadraoPage();
        servicoXDietaPadraoFlows = new ServicoXDietaPadraoFlows();
        loginFlows = new LoginFlows();

        loginFlows.efetuarLogin();
        servicoXDietaPadraoFlows.navegateTelaServicoXDietaPadrao();
        servicoXDietaPadraoPage.preencherFiltroInicial();
        servicoXDietaPadraoPage.tentarExcluirDietaPadrao();
    }


    //acessar a tela 'Serviço x Dieta Padrão'
    //preencher o filtro inicial selecionando a unidade Deposito Jabaquara e o serviço Jantar
    //clicar no botão 'aplicar filtro', no filtro procurar pelo código 0002, clicar no nome da dieta encontrada, clicar na aba clientes
    //clicar no botão adicionar, clicar no campo 'razão social' e selecionar o cliente AGUIA FARMA FARMACEUTICA LTDA, preencher o preço da dieta com 35,5
    //clicar no botão salvar, verificar a mensagem de salvo com sucesso exibida no canto superior direito da tela
    //clicar no botão adicionar, selecionar um segundo cliente BIG FARMA LTDA, preencher o preço da dieta com 40
    //clicar em salvar e verificar a mensagem de salvo com sucesso exibida no canto da tela
    //clicar no check-box do primeiro cliente, clicar em excluir, verificar a mensagem exibida na tela, clicar em sim, verificar a mensagem de excluído com sucesso exibida no canto da tela
    //clicar no check-box do primeiro cliente da lista de cliente, clicar em excluir, verificar a mensagem exibida, clicar em sim e verificar a mensagem de excluído com sucesso
    //verificar se no grid da lista de cliente é apresentada a mensagem 'Não há registros'
    @Test
    public void addClientesExclUmDeCadaVez() {
        servicoXDietaPadraoPage = new ServicoXDietaPadraoPage();
        servicoXDietaPadraoFlows = new ServicoXDietaPadraoFlows();
        loginFlows = new LoginFlows();

        loginFlows.efetuarLogin();
        servicoXDietaPadraoFlows.navegateTelaServicoXDietaPadrao();
        servicoXDietaPadraoPage.preencherFiltroInicial();
        servicoXDietaPadraoPage.adicionarClientes();
        servicoXDietaPadraoPage.excluirClientes();
    }


    //acessar a tela 'Serviço x Dieta Padrão'
    //clicar no botão do campo unidade, clicar em aplicar filtro e verificar a mensagem de campo obrigatório nos campos: unidade e serviço
    @Test
    public void camposObrigatoriosFiltroInicial() {
        servicoXDietaPadraoPage = new ServicoXDietaPadraoPage();
        servicoXDietaPadraoFlows = new ServicoXDietaPadraoFlows();
        loginFlows = new LoginFlows();

        loginFlows.efetuarLogin();
        servicoXDietaPadraoFlows.navegateTelaServicoXDietaPadrao();
        servicoXDietaPadraoPage.campoObrigatorioFiltroInicial();
    }


    //acessar a tela 'Serviço x Dieta Padrão'
    //preencher o filtro inicial selecionando a unidade Deposito Jabaquara e o serviço Jantar
    //clicar no botão 'aplicar filtro', clicar no botão adicionar, clicar em salvar, verificar a mensagem de campo obrigatório no campo nome
    //clicar em cancelar
    @Test
    public void campoObrigatorioAddDietaPadrao() {
        servicoXDietaPadraoPage = new ServicoXDietaPadraoPage();
        servicoXDietaPadraoFlows = new ServicoXDietaPadraoFlows();
        loginFlows = new LoginFlows();

        loginFlows.efetuarLogin();
        servicoXDietaPadraoFlows.navegateTelaServicoXDietaPadrao();
        servicoXDietaPadraoPage.preencherFiltroInicial();
        servicoXDietaPadraoPage.campoObrigatorioAddDietaPadrao();
    }

    //acessar a tela 'Serviço x Dieta Padrão'
    //preencher o filtro inicial selecionando a unidade Deposito Jabaquara e o serviço Jantar
    //clicar no botão 'aplicar filtro', no filtro procurar pelo código 0002, clicar no nome da dieta padrão encontrada
    //clicar na aba clientes, clicar no botão adicionar, clicar em salvar, verificar a mensagem de campo obrigatório nos campos: razão social e preço da dieta
    //clicar em cancelar, clicar em voltar
    @Test
    public void camposObrigatoriosAddCliente() {
        servicoXDietaPadraoPage = new ServicoXDietaPadraoPage();
        servicoXDietaPadraoFlows = new ServicoXDietaPadraoFlows();
        loginFlows = new LoginFlows();

        loginFlows.efetuarLogin();
        servicoXDietaPadraoFlows.navegateTelaServicoXDietaPadrao();
        servicoXDietaPadraoPage.preencherFiltroInicial();;
        servicoXDietaPadraoPage.campoObrigatorioAddCliente();
    }


    //acessar a tela 'Serviço x Dieta Padrão'
    //preencher o filtro inicial selecionando a unidade Deposito Jabaquara e o serviço Jantar
    //clicar no botão 'aplicar filtro', clicar no botão adicionar, clicar no campo nome e selecionar a dieta Fitness
    //clicar em salvar, verificar a mensagem exibida na tela informando que é impossível da adicionar pois o registro já existe
    //clicar em ok, clicar em cancelar
    @Test
    public void tentarAddDietaJaExistente() {
        servicoXDietaPadraoPage = new ServicoXDietaPadraoPage();
        servicoXDietaPadraoFlows = new ServicoXDietaPadraoFlows();
        loginFlows = new LoginFlows();

        loginFlows.efetuarLogin();
        servicoXDietaPadraoFlows.navegateTelaServicoXDietaPadrao();
        servicoXDietaPadraoPage.preencherFiltroInicial();
        servicoXDietaPadraoPage.dietaJaExiste();
    }


    //acessar a tela 'Serviço x Dieta Padrão'
    //preencher o filtro inicial selecionando a unidade Deposito Jabaquara e o serviço Jantar
    //clicar no botão 'aplicar filtro', no filtro procurar pelo código 0002, clicar no nome da dieta padrão encontrada, clicar na aba clientes
    //clicar no botão adicionar, clicar no campo 'razão social' e selecionar o cliente AGUIA FARMA FARMACEUTICA LTDA, preencher o preço da dieta com 35,5
    //clicar no botão salvar, verificar a mensagem de salvo com sucesso exibida no canto superior direito da tela
    //clicar em adicionar, selecionar novamente o cliente AGUIA FARMA FARMACEUTICA LTDA, preencher o preço da dieta, clicar em salvar
    //verificar a mensagem exibida na tela informando que é impossível adicionar pois o registro já existe, clicar em ok, clicar em cancelar
    //selecionar o check-box do cliente que havia sido adicionado com sucesso, clicar em excluir, verificar a mensagem exibida na tela, clicar em sim
    //verificar a mensagem excluído com sucesso exibida no canto da tela
    @Test
    public void tentarAddClienteJaExistente() {
        servicoXDietaPadraoPage = new ServicoXDietaPadraoPage();
        servicoXDietaPadraoFlows = new ServicoXDietaPadraoFlows();
        loginFlows = new LoginFlows();

        loginFlows.efetuarLogin();
        servicoXDietaPadraoFlows.navegateTelaServicoXDietaPadrao();
        servicoXDietaPadraoPage.preencherFiltroInicial();
        servicoXDietaPadraoPage.clienteJaExiste();
    }

}
