package com.javaseleniumtemplate.tests;

import com.javaseleniumtemplate.bases.TestBase;
import com.javaseleniumtemplate.flows.LoginFlows;
import com.javaseleniumtemplate.flows.UnidadeAdicionalProdutoFlows;
import com.javaseleniumtemplate.pages.UnidadeAdicionalProdutoPage;
import org.testng.annotations.Test;

public class UnidadeAdicionalProdutoTests extends TestBase {

    UnidadeAdicionalProdutoPage unidadeAdicionalProdutoPage;
    UnidadeAdicionalProdutoFlows unidadeAdicionalProdutoFlows;
    LoginFlows loginFlows;


    //acessar a tela 'Unidade Adicional do Produto'
    //clicar no botão adicionar, clicar no botão do campo produto, procurar pelo produto IODETO DE ARSENIO e selecionar o mesmo
    //clicar no botão do campo unidade secundária, procurar pela unidade LATA e selecionar a mesma
    //clicar na primeira 'opção de relação', preencher o campo 'relação (valor de x)' com o valor 0,5 e clicar em salvar
    //verificar a mensagem de salvo com sucesso exibida no canto superior direito da tela
    //no filtro da tela inicial procurar pelo código 101110201400, verificar se as informações(código, produto e unidade) foram salvas corretamente
    //clicar no nome do produto, verificar a descrição da conversão adicionada, clicar na descrição, clicar em editar
    //verificar se as informações(código do produto, nome do produto, unidade principal, unidade secundária e 'relação (valor de x)') foram salvas corretamente
    //verificar se a primeira 'opção da relação' está selecionada e qual é a descrição da mesma
    //clicar em cancelar, clicar em voltar
    //no filtro da tela inicial procurar pelo código 101110201400, clicar no nome do produto, clicar no botão excluir
    //verificar a mensagem exibida na tela, clicar em sim, verificar a mensagem sucesso exibida na tela, clicar em ok
    //verificar se no grid da lista de produtos é apresentada a informação de nenhum registro foi encontrado
    @Test
    public void adicionarExcluirUnidadeAdicionalProd() {
        unidadeAdicionalProdutoPage = new UnidadeAdicionalProdutoPage();
        unidadeAdicionalProdutoFlows = new UnidadeAdicionalProdutoFlows();
        loginFlows = new LoginFlows();

        loginFlows.efetuarLogin();
        unidadeAdicionalProdutoFlows.navegateUnidadeAdicionalProduto();
        unidadeAdicionalProdutoPage.adicionarUnidadeAdicional();
        unidadeAdicionalProdutoPage.verificarUnidadeAdicionalProdTelaInicial();
        unidadeAdicionalProdutoPage.verificarUnidadeAdicionalProdTelaConversao();
        unidadeAdicionalProdutoPage.excluirUnidadeAdicionalAdd();
    }


    //acessar a tela 'Unidade Adicional do Produto'
    //no filtro da tela inicial procurar pelo código 101210100201, clicar no nome do produto encontrado, clicar no botão editar
    //clicar na primeira 'opção da relação' e verificar qual o valor apresentado no campo 'relação (valor de x)' quando está 'opção da relação' está selecionada
    //clicar na segunda 'opção da relação' e verificar qual o valor apresentado no campo 'relação (valor de x)' quando está 'opção da relação' está selecionada
    //preencher o campo 'relação (valor de x)' com o valor 5, clicar na primeira 'opção da relação' e verificar com fica o valor da relação para está 'opção da relação'
    //clicar em salvar, verificar a mensagem de editado com sucesso exibida no canto da tela, e verificar como fica a descrição da conversão após a edição
    //clicar na descrição da conversão, clicar em editar, clicar na primeira 'opção da relação' e verificar a descrição da mesma e qual o valor da 'relação (valor de x)'
    //clicar na segunda 'opção da relação', verificar a descrição da mesma e qual o valor apresentado no campo 'relação (valor de x)'
    //clicar na primeira 'opção da relação' e preencher o campo 'relação (valor de x)' com o valor 0,5 valor este que estava no início do teste
    //clicar em salvar, verificar como fica a descrição da conversão e clicar em voltar
    @Test
    public void editarConversao() {
        unidadeAdicionalProdutoPage = new UnidadeAdicionalProdutoPage();
        unidadeAdicionalProdutoFlows = new UnidadeAdicionalProdutoFlows();
        loginFlows = new LoginFlows();

        loginFlows.efetuarLogin();
        unidadeAdicionalProdutoFlows.navegateUnidadeAdicionalProduto();
        unidadeAdicionalProdutoPage.editarConversao();
        unidadeAdicionalProdutoPage.reeditarConversao();
    }


    //acessar a tela 'Unidade Adicional do Produto'
    //no filtro da tela inicial procurar pelo código 101110201500, clicar no nome do produto encontrado, clicar no botão adicionar
    //clicar no botão do campo unidade secundária, procurar pela unidade COPO e selecionar a mesma, preencher o campo 'relação (valor de x)' com o valor 4
    //clicar no botão salvar, verificar a mensagem de salvo com sucesso exibida no canto da tela
    //verificar se a unidade possui duas conversões, verificar a descrição da nova conversão adicionada, clicar na mesma, clicar no botão editar
    //clicar na primeira 'opção da relação', verificar a descrição da mesma e o valor apresentado no campo 'relação (valor de x)'
    //clicar na segunda 'opção da relação', verificar a descrição da mesma e o valor apresentado no campo 'relação (valor de x)'
    //clicar no botão cancelar, clicar na segunda conversão, clicar em excluir, verificar a mensagem exibida na tela, clicar em sim
    //verificar a mensagem de removido com sucesso exibida na tela, clicar em ok
    //no filtro da tela inicial procurar pelo código 101110201500, clicar no nome do produto encontrado e verificar se o mesmo possui apenas uma conversão
    @Test
    public void addSegundaConversaoIniPelaTelaConversaoUni() {
        unidadeAdicionalProdutoPage = new UnidadeAdicionalProdutoPage();
        unidadeAdicionalProdutoFlows = new UnidadeAdicionalProdutoFlows();
        loginFlows = new LoginFlows();

        loginFlows.efetuarLogin();
        unidadeAdicionalProdutoFlows.navegateUnidadeAdicionalProduto();
        unidadeAdicionalProdutoPage.adicionarSegundaConversaoPelaTelaDeConversao();
        unidadeAdicionalProdutoPage.verificarSegundaConversaoAdicionada();
        unidadeAdicionalProdutoPage.excluirSegundaConversao();
    }


    //acessar a tela 'Unidade Adicional do Produto'
    //clicar no botão adicionar, clicar no botão do campo produto, procurar pelo produto IODETO DE ARSENIO e selecionar o mesmo
    //clicar no botão do campo unidade secundária, procurar pela unidade LATA e selecionar a mesma
    //clicar na primeira 'opção de relação', preencher o campo 'relação (valor de x)' com o valor 0,5 e clicar em salvar, verificar a mensagem de salvo com sucesso exibida no canto da tela
    //no filtro da tela inicial procurar pelo código 101110201400, clicar no nome do produto, clicar em voltar
    //com o produto já selecionado, clicar em excluir, verificar a mensagem exibida na tela pergunta de deseja excluir as conversões do produto, informando o nome do produto
    //clicar em sim, verificar a mensagem de removido com sucesso exibida na tela, clicar em ok
    //no filtro da tela inicial procurar pelo código 101110201400, verificar se no grid da lista de produtos é informado que nenhum registro foi encontrado
    @Test
    public void excluirProdutoPelaTelaIni() {
        unidadeAdicionalProdutoPage = new UnidadeAdicionalProdutoPage();
        unidadeAdicionalProdutoFlows = new UnidadeAdicionalProdutoFlows();
        loginFlows = new LoginFlows();

        loginFlows.efetuarLogin();
        unidadeAdicionalProdutoFlows.navegateUnidadeAdicionalProduto();
        unidadeAdicionalProdutoPage.adicionarUnidadeAdicional();
        unidadeAdicionalProdutoPage.excluirUnidadeAdicionalPelaTelaIni();
    }


    //acessar a tela 'Unidade Adicional do Produto'
    //no filtro da tela inicial procurar pelo código 101110201500, clicar no nome da unidade encontrada
    //pegar o valor da descrição da conversão e armazenar em uma variável para comparar as após tentar adicionar uma conversão que já existia, a mesma não teve seu valor alterado
    //clicar no botão adicionar, clicar no botão do campo produto, procurar pelo produto IODETO DE CALCIO e selecionar o mesmo
    //clicar no botão do campo unidade secundária, procurar pela unidade BALDE, preencher o campo 'relação (valor de x)' com o valor 2,5
    //clicar em salvar, verificar a mensagem exibida na tela informando que o registro já existe, clicar em ok, clicar em cancelar
    //no filtro da tela inicial procurar pelo código 101110201500, clicar no nome da unidade encontrada, comparar o valor da descrição atual com o valor que foi armazenado em uma variável no início do teste
    //verificar se a unidade continua tendo apenas uma conversão
    //clicar no botão adicionar, clicar no botão do campo produto, procurar pelo produto IODETO DE CALCIO e selecionar o mesmo
    //clicar no botão do campo unidade secundária, procurar pela unidade BALDE, preencher o campo 'relação (valor de x)' com o valor 2,5
    //clicar em salvar, verificar a mensagem exibida na tela informando que o registro já existe, clicar em ok, clicar em cancelar
    //verificar se a unidade continua tendo apenas uma conversão, comparar o valor da descrição atual com o valor que foi armazenado em uma variável no início do teste
    @Test
    public void tentarAdicionarConversaoJaExistente() {
        unidadeAdicionalProdutoPage = new UnidadeAdicionalProdutoPage();
        unidadeAdicionalProdutoFlows = new UnidadeAdicionalProdutoFlows();
        loginFlows = new LoginFlows();

        loginFlows.efetuarLogin();
        unidadeAdicionalProdutoFlows.navegateUnidadeAdicionalProduto();
        unidadeAdicionalProdutoPage.tentarAdicionarConversaoJaExistente();
    }



    //acessar a tela 'Unidade Adicional do Produto'
    //clicar no botão adicionar, clicar no botão do campo produto, procurar pelo produto IODETO DE CALCIO e selecionar o mesmo
    //clicar no botão do campo unidade secundária, procurar pela unidade COPO e selecionar a mesma
    //preencher a 'relação (valor de x)' com o valor 8, clicar em salvar, verificar a mensagem de salvo com sucesso exibida no canto da tela
    //no filtro da tela inicial procurar pelo código 101110201500, clicar no nome do produto encontrado, verificar se a unidade possui duas conversões
    //verificar a descrição da nova conversão adicionada, clicar na segunda conversão, clicar em excluir, verificar a mensagem exibida na tela, clicar em sim
    //verificar a mensagem de removido com sucesso exibida na tela, clicar em ok
    //no filtro da tela inicial procurar pelo código 101110201500, clicar no nome do produto encontrado e verificar se o mesmo possui apenas uma conversão
    @Test
    public void addSegundaConversaoIniciandoPelaTelaIni() {
        unidadeAdicionalProdutoPage = new UnidadeAdicionalProdutoPage();
        unidadeAdicionalProdutoFlows = new UnidadeAdicionalProdutoFlows();
        loginFlows = new LoginFlows();

        loginFlows.efetuarLogin();
        unidadeAdicionalProdutoFlows.navegateUnidadeAdicionalProduto();
        unidadeAdicionalProdutoPage.adicionarSegundaConversaPelaTelaInicial();
        unidadeAdicionalProdutoPage.excluirSegundaConversao();
    }


    //acessar a tela 'Unidade Adicional do Produto'
    //clicar no botão adicionar, clicar no botão do campo produto, procurar pelo produto IODETO DE ARSENIO e selecionar o mesmo
    //clicar no botão do campo unidade secundária, procurar pela unidade COPO e selecionar a mesma
    //preencher o campo 'relação (valor de x)' com o valor 0, clicar em salvar e verificar a mensagem exibida na tela informando que o valor deve ser maior que zero
    //clicar em ok, clicar em cancelar, no filtro da tela inicial procurar pelo código 101150200100, clicar no nome do produto encontrado
    //clicar na conversão, clicar em editar, alterar o valor do campo 'relação (valor de x)' para o valor 0, clicar em salvar
    //verificar a mensagem exibida na tela informando que o valor deve ser maior que zero
    @Test
    public void valorDeXDeveSerMaiorQueZero() {
        unidadeAdicionalProdutoPage = new UnidadeAdicionalProdutoPage();
        unidadeAdicionalProdutoFlows = new UnidadeAdicionalProdutoFlows();
        loginFlows = new LoginFlows();

        loginFlows.efetuarLogin();
        unidadeAdicionalProdutoFlows.navegateUnidadeAdicionalProduto();
        unidadeAdicionalProdutoPage.mensagemXDeveSerMaiorQueZero();
    }


    //acessar a tela 'Unidade Adicional do Produto'
    //clicar no botão adicionar, clicar em salvar
    //verificar a mensagem de campo obrigatório nos campos: produto, unidade secundária e 'relação (valor de x)'
    @Test
    public void camposObrigatorios() {
        unidadeAdicionalProdutoPage = new UnidadeAdicionalProdutoPage();
        unidadeAdicionalProdutoFlows = new UnidadeAdicionalProdutoFlows();
        loginFlows = new LoginFlows();

        loginFlows.efetuarLogin();
        unidadeAdicionalProdutoFlows.navegateUnidadeAdicionalProduto();
        unidadeAdicionalProdutoPage.camposObrigatorios();
    }


}